// ESOC BAJA CALIFORNIA
// designed by Garja

int PlayerNum=2;
int numPlayer=3;

include "mercenaries.xs";
include "ypAsianInclude.xs";
include "ypKOTHInclude.xs";

// Main entry point for random map script
void main(void)
{
		
	// Text
	// These status text lines are used to manually animate the map generation progress bar
	rmSetStatusText("",0.01); 
	
	// ************************************** GENERAL FEATURES *****************************************
	
	
	// Picks the map size
	int	playerTiles = 9000;
	int size=2.0*sqrt(PlayerNum*playerTiles); //2.1
	int longside = 1.5*size;
	rmEchoInfo("Map size="+size+"m x "+size+"m");
	rmSetMapSize(longside, size);
	
	// Make the corners.
	rmSetWorldCircleConstraint(false);
	
	// Picks a default water height
	rmSetSeaLevel(0.0);	// this is height of river surface compared to surrounding land. River depth is in the river XML.

//	rmSetMapElevationParameters(cElevTurbulence, 0.4, 4, 0.4, 4.0);
//	rmSetMapElevationParameters(cElevTurbulence, 0.5, 3, 0.5, 4.0);  // type, frequency, octaves, persistence, variation 
//	rmSetMapElevationHeightBlend(0.3); //
	
	// Picks default terrain and water
	rmSetSeaType("california coast"); // california coast
	rmSetBaseTerrainMix("california desert");
	rmTerrainInitialize("california\desert5_cal", 4.0);
//	rmTerrainInitialize("water"); // 
	rmSetMapType("california"); 
	rmSetMapType("desert");
//	rmSetMapType("grass");
	rmSetMapType("water");
	rmSetLightingSet("sonora");
	rmSetWindMagnitude(2.0);
	
	// Choose Mercs
	chooseMercs();
	
	// Text
	rmSetStatusText("",0.10);
	
	// Set up Natives
	int subCiv0 = -1;
	subCiv0 = rmGetCivID("Apache");
	rmSetSubCiv(0, "Apache");
	int subCiv1 = -1;
	subCiv1 = rmGetCivID("Navajo");
	rmSetSubCiv(1, "Navajo");
	int subCiv2 = -1;
	subCiv2 = rmGetCivID("Maya");
	rmSetSubCiv(2, "Maya");

	//Define some classes. These are used later for constraints.
	int classPlayer = rmDefineClass("player");
	rmDefineClass("classHill");
	int classPatch = rmDefineClass("patch");
	int classPatch2 = rmDefineClass("patch2");
	int classPatch3 = rmDefineClass("patch3");
	int classPond = rmDefineClass("pond");
	int classRocks = rmDefineClass("rocks");
	int classGrass = rmDefineClass("grass");
	rmDefineClass("starting settlement");
	rmDefineClass("startingUnit");
	int classForest = rmDefineClass("Forest");
	int importantItem = rmDefineClass("importantItem");
	int classNative = rmDefineClass("natives");
	int classCliff = rmDefineClass("Cliffs");
	int classGold = rmDefineClass("Gold");
	int classStartingResource = rmDefineClass("startingResource");
	
	// ******************************************************************************************
	
	// Text
	rmSetStatusText("",0.20);
	
	// ************************************* CONTRAINTS *****************************************
	// These are used to have objects and areas avoid each other
   
	// Cardinal Directions & Map placement
	int avoidEdge = rmCreatePieConstraint("Avoid Edge",0.5,0.5, rmXFractionToMeters(0.0),rmXFractionToMeters(0.47), rmDegreesToRadians(0),rmDegreesToRadians(360));
	int avoidEdgeMore = rmCreatePieConstraint("Avoid Edge More",0.5,0.5, rmXFractionToMeters(0.0),rmXFractionToMeters(0.38), rmDegreesToRadians(0),rmDegreesToRadians(360));
	int avoidCenter = rmCreatePieConstraint("Avoid Center",0.5,0.5,rmXFractionToMeters(0.26), rmXFractionToMeters(0.5), rmDegreesToRadians(0),rmDegreesToRadians(360));
	int stayCenter = rmCreatePieConstraint("Stay Center",0.50,0.50,rmXFractionToMeters(0.0), rmXFractionToMeters(0.28), rmDegreesToRadians(0),rmDegreesToRadians(360));
	int stayCenterMore = rmCreatePieConstraint("Stay Center more",0.5,0.5,rmXFractionToMeters(0.0), rmXFractionToMeters(0.26), rmDegreesToRadians(0),rmDegreesToRadians(360));
	int stayWestHalf = rmCreatePieConstraint("Stay West half",0.45,0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.50), rmDegreesToRadians(180),rmDegreesToRadians(360));
	int stayEastHalf = rmCreatePieConstraint("Stay East half",0.55,0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.50), rmDegreesToRadians(0),rmDegreesToRadians(180));
	
		
	// Resource avoidance
	int avoidForestFar=rmCreateClassDistanceConstraint("avoid forest far", rmClassID("Forest"), 26.0); //15.0
	int avoidForest=rmCreateClassDistanceConstraint("avoid forest", rmClassID("Forest"), 22.0); //15.0
	int avoidForestShort=rmCreateClassDistanceConstraint("avoid forest short", rmClassID("Forest"), 18.0); //15.0
	int avoidForestMin=rmCreateClassDistanceConstraint("avoid forest min", rmClassID("Forest"), 3.0);
	int avoidPronghornFar = rmCreateTypeDistanceConstraint("avoid pronghorn far", "pronghorn", 50.0);
	int avoidPronghorn = rmCreateTypeDistanceConstraint("avoid pronghorn", "pronghorn", 40.0);
	int avoidPronghornShort = rmCreateTypeDistanceConstraint("avoid pronghorn short", "pronghorn", 25.0);
	int avoidPronghornMin = rmCreateTypeDistanceConstraint("avoid pronghorn min", "pronghorn", 5.0);
	int avoidBighornFar = rmCreateTypeDistanceConstraint("avoid bighorn far", "bighornsheep", 52.0);
	int avoidBighorn = rmCreateTypeDistanceConstraint("avoid  bighorn", "bighornsheep", 48.0);
	int avoidBighornShort = rmCreateTypeDistanceConstraint("avoid  bighorn short", "bighornsheep", 30.0);
	int avoidBighornMin = rmCreateTypeDistanceConstraint("avoid bighorn min", "bighornsheep", 5.0);
	int avoidGoldTypeShort = rmCreateTypeDistanceConstraint("coin avoids coin short", "gold", 8.0);
	int avoidGoldTypeMed = rmCreateTypeDistanceConstraint("coin avoids coin med", "gold", 12.0);
	int avoidGoldType = rmCreateTypeDistanceConstraint("coin avoids coin", "gold", 46.0);
	int avoidGoldTypeFar = rmCreateTypeDistanceConstraint("coin avoids coin far", "gold", 58.0);
	int avoidGoldMin=rmCreateClassDistanceConstraint("min distance vs gold", rmClassID("Gold"), 20.0);
	int avoidGold = rmCreateClassDistanceConstraint ("gold avoid gold med", rmClassID("Gold"), 30.0);
	int avoidGoldFar = rmCreateClassDistanceConstraint ("gold avoid gold far", rmClassID("Gold"), 52.0); // 82
//	int avoidGoldVeryFar = rmCreateClassDistanceConstraint ("gold avoid gold very ", rmClassID("Gold"), 74.0);
	int avoidNuggetMin = rmCreateTypeDistanceConstraint("nugget avoid nugget min", "AbstractNugget", 10.0);
	int avoidNuggetShort = rmCreateTypeDistanceConstraint("nugget avoid nugget short", "AbstractNugget", 30.0);
	int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 34.0);
	int avoidNuggetFar = rmCreateTypeDistanceConstraint("nugget avoid nugget Far", "AbstractNugget", 54.0);
	int avoidTownCenterFar=rmCreateTypeDistanceConstraint("avoid Town Center Far", "townCenter", 65.0);
	int avoidTownCenter=rmCreateTypeDistanceConstraint("avoid Town Center", "townCenter", 52.0);
	int avoidTownCenterMed=rmCreateTypeDistanceConstraint("avoid Town Center med", "townCenter", 48.0);
	int avoidTownCenterShort=rmCreateTypeDistanceConstraint("avoid Town Center short", "townCenter", 24.0);
	int avoidTownCenterMin=rmCreateTypeDistanceConstraint("avoid Town Center min", "townCenter", 18.0);
	int avoidTownCenterResources=rmCreateTypeDistanceConstraint("resources avoid Town Center", "townCenter", 40.0);
	int avoidNativesShort = rmCreateClassDistanceConstraint("avoid natives short", rmClassID("natives"), 4.0);
	int avoidNatives = rmCreateClassDistanceConstraint("avoid natives", rmClassID("natives"), 10.0);
	int avoidNativesFar = rmCreateClassDistanceConstraint("avoid natives far", rmClassID("natives"), 15.0);
	int avoidStartingResources  = rmCreateClassDistanceConstraint("avoid starting resources", rmClassID("startingResource"), 8.0);
	int avoidStartingResourcesShort  = rmCreateClassDistanceConstraint("avoid starting resources short", rmClassID("startingResource"), 4.0);
	int avoidWhale=rmCreateTypeDistanceConstraint("avoid whale", "fish", 30.0);
	int avoidFish=rmCreateTypeDistanceConstraint("avoid fish", "fish", 15.0);
	int avoidSheep=rmCreateTypeDistanceConstraint("sheep avoids sheep", "sheep", 61.0);
	int avoidColonyShip=rmCreateTypeDistanceConstraint("avoid colony ship", "HomeCityWaterSpawnFlag", 30.0);
	int avoidColonyShipShort = rmCreateTypeDistanceConstraint("avoid colony ship short", "HomeCityWaterSpawnFlag", 16.0);

	// Avoid impassable land
	int avoidImpassableLand = rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 10.0);
	int avoidImpassableLandFar=rmCreateTerrainDistanceConstraint("avoid impassable land far", "Land", false, 22.0);
	int avoidImpassableLandShort = rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 5.0);
	int avoidImpassableLandMed=rmCreateTerrainDistanceConstraint("medium avoid impassable land", "Land", false, 14.0);
	int stayNearLand = rmCreateTerrainMaxDistanceConstraint("stay near land ", "Land", true, 5.0);
	int avoidLand = rmCreateTerrainDistanceConstraint("avoid land ", "Land", true, 10.0);
	int avoidLandFar = rmCreateTerrainDistanceConstraint("avoid land far ", "Land", true, 14.0);
	int avoidWater = rmCreateTerrainDistanceConstraint("avoid water ", "water", true, 22.0);
	int stayNearWater = rmCreateTerrainMaxDistanceConstraint("stay near water ", "water", true, 2.0);
	int stayInWater = rmCreateTerrainMaxDistanceConstraint("stay in water ", "water", true, 0.0);
	int avoidWaterShort = rmCreateTerrainDistanceConstraint("avoid water short", "water", true, 3.0);
	int avoidWaterFar = rmCreateTerrainDistanceConstraint("avoid water far", "water", true, 35.0);
	int avoidPatch = rmCreateClassDistanceConstraint("avoid patch", rmClassID("patch"), 30.0);
	int avoidPatch2 = rmCreateClassDistanceConstraint("avoid patch2", rmClassID("patch2"), 10.0);
	int avoidPatch3 = rmCreateClassDistanceConstraint("avoid patch3", rmClassID("patch3"), 5.0);
	int avoidPond = rmCreateClassDistanceConstraint("avoid pond", rmClassID("pond"), 40.0);
	int avoidRock = rmCreateClassDistanceConstraint("rock avoids rock", rmClassID("rocks"), 10.0);
	int avoidRockFar = rmCreateClassDistanceConstraint("rock avoids rock far", rmClassID("rocks"), 25.0);
	int avoidGrass = rmCreateClassDistanceConstraint("grass avoid grass", rmClassID("grass"), 40.0);
	int avoidGrassShort = rmCreateClassDistanceConstraint("grass avoid grass short", rmClassID("grass"), 5.0);
	
	// Unit avoidance
	int avoidStartingUnits = rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 35.0);	
	
	// VP avoidance
	int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 10.0);
	int avoidTradeRouteShort = rmCreateTradeRouteDistanceConstraint("trade route short", 4.0);
	int avoidTradeRouteSocket = rmCreateTypeDistanceConstraint("avoid trade route socket", "socketTradeRoute", 12.0);
	int avoidTradeRouteSocketShort = rmCreateTypeDistanceConstraint("avoid trade route socket short", "socketTradeRoute", 3.0);
	int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 10.0);
   
	
	// ***********************************************************************************************
	
	// **************************************** PLACE PLAYERS ****************************************

	int teamZeroCount = rmGetNumberPlayersOnTeam(0);
	int teamOneCount = rmGetNumberPlayersOnTeam(1);
	
	// 2 team and FFA support
	float OneVOnePlacement=rmRandFloat(0, 1);
	if (PlayerNum == 2)
	{
			if ( OneVOnePlacement < 0.5)
			{
				rmSetPlacementTeam(0);
				rmPlacePlayersLine(0.28, 0.82, 0.4, 0.20, 0, 0.0); // disregard line end

				rmSetPlacementTeam(1);
				rmPlacePlayersLine(0.72, 0.18, 0.4, 0.8, 0, 0.0); // disregard line end
			}
			else
			{
				rmSetPlacementTeam(0);
				rmPlacePlayersLine(0.72, 0.18, 0.4, 0.8, 0, 0.0);

				rmSetPlacementTeam(1);
				rmPlacePlayersLine(0.28, 0.82, 0.4, 0.20, 0, 0.0);
			}
		
	}
	
/*	// Team placement
	else if ( PlayerNum == 2 && teamZeroCount == teamOneCount)
	{

		rmSetPlacementTeam(0);
		rmSetTeamSpacingModifier(0.25);
		rmPlacePlayersLine(0.2, 0.2, 0.5, 0.2, 0, 0.0);

		rmSetPlacementTeam(1);
		rmSetTeamSpacingModifier(0.25);
		rmPlacePlayersLine(0.8, 0.8, 0.5, 0.8, 0, 0.0);
	
	}
	// FFA support
	else if (PlayerNum > 2)
	{
      bool southSide = true;

      float spacingIncrement = (0.35 / (PlayerNum / 2));
      float spacingSouth = 0;
      float spacingNorth = 0;
      
      float southStart = 0.45;
      float southEnd = 0.82;
      float northStart = 0.95;
      float northEnd = 0.32;

      for (i = 0; < PlayerNum)
      {
         rmEchoInfo("i = "+i);
         if (southSide == true)
         {
            rmSetPlacementTeam(i);
            rmSetPlacementSection((southStart + spacingSouth), southEnd);
	         rmSetTeamSpacingModifier(0.25);
	         rmPlacePlayersCircular(0.4, 0.4, 0);
            spacingSouth = spacingSouth + spacingIncrement;
         }
         else
         {
            rmSetPlacementTeam(i);
            rmSetPlacementSection((northStart + spacingNorth), northEnd);
	         rmSetTeamSpacingModifier(0.25);
	         rmPlacePlayersCircular(0.4, 0.4, 0);
            spacingNorth = spacingNorth + spacingIncrement;
         }
         if (southSide == true)
         {
            southSide = false;
         }
         else
         {
            southSide = true;
         }
      }
    }
    else 
    {
      if (teamZeroCount < teamOneCount)
      {
         rmSetPlacementTeam(0);
         rmSetPlacementSection(0.55, 0.75);
		   rmSetTeamSpacingModifier(0.35 / teamZeroCount);
		   rmPlacePlayersCircular(0.4, 0.4, 0);

		   rmSetPlacementTeam(1);
         rmSetPlacementSection(0.95, 0.32);
		   rmSetTeamSpacingModifier(0.35 / teamOneCount);
		   rmPlacePlayersCircular(0.4, 0.4, 0);
      }
      else 
      {
         rmSetPlacementTeam(0);
         rmSetPlacementSection(0.45, 0.82);
		   rmSetTeamSpacingModifier(0.35 / teamZeroCount);
		   rmPlacePlayersCircular(0.4, 0.4, 0);

		   rmSetPlacementTeam(1);
         rmSetPlacementSection(0.0, 0.2);
		   rmSetTeamSpacingModifier(0.35 / teamOneCount);
		   rmPlacePlayersCircular(0.4, 0.4, 0);
      }
   }
*/
	// **************************************************************************************************
   
	// Text
	rmSetStatusText("",0.30);
	
	// ******************************************** MAP LAYOUT **************************************************
/*	
	//Sea
	int SeaWestID = rmCreateArea("Sea west");
	rmSetAreaSize(SeaWestID, 0.16, 0.16);
	rmSetAreaLocation(SeaWestID, 0.05, 0.50);
	rmSetAreaObeyWorldCircleConstraint(SeaWestID, true);
	rmAddAreaInfluenceSegment(SeaWestID, 0.05, 1.00, 0.05, 0.00); 
	rmSetAreaWaterType(SeaWestID, "california coast"); 
//	rmAddAreaTerrainLayer(SeaWestID, "coastal_japan\ground_grass1_co_japan", 0, 2);
	rmSetAreaMinBlobs(SeaWestID, 8);
	rmSetAreaMaxBlobs(SeaWestID, 10);
//	rmSetAreaMinBlobDistance(SeaWestID, 10);
//	rmSetAreaMaxBlobDistance(SeaWestID, 20);
	rmSetAreaCoherence(SeaWestID, 0.60);
	rmSetAreaSmoothDistance(SeaWestID, 24);
	rmBuildArea(SeaWestID);
	
	int SeaEastID = rmCreateArea("Sea east");
	rmSetAreaSize(SeaEastID, 0.16, 0.16);
	rmSetAreaLocation(SeaEastID, 0.95, 0.50);
	rmSetAreaObeyWorldCircleConstraint(SeaEastID, true);
	rmAddAreaInfluenceSegment(SeaEastID, 0.96, 1.00, 0.96, 0.00); 
	rmSetAreaWaterType(SeaEastID, "california coast"); 
//	rmAddAreaTerrainLayer(SeaWestID, "coastal_japan\ground_grass1_co_japan", 0, 2);
	rmSetAreaMinBlobs(SeaEastID, 8);
	rmSetAreaMaxBlobs(SeaEastID, 10);
//	rmSetAreaMinBlobDistance(SeaWestID, 10);
//	rmSetAreaMaxBlobDistance(SeaWestID, 20);
	rmSetAreaCoherence(SeaEastID, 0.60);
	rmSetAreaSmoothDistance(SeaEastID, 24);
	rmBuildArea(SeaEastID);
*/
	//Sea stripe west
	int SeaWestID = rmRiverCreate(-1, "california coast", 10, 10, 20, 20); //  (-1, "new england lake", 18, 14, 5, 5)
	rmRiverAddWaypoint(SeaWestID, 0.04, 1.00); 
	rmRiverAddWaypoint(SeaWestID, 0.04, 0.00); 
	rmRiverBuild(SeaWestID);	
	
	//Sea stripe east
	int SeaEastID = rmRiverCreate(-1, "california coast", 10, 10, 20, 20); //  (-1, "new england lake", 18, 14, 5, 5)
	rmRiverAddWaypoint(SeaEastID, 0.96, 1.00); 
	rmRiverAddWaypoint(SeaEastID, 0.96, 0.00); 
	rmRiverBuild(SeaEastID);

	//Sea holes 
	for (i=0; < 4)
	{
	int SeaHoleID = rmCreateArea("Sea hole "+i);
	rmSetAreaSize(SeaHoleID, 0.038, 0.038);
	if (i < 1)
		rmSetAreaLocation(SeaHoleID, 0.08, 0.65);
	else if (i < 2)
		rmSetAreaLocation(SeaHoleID, 0.08, 0.22);
	else if (i < 3)
		rmSetAreaLocation(SeaHoleID, 0.92, 0.35);
	else 
		rmSetAreaLocation(SeaHoleID, 0.92, 0.78);
	rmSetAreaObeyWorldCircleConstraint(SeaHoleID, true);
	rmSetAreaWaterType(SeaHoleID, "california coast"); 
	rmSetAreaCoherence(SeaHoleID, 0.42);
	rmSetAreaSmoothDistance(SeaHoleID, 12);
	rmBuildArea(SeaHoleID);
	}
	
	// Continent
	float waypointnorth = rmRandFloat(0.47,0.53);
	float waypoint1 = rmRandFloat(0.46,0.54);
	float waypoint2 = rmRandFloat(0.46,0.54);
	float waypoint3 = rmRandFloat(0.46,0.54);
	
	int ContinentAreaID = rmCreateArea("Continent area");
	rmSetAreaSize(ContinentAreaID, 0.80, 0.80);
	rmSetAreaMix(ContinentAreaID,"california_desert2");
//	rmSetAreaTerrainType(ContinentAreaID,"california\ground5_cal",4.0);
	rmSetAreaElevationType(ContinentAreaID, cElevTurbulence);
    rmSetAreaElevationVariation(ContinentAreaID, 3.0);
    rmSetAreaBaseHeight(ContinentAreaID, 4.0);
    rmSetAreaElevationMinFrequency(ContinentAreaID, 0.08);
    rmSetAreaElevationOctaves(ContinentAreaID, 3);
    rmSetAreaElevationPersistence(ContinentAreaID, 0.2);  
	rmAddAreaConstraint(ContinentAreaID, avoidImpassableLand);
	rmSetAreaObeyWorldCircleConstraint(ContinentAreaID, false);
	rmBuildArea(ContinentAreaID); 

	//Central area
	int CentralAreaID = rmCreateArea("Central area");
		rmSetAreaSize(CentralAreaID, 0.20, 0.20);
		rmAddAreaInfluenceSegment(CentralAreaID, 0.58, 1.0, 0.55, 0.6);
		rmAddAreaInfluenceSegment(CentralAreaID, 0.55, 0.6, 0.45, 0.4);
		rmAddAreaInfluenceSegment(CentralAreaID, 0.45, 0.4, 0.42, 0.0);
	rmSetAreaMix(CentralAreaID,"california_grassrocks"); // california_grassrocks
	rmAddAreaTerrainLayer(CentralAreaID, "california\desert5_cal", 0, 3);
//	rmSetAreaTerrainType(CentralAreaID,"california\ground5_cal",4.0);
	rmSetAreaElevationType(CentralAreaID, cElevTurbulence);
	rmSetAreaElevationVariation(CentralAreaID, 4.0);
	rmSetAreaBaseHeight(CentralAreaID, 3.0);
    rmSetAreaElevationMinFrequency(CentralAreaID, 0.08);
	rmSetAreaElevationOctaves(CentralAreaID, 3);
	rmSetAreaElevationPersistence(CentralAreaID, 0.3); 
	rmSetAreaBaseHeight(CentralAreaID, 8.0);
	rmSetAreaHeightBlend(CentralAreaID, 2.0);
	rmSetAreaCoherence(CentralAreaID,0.60);
	rmSetAreaSmoothDistance(CentralAreaID, 16);
	rmAddAreaConstraint(CentralAreaID, avoidImpassableLand);
//	rmAddAreaConstraint(CentralAreaID, avoidWaterFar);
	rmSetAreaObeyWorldCircleConstraint(CentralAreaID, false);
	rmSetAreaLocation(CentralAreaID, 0.50, 0.50);
	rmBuildArea(CentralAreaID); 
	
	int avoidCentralArea = rmCreateAreaDistanceConstraint("avoid central area", CentralAreaID, 3.0);
	int avoidCentralAreaMin = rmCreateAreaDistanceConstraint("avoid central area min", CentralAreaID, 0.5);
	int stayInCentralArea = rmCreateAreaMaxDistanceConstraint("stay in central area", CentralAreaID, 0.0);
	
	// Cliff imprint
	int CliffImprintID = rmCreateArea("Cliff imprint");
	rmSetAreaSize(CliffImprintID, 0.09, 0.09);
	rmAddAreaInfluenceSegment(CliffImprintID, 0.42, 0.00, 0.42, 0.30);
	rmAddAreaInfluenceSegment(CliffImprintID, 0.42, 0.30, 0.58, 0.70);
	rmAddAreaInfluenceSegment(CliffImprintID, 0.58, 0.70, 0.58, 1.00);
	rmSetAreaTerrainType(CliffImprintID,"california\groundforest_cal"); // california_grassrocks
//	rmAddAreaTerrainLayer(CliffImprintID, "california\groundforest_cal", 0, 1);
//	rmSetAreaTerrainType(CliffImprintID,"california\ground5_cal",4.0);
	rmSetAreaElevationType(CliffImprintID, cElevTurbulence);
	rmSetAreaElevationVariation(CliffImprintID, 4.0);
	rmSetAreaBaseHeight(CliffImprintID, 4.0);
    rmSetAreaElevationMinFrequency(CliffImprintID, 0.08);
	rmSetAreaElevationOctaves(CliffImprintID, 3);
	rmSetAreaElevationPersistence(CliffImprintID, 0.3); 
	rmSetAreaBaseHeight(CliffImprintID, 8.0);
	rmSetAreaHeightBlend(CliffImprintID, 2.0);
	rmSetAreaCoherence(CliffImprintID,0.65);
	rmSetAreaSmoothDistance(CliffImprintID, 8);
	rmAddAreaConstraint(CliffImprintID, avoidImpassableLandFar);
//	rmAddAreaConstraint(CliffImprintID, avoidWaterFar);
	rmSetAreaObeyWorldCircleConstraint(CliffImprintID, false);
	rmSetAreaLocation(CliffImprintID, 0.50, 0.50);
	rmBuildArea(CliffImprintID); 

	//Cliff
	int cliffnorthID = -1;
	int cliffsouthID = -1;
	int cliff1ID = -1;
	int cliff2ID = -1;
	int cliff3ID = -1;
		
			cliffnorthID = rmCreateArea("cliff north");
			rmAddAreaToClass(cliffnorthID, rmClassID("Cliffs"));
			rmSetAreaSize(cliffnorthID, 0.004, 0.004);
			rmSetAreaCoherence(cliffnorthID, 0.7);
			rmSetAreaSmoothDistance(cliffnorthID, 7);
			rmAddAreaInfluencePoint(cliffnorthID, 0.58, 0.96);
			rmSetAreaWarnFailure(cliffnorthID, false);
			rmSetAreaCliffType(cliffnorthID, "california"); //
			rmSetAreaCliffHeight(cliffnorthID, 5, 0.0, 0.5);
			rmSetAreaCliffEdge(cliffnorthID, 1, 1.0, 0.0, 0.0, 1);
			rmSetAreaTerrainType(cliffnorthID, "california\groundforest_cal"); 
		//	rmSetAreaCliffPainting(cliffnorthID, true, false, true, 1.5 , true);
			rmSetAreaLocation(cliffnorthID, 0.58, 1.0);
			rmSetAreaObeyWorldCircleConstraint(cliffnorthID, false);
			rmBuildArea(cliffnorthID);
			
			cliff1ID = rmCreateArea("cliff diagonal north");
			rmAddAreaToClass(cliff1ID, rmClassID("Cliffs"));
			rmSetAreaSize(cliff1ID, 0.0115, 0.0115);
			rmSetAreaCoherence(cliff1ID, 0.65);
			rmSetAreaSmoothDistance(cliff1ID, 7);
			rmAddAreaInfluenceSegment(cliff1ID, 0.58, 0.78, 0.58, 0.70);
			rmAddAreaInfluenceSegment(cliff1ID, 0.58, 0.70, 0.52, 0.60);
			rmSetAreaWarnFailure(cliff1ID, false);
			rmSetAreaCliffType(cliff1ID, "california"); //
			rmSetAreaCliffHeight(cliff1ID, 5, 0.0, 0.5);
			rmSetAreaCliffEdge(cliff1ID, 1, 1.0, 0.0, 0.0, 1);
			rmSetAreaTerrainType(cliff1ID, "california\groundforest_cal"); 
		//	rmSetAreaCliffPainting(cliff1ID, true, false, true, 1.5 , true);
			rmSetAreaLocation(cliff1ID, 0.58, 0.70);
			rmSetAreaObeyWorldCircleConstraint(cliff1ID, false);
			rmBuildArea(cliff1ID);
			
			cliff2ID = rmCreateArea("cliff diagonal south");
			rmAddAreaToClass(cliff2ID, rmClassID("Cliffs"));
			rmSetAreaSize(cliff2ID, 0.0115, 0.0115); // 0.008, 0.008
			rmSetAreaCoherence(cliff2ID, 0.65);
			rmSetAreaSmoothDistance(cliff2ID, 7);
			rmAddAreaInfluenceSegment(cliff2ID, 0.42, 0.22, 0.42, 0.30); 
			rmAddAreaInfluenceSegment(cliff2ID, 0.42, 0.30, 0.48, 0.40); 
			rmSetAreaWarnFailure(cliff2ID, false);
			rmSetAreaCliffType(cliff2ID, "california"); //
			rmSetAreaCliffHeight(cliff2ID, 5, 0.0, 0.5);
			rmSetAreaCliffEdge(cliff2ID, 1, 1.0, 0.0, 0.0, 1);
			rmSetAreaTerrainType(cliff2ID, "california\groundforest_cal"); 
		//	rmSetAreaCliffPainting(cliff2ID, true, false, true, 1.5 , true);
			rmSetAreaLocation(cliff2ID, 0.42, 0.30);
			rmSetAreaObeyWorldCircleConstraint(cliff2ID, false);
			rmBuildArea(cliff2ID);
			
			cliffsouthID = rmCreateArea("cliff south");
			rmAddAreaToClass(cliffsouthID, rmClassID("Cliffs"));
			rmSetAreaSize(cliffsouthID, 0.004, 0.004);
			rmSetAreaCoherence(cliffsouthID, 0.7);
			rmSetAreaSmoothDistance(cliffsouthID, 5);
			rmAddAreaInfluencePoint(cliffsouthID, 0.42, 0.04);
			rmSetAreaWarnFailure(cliffsouthID, false);
			rmSetAreaCliffType(cliffsouthID, "california"); //
			rmSetAreaCliffHeight(cliffsouthID, 5, 0.0, 0.5);
			rmSetAreaCliffEdge(cliffsouthID, 1, 1.0, 0.0, 0.0, 1);
			rmSetAreaTerrainType(cliffsouthID, "california\groundforest_cal"); 
		//	rmSetAreaCliffPainting(cliffsouthID, true, false, true, 1.5 , true);
			rmSetAreaLocation(cliffsouthID, 0.42, 0.0);
			rmSetAreaObeyWorldCircleConstraint(cliffsouthID, false);
			rmBuildArea(cliffsouthID);
		
	int avoidCliffNorth = rmCreateAreaDistanceConstraint("avoid cliff north", cliffnorthID, 6.0);
	int avoidCliffSouth = rmCreateAreaDistanceConstraint("avoid cliff south", cliffsouthID, 6.0);
	int avoidCliff1 = rmCreateAreaDistanceConstraint("avoid cliff 1", cliff1ID, 6.0);
	int avoidCliff2 = rmCreateAreaDistanceConstraint("avoid cliff 2", cliff2ID, 6.0);
	int avoidCliff3 = rmCreateAreaDistanceConstraint("avoid cliff 3", cliff3ID, 6.0);
	
	int stayCliffNorth = rmCreateAreaMaxDistanceConstraint("stay cliff north", cliffnorthID, 0.0);
	int stayCliffSouth = rmCreateAreaMaxDistanceConstraint("stay cliff south", cliffsouthID, 0.0);
	int stayCliff1 = rmCreateAreaMaxDistanceConstraint("stay cliff 1", cliff1ID, 0.0);
	int stayCliff2 = rmCreateAreaMaxDistanceConstraint("stay cliff 2", cliff2ID, 0.0);
	int stayCliff3 = rmCreateAreaMaxDistanceConstraint("stay cliff 3", cliff3ID, 0.0);
	
	// Players area
	for (i=1; < numPlayer)
	{
		int playerareaID = rmCreateArea("playerarea"+i);
		rmSetPlayerArea(i, playerareaID);
		rmSetAreaSize(playerareaID, 0.05, 0.05);
		rmSetAreaCoherence(playerareaID, 1.0);
		rmSetAreaWarnFailure(playerareaID, false);
//		rmSetAreaTerrainType(playerareaID, "new_england\ground2_cliff_ne"); // for testing
		rmSetAreaLocPlayer(playerareaID, i);
		rmSetAreaObeyWorldCircleConstraint(playerareaID, false);
		rmBuildArea(playerareaID);
		int avoidPlayerArea = rmCreateAreaDistanceConstraint("avoid player area "+i, playerareaID, 3.0);
		int stayPlayerArea = rmCreateAreaMaxDistanceConstraint("stay in player area "+i, playerareaID, 0.0);
	}
	
	int avoidPlayerArea1 = rmConstraintID("avoid player area 1");
	int avoidPlayerArea2 = rmConstraintID("avoid player area 2");
	int stayInPlayerArea1 = rmConstraintID("stay in player area 1");
	int stayInPlayerArea2 = rmConstraintID("stay in player area 2");
	
	
	// *********************************************************************************************************
	
	// Text
	rmSetStatusText("",0.40);
	
		// ****************************************** TRADE ROUTE **********************************************
	
	int tradeRouteID = rmCreateTradeRoute();
	int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
	rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	rmSetObjectDefAllowOverlap(socketID, true);
	rmSetObjectDefMinDistance(socketID, 0.0);
	rmSetObjectDefMaxDistance(socketID, 8.0);

			
		rmAddTradeRouteWaypoint(tradeRouteID, 0.74, 1.00);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.70, 0.84);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.74, 0.68);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.70, 0.52);
		
		rmAddTradeRouteWaypoint(tradeRouteID, 0.62, 0.44);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.38, 0.55);
		
		rmAddTradeRouteWaypoint(tradeRouteID, 0.32, 0.49); 
		rmAddTradeRouteWaypoint(tradeRouteID, 0.26, 0.32);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.32, 0.16);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.26, 0.00);	
	
	
	bool placedTradeRoute =	rmBuildTradeRoute(tradeRouteID, "dirt");
	if(placedTradeRoute == false)
	rmEchoError("Failed to place trade route");
	rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
	
	
		vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.08);
		rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
//		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.24);
//		rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
//		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.40);
//		rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.46);
		rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
//		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.60);
//		rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
//		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.76);
//		rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.92);
		rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		
	// *************************************************************************************************************
		
	// Text
	rmSetStatusText("",0.45);
	
	// ******************************************** NATIVES *************************************************
	
	int natsvariation = -1;
//	natsvariation = rmRandInt(0,1);
	natsvariation = 1; // <--- TEST
	
	int nativeID0 = -1;
    int nativeID1 = -1;
	int nativeID2 = -1;
    int nativeID3 = -1;
	int nativeID4 = -1;
		
	if (natsvariation == 0)	
		nativeID0 = rmCreateGrouping("apache village", "native apache village "+3);
	else
		nativeID0 = rmCreateGrouping("navajo village", "native navajo village "+4);
    rmSetGroupingMinDistance(nativeID0, 0.00);
    rmSetGroupingMaxDistance(nativeID0, 0.00);
//	rmAddGroupingConstraint(nativeID0, avoidImpassableLand);
	rmAddGroupingToClass(nativeID0, rmClassID("natives"));
//  rmAddGroupingToClass(nativeID0, rmClassID("importantItem"));
//	rmAddGroupingConstraint(nativeID0, avoidNatives);
		rmPlaceGroupingAtLoc(nativeID0, 0, 0.46, 0.72);
	
	if (natsvariation == 0)	
		nativeID1 = rmCreateGrouping("apache village2", "native apache village "+1);
	else
		nativeID1 = rmCreateGrouping("navajo village2", "native navajo village "+1);
    rmSetGroupingMinDistance(nativeID1, 0.00);
    rmSetGroupingMaxDistance(nativeID1, 0.00);
//	rmAddGroupingConstraint(nativeID1, avoidImpassableLand);
	rmAddGroupingToClass(nativeID1, rmClassID("natives"));
//  rmAddGroupingToClass(nativeID1, rmClassID("importantItem"));
//	rmAddGroupingConstraint(nativeID1, avoidNatives);
		rmPlaceGroupingAtLoc(nativeID1, 0, 0.54, 0.28);
	
	// ******************************************************************************************************
	
	// Text
	rmSetStatusText("",0.50);
	
	// ************************************ PLAYER STARTING RESOURCES ***************************************

	// ******** Define ********

	// Town center & units
	int TCID = rmCreateObjectDef("player TC");
	int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	if (rmGetNomadStart())
	{
		rmAddObjectDefItem(TCID, "CoveredWagon", 1, 0.0);
	}
	else
	{
	rmAddObjectDefItem(TCID, "TownCenter", 1, 0.0);
	rmAddObjectDefToClass(TCID, classStartingResource);
	}
	rmSetObjectDefMinDistance(TCID, 0.0);
	rmSetObjectDefMaxDistance(TCID, 0.0);
	
	// Starting mines
	int playergoldID = rmCreateObjectDef("player mine");
	rmAddObjectDefItem(playergoldID, "mine", 1, 0);
	rmSetObjectDefMinDistance(playergoldID, 14.0);
	rmSetObjectDefMaxDistance(playergoldID, 16.0);
	rmAddObjectDefToClass(playergoldID, classStartingResource);
	rmAddObjectDefToClass(playergoldID, classGold);
//	rmAddObjectDefConstraint(playergoldID, avoidTradeRoute);
	rmAddObjectDefConstraint(playergoldID, avoidImpassableLand);
	rmAddObjectDefConstraint(playergoldID, avoidNatives);
	rmAddObjectDefConstraint(playergoldID, avoidStartingResources);
	
	// 2nd mine
	int playergold2ID = rmCreateObjectDef("player second mine");
	rmAddObjectDefItem(playergold2ID, "mine", 1, 0);
	rmSetObjectDefMinDistance(playergold2ID, 62.0); //58
	rmSetObjectDefMaxDistance(playergold2ID, 66.0); //62
//	rmAddObjectDefToClass(playergold2ID, classStartingResource);
	rmAddObjectDefToClass(playergold2ID, classGold);
	rmAddObjectDefConstraint(playergold2ID, avoidTradeRoute);
	rmAddObjectDefConstraint(playergold2ID, avoidImpassableLand);
	rmAddObjectDefConstraint(playergold2ID, avoidWaterFar);
	rmAddObjectDefConstraint(playergold2ID, avoidNatives);
	rmAddObjectDefConstraint(playergold2ID, avoidGoldType);
	rmAddObjectDefConstraint(playergold2ID, avoidStartingResources);
	rmAddObjectDefConstraint(playergold2ID, avoidEdge);
	
	// 3nd mine
	int playergold3ID = rmCreateObjectDef("player third mine");
	rmAddObjectDefItem(playergold3ID, "mine", 1, 0);
	rmSetObjectDefMinDistance(playergold3ID, 36.0); //58
	rmSetObjectDefMaxDistance(playergold3ID, 38.0); //62
//	rmAddObjectDefToClass(playergold3ID, classStartingResource);
	rmAddObjectDefToClass(playergold3ID, classGold);
	rmAddObjectDefConstraint(playergold3ID, avoidTradeRoute);
	rmAddObjectDefConstraint(playergold3ID, avoidImpassableLandMed);
//	rmAddObjectDefConstraint(playergold3ID, avoidWater);
	rmAddObjectDefConstraint(playergold3ID, avoidNatives);
	rmAddObjectDefConstraint(playergold3ID, avoidGoldType);
	rmAddObjectDefConstraint(playergold3ID, avoidStartingResources);
	rmAddObjectDefConstraint(playergold3ID, avoidEdge);
//	rmAddObjectDefConstraint(playergold3ID, avoidCenter);

	
	// Starting trees
	int playerTreeID = rmCreateObjectDef("player trees");
	rmAddObjectDefItem(playerTreeID, "TreeSonora", rmRandInt(1,2), 2.0);
    rmSetObjectDefMinDistance(playerTreeID, 12);
    rmSetObjectDefMaxDistance(playerTreeID, 16);
	rmAddObjectDefToClass(playerTreeID, classStartingResource);
//	rmAddObjectDefToClass(playerTreeID, classForest);
	rmAddObjectDefConstraint(playerTreeID, avoidTradeRoute);
    rmAddObjectDefConstraint(playerTreeID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerTreeID, avoidStartingResourcesShort);
	
	// Starting trees2
	int playerTree2ID = rmCreateObjectDef("player trees 2");
	rmAddObjectDefItem(playerTree2ID, "TreeSonora", rmRandInt(2,2), 2.0);
    rmSetObjectDefMinDistance(playerTree2ID, 12);
    rmSetObjectDefMaxDistance(playerTree2ID, 16);
	rmAddObjectDefToClass(playerTree2ID, classStartingResource);
//	rmAddObjectDefToClass(playerTree2ID, classForest);
	rmAddObjectDefConstraint(playerTree2ID, avoidTradeRoute);
    rmAddObjectDefConstraint(playerTree2ID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerTree2ID, avoidStartingResourcesShort);
	
	// Starting berries
	int playerberriesID = rmCreateObjectDef("player berries");
	rmAddObjectDefItem(playerberriesID, "berrybush", rmRandInt(2,2), 2.0);
    rmSetObjectDefMinDistance(playerberriesID, 12);
    rmSetObjectDefMaxDistance(playerberriesID, 16);
	rmAddObjectDefToClass(playerberriesID, classStartingResource);
    rmAddObjectDefConstraint(playerberriesID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerberriesID, avoidStartingResources);
	
	// Starting herd
	int playerherdID = rmCreateObjectDef("starting moose");
	rmAddObjectDefItem(playerherdID, "pronghorn", rmRandInt(5,5), 4.0);
	rmSetObjectDefMinDistance(playerherdID, 14.0);
	rmSetObjectDefMaxDistance(playerherdID, 16.0);
	rmSetObjectDefCreateHerd(playerherdID, true);
	rmAddObjectDefToClass(playerherdID, classStartingResource);
	rmAddObjectDefConstraint(playerherdID, avoidTradeRoute);
	rmAddObjectDefConstraint(playerherdID, avoidImpassableLandMed);
	rmAddObjectDefConstraint(playerherdID, avoidNatives);
//	rmAddObjectDefConstraint(playerherdID, avoidStartingResourcesShort);
		
	// 2nd herd
	int player2ndherdID = rmCreateObjectDef("player 2nd herd");
	rmAddObjectDefItem(player2ndherdID, "pronghorn", rmRandInt(10,10), 7.0);
    rmSetObjectDefMinDistance(player2ndherdID, 30);
    rmSetObjectDefMaxDistance(player2ndherdID, 32);
	rmAddObjectDefToClass(player2ndherdID, classStartingResource);
	rmSetObjectDefCreateHerd(player2ndherdID, true);
	rmAddObjectDefConstraint(player2ndherdID, avoidStartingResources);
	rmAddObjectDefConstraint(player2ndherdID, avoidPronghorn); 
//	rmAddObjectDefConstraint(player2ndherdID, avoidTradeRouteShort);
	rmAddObjectDefConstraint(player2ndherdID, avoidTradeRouteSocket);
	rmAddObjectDefConstraint(player2ndherdID, avoidImpassableLandFar);
	rmAddObjectDefConstraint(player2ndherdID, avoidNatives);
		
// 3nd herd
	int player3rdherdID = rmCreateObjectDef("player 3rd herd");
	rmAddObjectDefItem(player3rdherdID, "pronghorn", rmRandInt(6,6), 5.0);
    rmSetObjectDefMinDistance(player3rdherdID, 44);
    rmSetObjectDefMaxDistance(player3rdherdID, 46);
	rmAddObjectDefToClass(player3rdherdID, classStartingResource);
	rmSetObjectDefCreateHerd(player3rdherdID, true);
	rmAddObjectDefConstraint(player3rdherdID, avoidStartingResources);
	rmAddObjectDefConstraint(player3rdherdID, avoidPronghorn); 
//	rmAddObjectDefConstraint(player3rdherdID, avoidTradeRouteShort);
	rmAddObjectDefConstraint(player3rdherdID, avoidTradeRouteSocket);
	rmAddObjectDefConstraint(player3rdherdID, avoidImpassableLandMed);
	rmAddObjectDefConstraint(player3rdherdID, avoidNatives);
	
	// Starting treasures
	int playerNuggetID = rmCreateObjectDef("player nugget"); 
	rmAddObjectDefItem(playerNuggetID, "Nugget", 1, 0.0);
	rmSetNuggetDifficulty(1, 1);
	rmSetObjectDefMinDistance(playerNuggetID, 20.0);
	rmSetObjectDefMaxDistance(playerNuggetID, 30.0);
	rmAddObjectDefToClass(playerNuggetID, classStartingResource);
	rmAddObjectDefConstraint(playerNuggetID, avoidTradeRoute);
	rmAddObjectDefConstraint(playerNuggetID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerNuggetID, avoidNatives);
	rmAddObjectDefConstraint(playerNuggetID, avoidStartingResourcesShort);
	rmAddObjectDefConstraint(playerNuggetID, avoidNuggetShort); //Short
	rmAddObjectDefConstraint(playerNuggetID, avoidEdge);
	
	// Water spawn flag
	int colonyShipID = 0;
	colonyShipID=rmCreateObjectDef("colony ship "+i);
	rmAddObjectDefItem(colonyShipID, "HomeCityWaterSpawnFlag", 1, 1.0);
	rmSetObjectDefMinDistance(colonyShipID, rmXFractionToMeters(0.1));
	rmSetObjectDefMaxDistance(colonyShipID, rmXFractionToMeters(0.2));
	rmAddObjectDefConstraint(colonyShipID, avoidColonyShip);
	rmAddObjectDefConstraint(colonyShipID, avoidLand);
	rmAddObjectDefConstraint(colonyShipID, avoidEdge);
//  vector colonyShipLocation=rmGetUnitPosition(rmGetUnitPlacedOfPlayer(colonyShipID, i));
//  rmSetHomeCityWaterSpawnPoint(i, colonyShipLocation);
   
   
		
	// ******** Place ********
	
	for(i=1; <numPlayer)
	{
		rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));

		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));	
		rmPlaceObjectDefAtLoc(playergoldID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playergold2ID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playergold3ID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTreeID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTree2ID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTreeID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerberriesID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTreeID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTree2ID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerherdID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(player2ndherdID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
 		rmPlaceObjectDefAtLoc(player3rdherdID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerNuggetID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerNuggetID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
				
		if(ypIsAsian(i) && rmGetNomadStart() == false)
			rmPlaceObjectDefAtLoc(ypMonasteryBuilder(i), i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
			
		vector closestPoint = rmFindClosestPointVector(TCLoc, rmXFractionToMeters(1.0));
		rmPlaceObjectDefAtLoc(colonyShipID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
	}

	// ************************************************************************************************
	
	// Text
	rmSetStatusText("",0.60);
	
	// ************************************** COMMON RESOURCES ****************************************
  
   
	// ************* Mines **************
	
		int minecount = rmRandInt(6,6);  // 3,3 


	//Mines
	for(i=0; < minecount)
	{
		int commongoldID = rmCreateObjectDef("common mines"+i);
		rmAddObjectDefItem(commongoldID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(commongoldID, rmXFractionToMeters(0.0));
		rmSetObjectDefMaxDistance(commongoldID, rmXFractionToMeters(0.5));
		rmAddObjectDefToClass(commongoldID, classGold);
		rmAddObjectDefConstraint(commongoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(commongoldID, avoidImpassableLandMed);
		rmAddObjectDefConstraint(commongoldID, avoidWater);
		rmAddObjectDefConstraint(commongoldID, avoidNatives);
		rmAddObjectDefConstraint(commongoldID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(commongoldID, avoidGoldFar);
		rmAddObjectDefConstraint(commongoldID, avoidTownCenterFar);
		rmAddObjectDefConstraint(commongoldID, avoidEdge);
		if (i < 3)
			rmAddObjectDefConstraint(commongoldID, stayWestHalf);
		else
			rmAddObjectDefConstraint(commongoldID, stayEastHalf);
		rmPlaceObjectDefAtLoc(commongoldID, 0, 0.50, 0.50);
	}
		
	// *********************************
		
	// ************ Forest *************
	
	// Desert forest
	int desertforestcount = 20;
	
	for (i=0; < desertforestcount)
	{
		int forestID = rmCreateArea("forest"+i);
		rmSetAreaWarnFailure(forestID, false);
		rmSetAreaSize(forestID, rmAreaTilesToFraction(160), rmAreaTilesToFraction(180));
		rmSetAreaForestType(forestID, "california desert forest");
//		rmSetAreaObeyWorldCircleConstraint(forestID, false);
		rmSetAreaForestDensity(forestID, 0.80);
		rmSetAreaForestClumpiness(forestID, 0.20);
		rmSetAreaForestUnderbrush(forestID, 0.2);
		rmSetAreaMinBlobs(forestID, 1);
		rmSetAreaMaxBlobs(forestID, 5);
		rmSetAreaMinBlobDistance(forestID, 10.0);
		rmSetAreaMaxBlobDistance(forestID, 30.0);
		rmSetAreaCoherence(forestID, 1.0);
		rmSetAreaSmoothDistance(forestID, 6);
		rmAddAreaToClass(forestID, classForest);
		rmAddAreaConstraint(forestID, avoidForest);
		rmAddAreaConstraint(forestID, avoidStartingResourcesShort);
		rmAddAreaConstraint(forestID, avoidGoldTypeMed);
//		rmAddAreaConstraint(forestID, avoidPronghornMin); 
		rmAddAreaConstraint(forestID, avoidTownCenterShort);
		rmAddAreaConstraint(forestID, avoidNatives);
		rmAddAreaConstraint(forestID, avoidTradeRouteShort);
		rmAddAreaConstraint(forestID, avoidTradeRouteSocket);
		rmAddAreaConstraint(forestID, avoidImpassableLand);
//		rmAddAreaConstraint(forestID, avoidEdge);
		rmAddAreaConstraint(forestID, avoidCentralArea);
		rmBuildArea(forestID);
	}
	
	// Isolated trees
	int randomtreecount = 30;
	
	for (i=0; < randomtreecount)
	{	
		int randomtreeID = rmCreateObjectDef("random tree"+i);
		rmAddObjectDefItem(randomtreeID, "TreeSonora", rmRandInt(1,3), 3.0); 
		rmSetObjectDefMinDistance(randomtreeID, 0);
		rmSetObjectDefMaxDistance(randomtreeID, rmXFractionToMeters(0.5));
		rmAddObjectDefToClass(randomtreeID, classForest);
		rmAddObjectDefConstraint(randomtreeID, avoidForestShort);
		rmAddObjectDefConstraint(randomtreeID, avoidTradeRouteShort);
		rmAddObjectDefConstraint(randomtreeID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(randomtreeID, avoidImpassableLandShort);
		rmAddObjectDefConstraint(randomtreeID, avoidNatives);
		rmAddObjectDefConstraint(randomtreeID, avoidGoldTypeMed);
		rmAddObjectDefConstraint(randomtreeID, avoidTownCenterShort);
		rmAddObjectDefConstraint(randomtreeID, avoidStartingResources); 
		rmAddObjectDefConstraint(randomtreeID, avoidPronghornMin); 
		rmAddObjectDefConstraint(randomtreeID, avoidCentralArea);
		rmPlaceObjectDefAtLoc(randomtreeID, 0, 0.50, 0.50);
	}	
	
	// Central ponderosa pine forest
	int centralforestcount = 10; 
	
	for (i=0; < centralforestcount)
	{	
		int centraltreebigID = rmCreateObjectDef("central tree clump  big"+i);
		rmAddObjectDefItem(centraltreebigID, "TreePonderosaPine", rmRandInt(10,12), 6.0); 
		rmSetObjectDefMinDistance(centraltreebigID, 0);
		rmSetObjectDefMaxDistance(centraltreebigID, rmXFractionToMeters(0.5));
		rmAddObjectDefToClass(centraltreebigID, classForest);
		rmAddObjectDefConstraint(centraltreebigID, avoidForestFar);
		rmAddObjectDefConstraint(centraltreebigID, avoidTradeRouteShort);
		rmAddObjectDefConstraint(centraltreebigID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(centraltreebigID, avoidImpassableLandShort);
		rmAddObjectDefConstraint(centraltreebigID, avoidNatives);
		rmAddObjectDefConstraint(centraltreebigID, avoidGoldTypeMed);
		rmAddObjectDefConstraint(centraltreebigID, avoidTownCenter);
		rmAddObjectDefConstraint(centraltreebigID, avoidStartingResources); 
		rmAddObjectDefConstraint(centraltreebigID, avoidPronghornMin); 
		rmAddObjectDefConstraint(centraltreebigID, stayInCentralArea);
		rmAddObjectDefConstraint(centraltreebigID, avoidCliffNorth);
		rmAddObjectDefConstraint(centraltreebigID, avoidCliffSouth);
		rmAddObjectDefConstraint(centraltreebigID, avoidCliff1);
		rmAddObjectDefConstraint(centraltreebigID, avoidCliff2);
		rmAddObjectDefConstraint(centraltreebigID, avoidCliff3);
		rmPlaceObjectDefAtLoc(centraltreebigID, 0, 0.50, 0.50);
	}	
	
	// Central ponderosa pine forest small	
	for (i=0; < centralforestcount)
	{	
		int centraltreesmallID = rmCreateObjectDef("central tree clump  small"+i);
		rmAddObjectDefItem(centraltreesmallID, "TreePonderosaPine", rmRandInt(6,8), 4.0); 
		rmSetObjectDefMinDistance(centraltreesmallID, 0);
		rmSetObjectDefMaxDistance(centraltreesmallID, rmXFractionToMeters(0.5));
		rmAddObjectDefToClass(centraltreesmallID, classForest);
		rmAddObjectDefConstraint(centraltreesmallID, avoidForest);
		rmAddObjectDefConstraint(centraltreesmallID, avoidTradeRouteShort);
		rmAddObjectDefConstraint(centraltreesmallID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(centraltreesmallID, avoidImpassableLandShort);
		rmAddObjectDefConstraint(centraltreesmallID, avoidNatives);
		rmAddObjectDefConstraint(centraltreesmallID, avoidGoldTypeMed);
		rmAddObjectDefConstraint(centraltreesmallID, avoidTownCenter);
		rmAddObjectDefConstraint(centraltreesmallID, avoidStartingResources); 
		rmAddObjectDefConstraint(centraltreesmallID, avoidPronghornMin); 
		rmAddObjectDefConstraint(centraltreesmallID, stayInCentralArea);
		rmAddObjectDefConstraint(centraltreesmallID, avoidCliffNorth);
		rmAddObjectDefConstraint(centraltreesmallID, avoidCliffSouth);
		rmAddObjectDefConstraint(centraltreesmallID, avoidCliff1);
		rmAddObjectDefConstraint(centraltreesmallID, avoidCliff2);
		rmAddObjectDefConstraint(centraltreesmallID, avoidCliff3);
		rmPlaceObjectDefAtLoc(centraltreesmallID, 0, 0.50, 0.50);
	}	
	
	// ********************************
	
	// Text
	rmSetStatusText("",0.70);

	// ************ Herds *************
				
	//Pronghorn herds
	int pronghorncount = 6;
	
	for (i=0; < pronghorncount)
	{
		int pronghornherdID = rmCreateObjectDef("pronghorn herd"+i);
		rmAddObjectDefItem(pronghornherdID, "pronghorn", rmRandInt(6,6), 6.0);
		rmSetObjectDefMinDistance(pronghornherdID, 0.0);
		rmSetObjectDefMaxDistance(pronghornherdID, rmXFractionToMeters(0.5));
		rmSetObjectDefCreateHerd(pronghornherdID, true);
		rmAddObjectDefConstraint(pronghornherdID, avoidImpassableLandShort);
		rmAddObjectDefConstraint(pronghornherdID, avoidNatives);
		rmAddObjectDefConstraint(pronghornherdID, avoidTradeRouteSocketShort);
		rmAddObjectDefConstraint(pronghornherdID, avoidForestMin);
		rmAddObjectDefConstraint(pronghornherdID, avoidGoldTypeMed);
		rmAddObjectDefConstraint(pronghornherdID, avoidPronghornFar);
		rmAddObjectDefConstraint(pronghornherdID, avoidForestMin);
		rmAddObjectDefConstraint(pronghornherdID, avoidTownCenter);
		rmAddObjectDefConstraint(pronghornherdID, avoidEdge);
		rmAddObjectDefConstraint(pronghornherdID, avoidCentralAreaMin);
		if (i < 3)
			rmAddObjectDefConstraint(pronghornherdID, stayWestHalf);
		else
			rmAddObjectDefConstraint(pronghornherdID, stayEastHalf);
		rmPlaceObjectDefAtLoc(pronghornherdID, 0, 0.50, 0.50);
	}
	
	//Bighorn herds
	int bighorncount = 6;
	
	for (i=0; < bighorncount)
	{
		int bighornherdID = rmCreateObjectDef("bighorn herd"+i);
		rmAddObjectDefItem(bighornherdID, "bighornsheep", rmRandInt(6,6), 7.0);
		rmSetObjectDefMinDistance(bighornherdID, rmXFractionToMeters(0.0));
		rmSetObjectDefMaxDistance(bighornherdID, rmXFractionToMeters(0.5));
		rmSetObjectDefCreateHerd(bighornherdID, true);
		rmAddObjectDefConstraint(bighornherdID, avoidImpassableLandShort);
		rmAddObjectDefConstraint(bighornherdID, avoidNatives);
		rmAddObjectDefConstraint(bighornherdID, avoidTradeRouteSocketShort);
		rmAddObjectDefConstraint(bighornherdID, avoidForestMin);
		rmAddObjectDefConstraint(bighornherdID, avoidGoldTypeMed);
		rmAddObjectDefConstraint(bighornherdID, avoidPronghorn);
		rmAddObjectDefConstraint(bighornherdID, avoidBighornFar);
		rmAddObjectDefConstraint(bighornherdID, avoidTownCenter);
		rmAddObjectDefConstraint(bighornherdID, stayInCentralArea);
		rmAddObjectDefConstraint(bighornherdID, avoidCliffNorth);
		rmAddObjectDefConstraint(bighornherdID, avoidCliffSouth);
		rmAddObjectDefConstraint(bighornherdID, avoidCliff1);
		rmAddObjectDefConstraint(bighornherdID, avoidCliff2);
		rmAddObjectDefConstraint(bighornherdID, avoidCliff3);
		rmAddObjectDefConstraint(bighornherdID, avoidEdge);
		rmPlaceObjectDefAtLoc(bighornherdID, 0, 0.50, 0.50);
	}
	
	// ************************************
	
	// Text
	rmSetStatusText("",0.80);
		
	// ************** Treasures ***************
	
	int treasure2count = 8;
	int treasure1count = 6;
	
	// Treasures lvl 2	
	for (i=0; < treasure2count)
	{
		int Nugget2ID = rmCreateObjectDef("nugget lvl2 "+i); 
		rmAddObjectDefItem(Nugget2ID, "Nugget", 1, 0.0);
		rmSetObjectDefMinDistance(Nugget2ID, 0);
		rmSetObjectDefMaxDistance(Nugget2ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(2,2);
		rmAddObjectDefConstraint(Nugget2ID, avoidNuggetFar);
		rmAddObjectDefConstraint(Nugget2ID, avoidNatives);
		rmAddObjectDefConstraint(Nugget2ID, avoidTradeRouteShort);
		rmAddObjectDefConstraint(Nugget2ID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(Nugget2ID, avoidImpassableLand);
		rmAddObjectDefConstraint(Nugget2ID, avoidGoldTypeShort);
		rmAddObjectDefConstraint(Nugget2ID, avoidTownCenter);
		rmAddObjectDefConstraint(Nugget2ID, avoidPronghornMin); 
		rmAddObjectDefConstraint(Nugget2ID, avoidBighornMin);
		rmAddObjectDefConstraint(Nugget2ID, avoidForestMin);
		rmAddObjectDefConstraint(Nugget2ID, avoidCliffNorth);
		rmAddObjectDefConstraint(Nugget2ID, avoidCliffSouth);
		rmAddObjectDefConstraint(Nugget2ID, avoidCliff1);
		rmAddObjectDefConstraint(Nugget2ID, avoidCliff2);
		rmAddObjectDefConstraint(Nugget2ID, avoidCliff3);
		rmAddObjectDefConstraint(Nugget2ID, avoidEdge); 
		if (i < 4)
			rmAddObjectDefConstraint(Nugget2ID, stayWestHalf);
		else
			rmAddObjectDefConstraint(Nugget2ID, stayEastHalf);
		rmPlaceObjectDefAtLoc(Nugget2ID, 0, 0.50, 0.50);
	}
	
	// Treasures lvl 1	
	for (i=0; < treasure1count)
	{
		int Nugget1ID = rmCreateObjectDef("nugget lvl1 "+i); 
		rmAddObjectDefItem(Nugget1ID, "Nugget", 1, 0.0);
		rmSetObjectDefMinDistance(Nugget1ID, 0);
		rmSetObjectDefMaxDistance(Nugget1ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(1,1);
		rmAddObjectDefConstraint(Nugget1ID, avoidNugget);
		rmAddObjectDefConstraint(Nugget1ID, avoidNatives);
		rmAddObjectDefConstraint(Nugget1ID, avoidTradeRouteShort);
		rmAddObjectDefConstraint(Nugget1ID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(Nugget1ID, avoidImpassableLand);
		rmAddObjectDefConstraint(Nugget1ID, avoidGoldTypeShort);
		rmAddObjectDefConstraint(Nugget1ID, avoidTownCenter);
		rmAddObjectDefConstraint(Nugget1ID, avoidPronghornMin); 
		rmAddObjectDefConstraint(Nugget1ID, avoidBighornMin);
		rmAddObjectDefConstraint(Nugget1ID, avoidForestMin);
		rmAddObjectDefConstraint(Nugget1ID, avoidCliffNorth);
		rmAddObjectDefConstraint(Nugget1ID, avoidCliffSouth);
		rmAddObjectDefConstraint(Nugget1ID, avoidCliff1);
		rmAddObjectDefConstraint(Nugget1ID, avoidCliff2);
		rmAddObjectDefConstraint(Nugget1ID, avoidCliff3);
		rmAddObjectDefConstraint(Nugget1ID, avoidEdge); 
		if (i < 3)
			rmAddObjectDefConstraint(Nugget1ID, stayWestHalf);
		else
			rmAddObjectDefConstraint(Nugget1ID, stayEastHalf);
		rmPlaceObjectDefAtLoc(Nugget1ID, 0, 0.50, 0.50);
	}
	
	// ****************************************
	
/*	// **************** Sheeps *****************
	
		for (i=0; <8)
		{
			int sheepID=rmCreateObjectDef("sheep"+i);
			rmAddObjectDefItem(sheepID, "sheep", 1, 1.0);
			rmSetObjectDefMinDistance(sheepID, 0.0);
			rmSetObjectDefMaxDistance(sheepID, rmXFractionToMeters(0.5));
			rmAddObjectDefConstraint(sheepID, avoidSheep);
			rmAddObjectDefConstraint(sheepID, avoidTownCenterFar);
			rmAddObjectDefConstraint(sheepID, avoidIsland1);
			rmAddObjectDefConstraint(sheepID, avoidIsland2);
			rmAddObjectDefConstraint(sheepID, avoidImpassableLand);
			rmAddObjectDefConstraint(sheepID, avoidEdge);
			rmPlaceObjectDefAtLoc(sheepID, 0, 0.50, 0.50);
		}
		
*/	// ****************************************
	
	// Text
	rmSetStatusText("",0.95);
	
	// ************ Sea resources *************
	
	// Fish
	int fishcount = 6;
	int whalecount = 3;
		
	int whaleID=rmCreateObjectDef("whale");
	rmAddObjectDefItem(whaleID, "HumpbackWhale", 1, 3.0);
	rmSetObjectDefMinDistance(whaleID, 0.0);
	rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.30));
	rmAddObjectDefConstraint(whaleID, avoidWhale);
	rmAddObjectDefConstraint(whaleID, avoidLandFar);
	rmAddObjectDefConstraint(whaleID, avoidColonyShipShort);
	rmAddObjectDefConstraint(whaleID, avoidEdge);	
	for (i=0; < whalecount)
	{
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.10, 0.50);
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.90, 0.50);
	}
	
	int fishID = rmCreateObjectDef("fish");
	rmAddObjectDefItem(fishID, "Fishmahi", rmRandInt(3,3), 10.0);
	rmSetObjectDefMinDistance(fishID, 0.0);
	rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(fishID, avoidFish);
	rmAddObjectDefConstraint(fishID, avoidLand);
	rmAddObjectDefConstraint(fishID, avoidColonyShipShort);
	rmAddObjectDefConstraint(fishID, avoidEdge);	
	for (i=0; < fishcount)
	{
		rmPlaceObjectDefAtLoc(fishID, 0, 0.10, 0.50);
		rmPlaceObjectDefAtLoc(fishID, 0, 0.90, 0.50);
	}
	
	// ************ EMBELLISHMENTS ************
	
	// Underbrush desert	
	for (i=0; < 5)
	{	
		int UnderbrusdesertID = rmCreateObjectDef("underbrush desert "+i);
		rmAddObjectDefItem(UnderbrusdesertID, "UnderbrushDesert", rmRandInt(5,5), 8.0); 
		rmSetObjectDefMinDistance(UnderbrusdesertID, 0);
		rmSetObjectDefMaxDistance(UnderbrusdesertID, rmXFractionToMeters(0.5));
		rmAddObjectDefToClass(UnderbrusdesertID, rmClassID("grass"));
		rmAddObjectDefConstraint(UnderbrusdesertID, avoidGrass);
		rmAddObjectDefConstraint(UnderbrusdesertID, avoidImpassableLand);
		rmAddObjectDefConstraint(UnderbrusdesertID, avoidTradeRouteShort);
		rmAddObjectDefConstraint(UnderbrusdesertID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(UnderbrusdesertID, avoidNatives);
		rmAddObjectDefConstraint(UnderbrusdesertID, avoidGoldTypeShort);
		rmAddObjectDefConstraint(UnderbrusdesertID, avoidTownCenter);
//		rmAddObjectDefConstraint(UnderbrusdesertID, avoidForestMin);
		rmAddObjectDefConstraint(UnderbrusdesertID, avoidCentralArea);
		rmPlaceObjectDefAtLoc(UnderbrusdesertID, 0, 0.50, 0.50);
	}
		
/*	// Desert grass	
	for (i=0; < 100)
	{
		int DesertgrassID = rmCreateObjectDef("desert grass "+i);
		rmAddObjectDefItem(DesertgrassID, "DuneGrass", rmRandInt(2,3), 3.0); 
		rmSetObjectDefMinDistance(DesertgrassID, 0);
		rmSetObjectDefMaxDistance(DesertgrassID, rmXFractionToMeters(0.5));
		rmAddObjectDefToClass(DesertgrassID, rmClassID("grass"));
		rmAddObjectDefConstraint(DesertgrassID, avoidGrassShort);
		rmAddObjectDefConstraint(DesertgrassID, avoidImpassableLandShort);
		rmAddObjectDefConstraint(DesertgrassID, avoidTradeRouteShort);
		rmAddObjectDefConstraint(DesertgrassID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(DesertgrassID, avoidNatives);
		rmAddObjectDefConstraint(DesertgrassID, avoidGoldTypeShort);
		rmAddObjectDefConstraint(DesertgrassID, avoidTownCenterShort);
		rmAddObjectDefConstraint(DesertgrassID, avoidCentralArea);
		rmPlaceObjectDefAtLoc(DesertgrassID, 0, 0.50, 0.50);
	}
*/	
	// Underbrush cliff
	for (i=0; < 100)
	{
		int UnderbrushcliffID = rmCreateObjectDef("underbrushcliff "+i);
		rmAddObjectDefItem(UnderbrushcliffID, "UnderbrushTexasGrass", rmRandInt(1,2), 2.0); 
		rmSetObjectDefMinDistance(UnderbrushcliffID, 0);
		rmSetObjectDefMaxDistance(UnderbrushcliffID, rmXFractionToMeters(0.5));
		rmAddObjectDefToClass(UnderbrushcliffID, rmClassID("grass"));
		rmAddObjectDefConstraint(UnderbrushcliffID, avoidGrassShort);
//		rmAddObjectDefConstraint(UnderbrushcliffID, avoidImpassableLandShort);
		rmAddObjectDefConstraint(UnderbrushcliffID, stayInCentralArea);
/*		if (i < 15)
			rmAddObjectDefConstraint(UnderbrushcliffID, stayCliffNorth);
		else if (i < 30)
			rmAddObjectDefConstraint(UnderbrushcliffID, stayCliffSouth);
		else if (i < 45)
			rmAddObjectDefConstraint(UnderbrushcliffID, stayCliff1);
		else if (i < 60)
			rmAddObjectDefConstraint(UnderbrushcliffID, stayCliff2);
		else
			rmAddObjectDefConstraint(UnderbrushcliffID, stayCliff3);
*/		
		rmPlaceObjectDefAtLoc(UnderbrushcliffID, 0, 0.50, 0.50);
	}

	// ****************************************************

	// Text
	rmSetStatusText("",1.00);
		
} // END
	
	