// ESOC KAMCHATKA
// designed by Garja

int PlayerNum=2;
int numPlayer=3;

include "mercenaries.xs";
include "ypAsianInclude.xs";
include "ypKOTHInclude.xs";



// Main entry point for random map script
void main(void)
{
 
	// Text
	// These status text lines are used to manually animate the map generation progress bar
	rmSetStatusText("",0.01); 
	
	// ************************************** GENERAL FEATURES *****************************************
	
	float season = -1;
	season = rmRandFloat(0.1, 1.0);
//	season = 0.555; // <-- TEST
	
	// Picks the map size
	int playerTiles=11000; //12000
	int size=2.0*sqrt(PlayerNum*playerTiles); //2.1
	rmEchoInfo("Map size="+size+"m x "+size+"m");
	rmSetMapSize(size, size);
	
//	rmSetMapElevationParameters(cElevTurbulence,  0.02, 3, 0.4, 3.0); // type, frequency, octaves, persistence, variation 
//	rmSetMapElevationHeightBlend(1);
	
	// Picks a default water height
	if (season >= 0.5)
		rmSetSeaLevel(1.0);	// this is height of river surface compared to surrounding land. River depth is in the river XML.
	else
		rmSetSeaLevel(0.0);

	// Picks default terrain and water
	if (season >= 0.5)
	{
		rmSetBaseTerrainMix("patagonia_grass");
		rmTerrainInitialize("patagonia\ground_grass1_pat", 2.0); //dirt1
	}
	else
	{
		rmSetBaseTerrainMix("rockies_grass_snowa");
		rmTerrainInitialize("rockies\ground2_roc", 2.0);
	}	
	rmSetMapType("himalayas"); //("northwestTerritory");
	rmSetMapType("grass");
	rmSetMapType("land");
//	rmSetLightingSet("nwterritory");
	if (season >= 0.5)
		rmSetLightingSet("himalayas"); //california
	else
		rmSetLightingSet("himalayas"); //great lakes winter
	rmSetSeaType("NW Territory River"); 
	rmSetWindMagnitude(3.0);
	
/*	// Make it rain
	rmSetGlobalRain( 1.0 );
	rmSetGlobalStormLength(1.0, 0.0);
*/
	
	// Make the corners.
	rmSetWorldCircleConstraint(true);

	// Choose Mercs
	chooseMercs();
	
	// Text
	rmSetStatusText("",0.10);
	
	// Set up Natives
	int subCiv0 = -1;
	int subCiv1 = -1;
	subCiv0 = rmGetCivID("Klamath");
	subCiv1 = rmGetCivID("Nootka");
	rmSetSubCiv(0, "Klamath");
	rmSetSubCiv(1, "Nootka");
//	rmEchoInfo("subCiv0 is Klamath "+subCiv0);
//	rmEchoInfo("subCiv1 is Nootka "+subCiv1);
//	string nativeName0 = "native Klamath village";
//	string nativeName1 = "native Nootka village";
	

	//Define some classes. These are used later for constraints.
	int classPlayer = rmDefineClass("player");
	rmDefineClass("classHill");
	int classPatch = rmDefineClass("patch");
	rmDefineClass("starting settlement");
	rmDefineClass("startingUnit");
	int classForest = rmDefineClass("Forest");
	int importantItem = rmDefineClass("importantItem");
	int classNative = rmDefineClass("natives");
	int classCliff = rmDefineClass("classCliff");
	int classGold = rmDefineClass("Gold");
	int classStartingResource = rmDefineClass("startingResource");
	
	// ******************************************************************************************
	
	// Text
	rmSetStatusText("",0.20);
	
	// ************************************* CONTRAINTS *****************************************
	// These are used to have objects and areas avoid each other
   
   
	// Cardinal Directions & Map placement
	int Southeastconstraint = rmCreatePieConstraint("southeastMapConstraint", 0.4, 0.5, 0.0, rmZFractionToMeters(0.50), rmDegreesToRadians(90), rmDegreesToRadians(170));
	int Northwestconstraint = rmCreatePieConstraint("northwestMapConstraint", 0.4, 0.5, 0.0, rmZFractionToMeters(0.50), rmDegreesToRadians(270), rmDegreesToRadians(10));
	int Southwestconstraint = rmCreatePieConstraint("southwestMapConstraint", 0.4, 0.5, 0.0, rmZFractionToMeters(0.50), rmDegreesToRadians(170), rmDegreesToRadians(270));
	int Northeastconstraint = rmCreatePieConstraint("northeastMapConstraint", 0.4, 0.5, 0.0, rmZFractionToMeters(0.50), rmDegreesToRadians(10), rmDegreesToRadians(90));
	int Southnarrowconstraint = rmCreatePieConstraint("SouthstripConstraint", 0.5, 0.5, rmZFractionToMeters(0.15), rmZFractionToMeters(0.50), rmDegreesToRadians(160), rmDegreesToRadians(195));
	int Northnarrowconstraint = rmCreatePieConstraint("NorthstripConstraint", 0.5, 0.5, rmZFractionToMeters(0.15), rmZFractionToMeters(0.50), rmDegreesToRadians(355), rmDegreesToRadians(20));
	
	int Southeastsideconstraint = rmCreatePieConstraint("southeastsideConstraint", 0.5, 0.5, rmXFractionToMeters(0.32), rmXFractionToMeters(0.50), rmDegreesToRadians(90), rmDegreesToRadians(180));
	int Northwestsideconstraint = rmCreatePieConstraint("northwestsideConstraint", 0.5, 0.5, rmXFractionToMeters(0.32), rmXFractionToMeters(0.50), rmDegreesToRadians(268), rmDegreesToRadians(0));
	int Southwestsideconstraint = rmCreatePieConstraint("southwestsideConstraint", 0.5, 0.5, rmXFractionToMeters(0.32), rmXFractionToMeters(0.50), rmDegreesToRadians(180), rmDegreesToRadians(272));
	int Northeastsideconstraint = rmCreatePieConstraint("northeastsideConstraint", 0.5, 0.5, rmXFractionToMeters(0.32), rmXFractionToMeters(0.50), rmDegreesToRadians(0), rmDegreesToRadians(90));
	
	int avoidEdge = rmCreatePieConstraint("Avoid Edge",0.5,0.5, rmXFractionToMeters(0.0),rmXFractionToMeters(0.46), rmDegreesToRadians(0),rmDegreesToRadians(360));
	int avoidCenter = rmCreatePieConstraint("Avoid Center",0.4,0.5,rmXFractionToMeters(0.25), rmXFractionToMeters(0.5), rmDegreesToRadians(0),rmDegreesToRadians(360));
	int stayCenter = rmCreatePieConstraint("Stay Center",0.4,0.5,rmXFractionToMeters(0.0), rmXFractionToMeters(0.14), rmDegreesToRadians(0),rmDegreesToRadians(360));
	int stayEastclose = rmCreatePieConstraint("Stay East Close", 0.5, 0.5, rmZFractionToMeters(0.38), rmZFractionToMeters(0.50), rmDegreesToRadians(55), rmDegreesToRadians(155));
	int stayEastveryclose = rmCreatePieConstraint("Stay East Closer", 0.9, 0.5, 0.0, rmZFractionToMeters(0.12), rmDegreesToRadians(180), rmDegreesToRadians(360));
	int stayEdge = rmCreatePieConstraint("Stay Edge",0.5,0.5,rmXFractionToMeters(0.44), rmXFractionToMeters(0.5), rmDegreesToRadians(0),rmDegreesToRadians(360));
	
	
	// Resource avoidance
//	int avoidForestFar=rmCreateClassDistanceConstraint("forest vs forest", rmClassID("Forest"), 35.0); //15.0
	int avoidForest = rmCreateClassDistanceConstraint("avoid forest", rmClassID("Forest"), 38.0); //15.0
	int avoidForestShort = rmCreateClassDistanceConstraint("avoid forest short", rmClassID("Forest"), 26.0); //15.0
	int avoidForestMin = rmCreateClassDistanceConstraint("avoid forest min", rmClassID("Forest"), 8.0);
	int avoidCaribouFar = rmCreateTypeDistanceConstraint("avoid caribou far", "caribou", 38.0);
	int avoidCaribou = rmCreateTypeDistanceConstraint("avoid caribou", "caribou", 37.0);
	int avoidCaribouShort = rmCreateTypeDistanceConstraint("avoid caribou short", "caribou", 26.0);
	int avoidCaribouMin = rmCreateTypeDistanceConstraint("avoid caribou min", "caribou", 5.0);
	int avoidMuskdeerFar = rmCreateTypeDistanceConstraint("avoid muskdeer far", "ypmuskdeer", 38.0);
	int avoidMuskdeer = rmCreateTypeDistanceConstraint("avoid muskdeer", "ypmuskdeer", 36.0);
	int avoidMuskdeerShort = rmCreateTypeDistanceConstraint("avoid muskdeer short", "ypmuskdeer", 26.0);
	int avoidMuskdeerMin = rmCreateTypeDistanceConstraint("avoid muskdeer min", "ypmuskdeer", 5.0);
	int avoidElk = rmCreateTypeDistanceConstraint("avoid elk", "elk", 42.0);
	int avoidElkShort = rmCreateTypeDistanceConstraint("avoid elk short", "elk", 28.0);
	int avoidIbex = rmCreateTypeDistanceConstraint("avoid ibex", "ypibex", 42.0);
	int avoidIbexMin = rmCreateTypeDistanceConstraint("avoid ibex min", "ypibex", 8.0);
//	int avoidGoldMed = rmCreateTypeDistanceConstraint("coin avoids coin", "gold", 30.0);
	int avoidGoldTypeShort = rmCreateTypeDistanceConstraint("avoid gold type short", "gold", 10.0);
	int avoidGoldType = rmCreateTypeDistanceConstraint("avoid gold type  ", "gold", 20.0);
	int avoidGoldTypeFar = rmCreateTypeDistanceConstraint("avoid gold type  far ", "gold", 35.0);
	int avoidGoldMin = rmCreateClassDistanceConstraint("avoid gold min", rmClassID("Gold"), 20.0);
	int avoidGold = rmCreateClassDistanceConstraint ("avoid gold", rmClassID("Gold"), 48.0);
	int avoidGoldFar = rmCreateClassDistanceConstraint ("avoid gold far", rmClassID("Gold"), 60.0);
	int avoidNuggetShort = rmCreateTypeDistanceConstraint("nugget avoid nugget short", "AbstractNugget", 35.0);
	int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 40.0);
	int avoidTownCenter=rmCreateTypeDistanceConstraint("avoid Town Center", "townCenter", 24.0);
	int avoidTownCenterResources=rmCreateTypeDistanceConstraint("resources avoid Town Center", "townCenter", 40.0);
//	int avoidTownCenterMed=rmCreateTypeDistanceConstraint("resources avoid Town Center farther", "townCenter", 45.0);
	int avoidTownCenterFar=rmCreateTypeDistanceConstraint("avoid Town Center Far", "townCenter", 56.0);
	int avoidNatives = rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 10.0);
	int avoidStartingResources  = rmCreateClassDistanceConstraint("start resources avoid each other", rmClassID("startingResource"), 6.0);
	int avoidGoat = rmCreateTypeDistanceConstraint("goat avoid goat", "ypGoat", 60.0);

	// Avoid impassable land
	int avoidImpassableLand = rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 6.0);
	int avoidImpassableLandLong=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 25.0);
	int avoidImpassableLandShort = rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 3.0);
	int mediumAvoidImpassableLand=rmCreateTerrainDistanceConstraint("medium avoid impassable land", "Land", false, 15.0);
	int mediumShortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("mediumshort avoid impassable land", "Land", false, 10.0);
	int avoidWater = rmCreateTerrainDistanceConstraint("avoid water", "water", true, 12.0);
	int avoidWaterShort = rmCreateTerrainDistanceConstraint("avoid water short", "water", true, 5.0);
	int stayInWater = rmCreateTerrainMaxDistanceConstraint("stay in water ", "water", true, 0);
	int avoidPatch = rmCreateClassDistanceConstraint("patch avoid patch", rmClassID("patch"), 10.0);
	int avoidCliff = rmCreateClassDistanceConstraint("avoid cliff", rmClassID("classCliff"), 10.0);
	int avoidCliffShort = rmCreateClassDistanceConstraint("avoid cliff short", rmClassID("classCliff"), 5.0);

	// Unit avoidance
	int avoidStartingUnits = rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 35.0);
	
	// VP avoidance
	int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 10.0);
	int avoidTradeRouteShort = rmCreateTradeRouteDistanceConstraint("trade route short", 5.0);
	int avoidTradeRouteSocket = rmCreateTypeDistanceConstraint("avoid trade route socket", "socketTradeRoute", 12.0);
	int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 10.0);
   
	
	
	
	// ******************************************************************************************
	
	// ************************************* PLACE PLAYERS *************************************

	int teamZeroCount = rmGetNumberPlayersOnTeam(0);
	int teamOneCount = rmGetNumberPlayersOnTeam(1);
	
	// 2 team and FFA support
	float OneVOnePlacement=rmRandFloat(0.0, 0.9);
	if (PlayerNum == 2)
	{

		if ( OneVOnePlacement < 0.5)
		{
			rmSetPlacementTeam(0);
			rmPlacePlayersLine(0.64, 0.20, 0.4, 0.20, 0, 0.0); // 0.72, 0.20 disregard line end

			rmSetPlacementTeam(1);
			rmPlacePlayersLine(0.64, 0.80, 0.4, 0.8, 0, 0.0); // 0.72, 0.80 disregard line end
		}
		else
		{
			rmSetPlacementTeam(0);
			rmPlacePlayersLine(0.64, 0.80, 0.4, 0.8, 0, 0.0);

			rmSetPlacementTeam(1);
			rmPlacePlayersLine(0.64, 0.20, 0.4, 0.20, 0, 0.0);
		}
		
	}
/*	// Team placement
	else if ( PlayerNum == 2 && teamZeroCount == teamOneCount)
	{

		rmSetPlacementTeam(0);
		rmSetTeamSpacingModifier(0.25);
		rmPlacePlayersLine(0.2, 0.2, 0.5, 0.2, 0, 0.0);

		rmSetPlacementTeam(1);
		rmSetTeamSpacingModifier(0.25);
		rmPlacePlayersLine(0.8, 0.8, 0.5, 0.8, 0, 0.0);
	
	}
	// FFA support
	else if (PlayerNum > 2)
	{
      bool southSide = true;

      float spacingIncrement = (0.35 / (PlayerNum / 2));
      float spacingSouth = 0;
      float spacingNorth = 0;
      
      float southStart = 0.45;
      float southEnd = 0.82;
      float northStart = 0.95;
      float northEnd = 0.32;

      for (i = 0; < PlayerNum)
      {
         rmEchoInfo("i = "+i);
         if (southSide == true)
         {
            rmSetPlacementTeam(i);
            rmSetPlacementSection((southStart + spacingSouth), southEnd);
	         rmSetTeamSpacingModifier(0.25);
	         rmPlacePlayersCircular(0.4, 0.4, 0);
            spacingSouth = spacingSouth + spacingIncrement;
         }
         else
         {
            rmSetPlacementTeam(i);
            rmSetPlacementSection((northStart + spacingNorth), northEnd);
	         rmSetTeamSpacingModifier(0.25);
	         rmPlacePlayersCircular(0.4, 0.4, 0);
            spacingNorth = spacingNorth + spacingIncrement;
         }
         if (southSide == true)
         {
            southSide = false;
         }
         else
         {
            southSide = true;
         }
      }
   }
   else 
   {
      if (teamZeroCount < teamOneCount)
      {
         rmSetPlacementTeam(0);
         rmSetPlacementSection(0.55, 0.75);
		   rmSetTeamSpacingModifier(0.35 / teamZeroCount);
		   rmPlacePlayersCircular(0.4, 0.4, 0);

		   rmSetPlacementTeam(1);
         rmSetPlacementSection(0.95, 0.32);
		   rmSetTeamSpacingModifier(0.35 / teamOneCount);
		   rmPlacePlayersCircular(0.4, 0.4, 0);
      }
      else 
      {
         rmSetPlacementTeam(0);
         rmSetPlacementSection(0.45, 0.82);
		   rmSetTeamSpacingModifier(0.35 / teamZeroCount);
		   rmPlacePlayersCircular(0.4, 0.4, 0);

		   rmSetPlacementTeam(1);
         rmSetPlacementSection(0.0, 0.2);
		   rmSetTeamSpacingModifier(0.35 / teamOneCount);
		   rmPlacePlayersCircular(0.4, 0.4, 0);
      }
   }
*/
	// *******************************************************************************************
   
	// Text
	rmSetStatusText("",0.30);
	
	// ***************************************** MAP LAYOUT *******************************************
	
	// Big continent
	if (season >= 0.5)
	{
		int bigContinentID = rmCreateArea("big continent");
		rmSetAreaSize(bigContinentID, 1.00, 1.00); 
		rmSetAreaWarnFailure(bigContinentID, false);
		rmSetAreaCoherence(bigContinentID, 1.0);
		rmSetAreaLocation(bigContinentID, 0.5, 0.5);
		rmSetAreaElevationType(bigContinentID, cElevTurbulence);
		rmSetAreaElevationVariation(bigContinentID, 3.0);
		rmSetAreaElevationMinFrequency(bigContinentID, 0.1);
		rmSetAreaElevationOctaves(bigContinentID, 2);
		rmSetAreaElevationPersistence(bigContinentID, 0.30);
//		rmSetAreaElevationNoiseBias(bigContinentID, 1);
		rmSetAreaBaseHeight(bigContinentID, 1.0); 
	//	rmBuildArea(bigContinentID);
	}
	
	// Center
	int CenterID = rmCreateArea("map center");
	rmSetAreaSize(CenterID, 0.01, 0.01); 
	rmSetAreaWarnFailure(CenterID, false);
	rmSetAreaCoherence(CenterID, 1.0);
	rmSetAreaLocation(CenterID, 0.4, 0.5);
	rmBuildArea(CenterID);
	
	//Northwest plateau
	int plateauID1 =rmCreateArea("Northwest Plateau");
	rmSetAreaLocation(plateauID1, 0.23, 0.90);
	rmSetAreaSize(plateauID1, 0.13, 0.13); 
	rmSetAreaWarnFailure(plateauID1, false);
	rmSetAreaObeyWorldCircleConstraint(plateauID1, false);
	rmSetAreaCoherence(plateauID1, 0.8);
	rmSetAreaMinBlobs(plateauID1, 2);
	rmSetAreaMaxBlobs(plateauID1, 2);
	rmSetAreaElevationType(plateauID1, cElevTurbulence);
	rmSetAreaBaseHeight(plateauID1, 4.5); // 14
	rmSetAreaElevationVariation(plateauID1, 2.0);
	rmSetAreaElevationMinFrequency(plateauID1, 0.1);
	rmSetAreaElevationOctaves(plateauID1, 2);
	rmSetAreaElevationPersistence(plateauID1, 0.30);
	rmSetAreaHeightBlend(plateauID1, 1.6);
	
	//Northeast plateau
	int plateauID2 =rmCreateArea("Northeast Plateau");
	rmSetAreaLocation(plateauID2, 0.77, 0.90);
	rmSetAreaSize(plateauID2, 0.13, 0.13); 
	rmSetAreaWarnFailure(plateauID2, false);
	rmSetAreaObeyWorldCircleConstraint(plateauID2, false);
	rmSetAreaCoherence(plateauID2, 0.8);
	rmSetAreaMinBlobs(plateauID2, 2);
	rmSetAreaMaxBlobs(plateauID2, 2);
	rmSetAreaElevationType(plateauID2, cElevTurbulence);
	rmSetAreaBaseHeight(plateauID2, 4.5); // 14
	rmSetAreaElevationVariation(plateauID2, 2.0);
	rmSetAreaElevationMinFrequency(plateauID2, 0.1);
	rmSetAreaElevationOctaves(plateauID2, 2);
	rmSetAreaElevationPersistence(plateauID2, 0.30);
	rmSetAreaHeightBlend(plateauID2, 1.6);
	
	//Southeast plateau
	int plateauID3 =rmCreateArea("Souttheast Plateau");
	rmSetAreaLocation(plateauID3, 0.77, 0.10);
	rmSetAreaSize(plateauID3, 0.13, 0.13); 
	rmSetAreaWarnFailure(plateauID3, false);
	rmSetAreaObeyWorldCircleConstraint(plateauID3, false);
	rmSetAreaCoherence(plateauID3, 0.8);
	rmSetAreaMinBlobs(plateauID3, 2);
	rmSetAreaMaxBlobs(plateauID3, 2);
	rmSetAreaElevationType(plateauID3, cElevTurbulence);
	rmSetAreaBaseHeight(plateauID3, 4.5); // 14
	rmSetAreaElevationVariation(plateauID3, 2.0);
	rmSetAreaElevationMinFrequency(plateauID3, 0.1);
	rmSetAreaElevationOctaves(plateauID3, 2);
	rmSetAreaElevationPersistence(plateauID3, 0.30);
	rmSetAreaHeightBlend(plateauID3, 1.6);
	
	//Souththwest plateau
	int plateauID4 =rmCreateArea("Southwest Plateau");
	rmSetAreaLocation(plateauID4, 0.23, 0.10);
	rmSetAreaSize(plateauID4, 0.13, 0.13); 
	rmSetAreaWarnFailure(plateauID4, false);
	rmSetAreaObeyWorldCircleConstraint(plateauID4, false);
	rmSetAreaCoherence(plateauID4, 0.8);
	rmSetAreaMinBlobs(plateauID4, 2);
	rmSetAreaMaxBlobs(plateauID4, 2);	
	rmSetAreaElevationType(plateauID4, cElevTurbulence);
	rmSetAreaBaseHeight(plateauID4, 4.5); // 14
	rmSetAreaElevationVariation(plateauID4, 2.0);
	rmSetAreaElevationMinFrequency(plateauID4, 0.1);
	rmSetAreaElevationOctaves(plateauID4, 2);
	rmSetAreaElevationPersistence(plateauID4, 0.30);
	rmSetAreaHeightBlend(plateauID4, 1.6);
	
	rmBuildAllAreas();
		
	//Northwest quarter
	int quarterID1 =rmCreateArea("Northwest quarter");
	rmSetAreaLocation(quarterID1, 0.25, 0.75);
	rmSetAreaSize(quarterID1, 0.14, 0.14); 
	rmSetAreaWarnFailure(quarterID1, false);
	rmSetAreaObeyWorldCircleConstraint(quarterID1, false);
	rmSetAreaCoherence(quarterID1, 1.0);
	rmBuildArea(quarterID1);
	
	//Northeast quarter
	int quarterID2 =rmCreateArea("Northeast quarter");
	rmSetAreaLocation(quarterID2, 0.74, 0.76);
	rmSetAreaSize(quarterID2, 0.14, 0.14); 
	rmSetAreaWarnFailure(quarterID2, false);
	rmSetAreaObeyWorldCircleConstraint(quarterID2, false);
	rmSetAreaCoherence(quarterID2, 0.8);
	rmBuildArea(quarterID2);
	
	//Southeast quarter
	int quarterID3 =rmCreateArea("Souttheast quarter");
	rmSetAreaLocation(quarterID3, 0.74, 0.24);
	rmSetAreaSize(quarterID3, 0.14, 0.14); 
	rmSetAreaWarnFailure(quarterID3, false);
	rmSetAreaObeyWorldCircleConstraint(quarterID3, false);
	rmSetAreaCoherence(quarterID3, 0.8);
	rmBuildArea(quarterID3);
	
	//Souththwest quarter
	int quarterID4 =rmCreateArea("Southwest quarter");
	rmSetAreaLocation(quarterID4, 0.25, 0.25);
	rmSetAreaSize(quarterID4, 0.14, 0.14); 
	rmSetAreaWarnFailure(quarterID4, false);
	rmSetAreaObeyWorldCircleConstraint(quarterID4, false);
	rmSetAreaCoherence(quarterID4, 1.0);
	rmBuildArea(quarterID4);

	//Rivers
	if (season >= 0.5)
	{
		//river1
		int riverID1 = rmRiverCreate(-1, "Northwest Territory Water", 5, 5, 5, 5); //  (-1, "Northwest Territory Water", 5, 6, 5, 6)
		rmRiverAddWaypoint(riverID1, 1.0, 0.49); // 0.48
		rmRiverAddWaypoint(riverID1, 0.70, 0.49);
		rmRiverAddWaypoint(riverID1, 0.4, 0.3); // 0.3
		rmRiverAddWaypoint(riverID1, 0.15, 0.49);
		rmRiverAddWaypoint(riverID1, 0.0, 0.49);
	//	rmRiverSetBankNoiseParams(riverID1, 0.07, 2, 1.5, 20.0, 0.667, 5.0);
		
		//river2
		int riverID2 = rmRiverCreate(-1, "Northwest Territory Water", 5, 5, 5, 5); //  (-1, "Northwest Territory Water", 5, 6, 5, 6);
		rmRiverAddWaypoint(riverID2, 1.0, 0.51); // 0.52
		rmRiverAddWaypoint(riverID2, 0.70, 0.51);
		rmRiverAddWaypoint(riverID2, 0.4, 0.7); // 0.7
		rmRiverAddWaypoint(riverID2, 0.15, 0.51);
		rmRiverAddWaypoint(riverID2, 0.0, 0.51);
	//	rmRiverSetBankNoiseParams(riverID2, 0.07, 2, 1.5, 20.0, 0.667, 5.0);


		//shallows
	//	float mobileshallow = rmRandFloat(0.0, 1.0);
		rmRiverSetShallowRadius(riverID1, 11);
		rmRiverSetShallowRadius(riverID2, 11);
	//	if (mobileshallow < 0.5) 
	//	{
	//		rmRiverAddShallow(riverID1, 0.15); 	
	//		rmRiverAddShallow(riverID2, 0.15);
	//	}
	//	else
	//	{
			rmRiverAddShallow(riverID1, 0.10);
			rmRiverAddShallow(riverID2, 0.10);
			rmRiverAddShallow(riverID1, 0.32); //30
			rmRiverAddShallow(riverID2, 0.32); //30
	//	}	
		rmRiverAddShallow(riverID1, 0.55); //48
		rmRiverAddShallow(riverID2, 0.55); //49
		rmRiverAddShallow(riverID1, 0.84);
		rmRiverAddShallow(riverID2, 0.84);
		
		rmRiverBuild(riverID1);
		rmRiverBuild(riverID2);
	}
	else
	{
		int frozenriver1ID = rmCreateArea("frozen river1");
		rmSetAreaLocation(frozenriver1ID, 1.00, 0.49);
		rmAddAreaInfluenceSegment(frozenriver1ID, 1.00, 0.49, 0.70, 0.49);
		rmAddAreaInfluenceSegment(frozenriver1ID, 0.70, 0.49, 0.40, 0.30);
		rmAddAreaInfluenceSegment(frozenriver1ID, 0.40, 0.30, 0.15, 0.49); // 0.3
		rmAddAreaInfluenceSegment(frozenriver1ID, 0.15, 0.49, 0.00, 0.49);
		rmSetAreaSize(frozenriver1ID, 0.065, 0.065);
		rmSetAreaMix(frozenriver1ID, "great_lakes_ice");
		rmSetAreaBaseHeight(frozenriver1ID, 0.5); 
		rmSetAreaElevationVariation(frozenriver1ID, 0.0);
//		rmSetAreaTerrainType(frozenriver1ID, "great_lakes\ground_ice1_gl");
		rmSetAreaCoherence(frozenriver1ID, 0.8); 
		rmSetAreaSmoothDistance(frozenriver1ID, 10);
		rmSetAreaObeyWorldCircleConstraint(frozenriver1ID, false);
		rmBuildArea(frozenriver1ID); 
		
		int frozenriver2ID = rmCreateArea("frozen river2");
		rmSetAreaLocation(frozenriver2ID, 1.00, 0.51);
		rmAddAreaInfluenceSegment(frozenriver2ID, 1.00, 0.51, 0.70, 0.51);
		rmAddAreaInfluenceSegment(frozenriver2ID, 0.70, 0.51, 0.40, 0.70);
		rmAddAreaInfluenceSegment(frozenriver2ID, 0.40, 0.70, 0.15, 0.51); // 0.3
		rmAddAreaInfluenceSegment(frozenriver2ID, 0.15, 0.51, 0.00, 0.51);
		rmSetAreaSize(frozenriver2ID, 0.065, 0.065);
		rmSetAreaMix(frozenriver2ID, "great_lakes_ice");
		rmSetAreaBaseHeight(frozenriver2ID, 0.5); 
		rmSetAreaElevationVariation(frozenriver2ID, 0.0);
//		rmSetAreaTerrainType(frozenriver2ID, "great_lakes\ground_ice1_gl");
		rmSetAreaCoherence(frozenriver2ID, 0.8); 
		rmSetAreaSmoothDistance(frozenriver2ID, 10);
		rmSetAreaObeyWorldCircleConstraint(frozenriver2ID, false);
		rmBuildArea(frozenriver2ID); 
		
		int avoidFrozenRiver1 = rmCreateAreaDistanceConstraint("avoid frozen river 1", frozenriver1ID, 7);
		int avoidFrozenRiver2 = rmCreateAreaDistanceConstraint("avoid frozen river 2", frozenriver2ID, 7);
		int avoidFrozenRiver1Short = rmCreateAreaDistanceConstraint("avoid frozen river 1 short", frozenriver1ID, 3);
		int avoidFrozenRiver2Short = rmCreateAreaDistanceConstraint("avoid frozen river 2 short", frozenriver2ID, 3);
		int stayNearRiver1 = rmCreateAreaMaxDistanceConstraint("stay near frozen river 1", frozenriver1ID, 5);
		int stayNearRiver2 = rmCreateAreaMaxDistanceConstraint("stay near frozen river 2", frozenriver2ID, 5);
		
		//trade route passes
		int traderoutepass1ID = rmCreateArea("trade route pass 1");
		rmSetAreaLocation(traderoutepass1ID, 0.40, 0.30);
		rmAddAreaInfluenceSegment(traderoutepass1ID, 0.40, 0.26, 0.40, 0.34);
		rmSetAreaSize(traderoutepass1ID, 0.01, 0.01);
		rmSetAreaCoherence(traderoutepass1ID, 1.0); 
		rmSetAreaBaseHeight(traderoutepass1ID, 2.0); 
		rmSetAreaMix(traderoutepass1ID, "rockies_grass_snowa");
		rmBuildArea(traderoutepass1ID); 
		
		int traderoutepass2ID = rmCreateArea("trade route pass 2");
		rmSetAreaLocation(traderoutepass2ID, 0.40, 0.70);
		rmAddAreaInfluenceSegment(traderoutepass2ID, 0.40, 0.66, 0.40, 0.74);
		rmSetAreaSize(traderoutepass2ID, 0.01, 0.01);
		rmSetAreaCoherence(traderoutepass2ID, 1.0); 
		rmSetAreaBaseHeight(traderoutepass2ID, 2.0); 
		rmSetAreaMix(traderoutepass2ID, "rockies_grass_snowa");
		rmBuildArea(traderoutepass2ID); 
		
		//ice patches to fix river
		int icepatch1ID = rmCreateArea("ice patch 1");
		rmSetAreaLocation(icepatch1ID, 1.00, 0.50);
		rmSetAreaSize(icepatch1ID, 0.004, 0.004);
		rmSetAreaCoherence(icepatch1ID, 1.0); 
		rmSetAreaBaseHeight(icepatch1ID, 0.5); 
		rmSetAreaMix(icepatch1ID, "great_lakes_ice");
		rmSetAreaObeyWorldCircleConstraint(icepatch1ID, false);
		rmBuildArea(icepatch1ID); 
		
		int icepatch2ID = rmCreateArea("ice patch 2");
		rmSetAreaLocation(icepatch2ID, 0.00, 0.50);
		rmSetAreaSize(icepatch2ID, 0.004, 0.004);
		rmSetAreaCoherence(icepatch2ID, 1.0); 
		rmSetAreaBaseHeight(icepatch2ID, 0.5); 
		rmSetAreaMix(icepatch2ID, "great_lakes_ice");
		rmSetAreaObeyWorldCircleConstraint(icepatch2ID, false);
		rmBuildArea(icepatch2ID); 
		
/*		float variance1 = -1;
		float variance2 = -1;
		
		int icehole1ID = rmRiverCreate(-1, "Great Lakes Ice", 4, 4, 4, 4); //  (-1, "Northwest Territory Water", 5, 6, 5, 6)
		variance1 = rmRandFloat(-0.05, 0.05);
		variance2 = rmRandFloat(-0.03, 0.03);
		rmRiverAddWaypoint(icehole1ID, 0.88+variance1+variance2, rmRandFloat(0.49, 0.51)); // 0.48
		variance2 = rmRandFloat(-0.03, 0.03);
		rmRiverAddWaypoint(icehole1ID, 0.82+variance1+variance2, rmRandFloat(0.49, 0.51));
		rmRiverBuild(icehole1ID);
		
		int icehole2ID = rmRiverCreate(-1, "Great Lakes Ice", 4, 4, 4, 4); //  (-1, "Northwest Territory Water", 5, 6, 5, 6)
		variance1 = rmRandFloat(-0.04, 0.04);
		variance2 = rmRandFloat(-0.02, 0.02);
		rmRiverAddWaypoint(icehole2ID, 0.06+variance1+variance2, rmRandFloat(0.49, 0.51)); // 0.48
		variance2 = rmRandFloat(-0.02, 0.02);
		rmRiverAddWaypoint(icehole2ID, 0.12+variance1+variance2, rmRandFloat(0.49, 0.51));
		rmRiverBuild(icehole2ID);
		
		int icehole3ID = rmRiverCreate(-1, "Great Lakes Ice", 4, 4, 3, 3); //  (-1, "Northwest Territory Water", 5, 6, 5, 6)
		variance1 = rmRandFloat(-0.05, 0.05);
		variance2 = rmRandFloat(-0.03, 0.03);
		rmRiverAddWaypoint(icehole3ID, 0.25, 0.43); // 0.48
		variance2 = rmRandFloat(-0.03, 0.03);
		rmRiverAddWaypoint(icehole3ID, 0.35, 0.35);
		rmRiverBuild(icehole3ID);
*/
	}
	
	// Cliffs
	for (i = 0;  < 4)
	{
		int CliffID = rmCreateArea("cliff"+i);
		rmSetAreaSize(CliffID, rmAreaTilesToFraction(110), rmAreaTilesToFraction(110));
		rmSetAreaWarnFailure(CliffID, false);
		rmSetAreaCoherence(CliffID, 0.5);
		rmSetAreaSmoothDistance(CliffID, 4);
		if (season >= 0.5)
			rmSetAreaCliffType(CliffID, "patagonia"); 
		else
			rmSetAreaCliffType(CliffID, "araucania south"); 
		rmSetAreaCliffEdge(CliffID, 1, 1.0, 0.0, 0.0, 0);
		rmSetAreaCliffHeight(CliffID, 4.0, 0.0, 1.0);
		rmSetAreaCliffPainting(CliffID, false, false, true);
		rmAddAreaToClass(CliffID, rmClassID("classCliff"));
		if (i == 0)
			rmSetAreaLocation(CliffID, 0.82, 0.32);
		else if (i == 1)
			rmSetAreaLocation(CliffID, 0.82, 0.68);
		else if (i == 2)
			rmSetAreaLocation(CliffID, 0.26, 0.21);
		else
			rmSetAreaLocation(CliffID, 0.26, 0.79);
		rmBuildArea(CliffID);
	}
	
	// *****************************************************************************************************

	// Text
	rmSetStatusText("",0.40);
	
	// ****************************************** TRADE ROUTE **********************************************
	
	int tradeRouteID = rmCreateTradeRoute();
	int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
	rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	rmSetObjectDefAllowOverlap(socketID, true);
	rmSetObjectDefMinDistance(socketID, 0.0);
	rmSetObjectDefMaxDistance(socketID, 5.0);

	
	rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
	rmAddTradeRouteWaypoint(tradeRouteID, 0.52, 0.00); //
	rmAddTradeRouteWaypoint(tradeRouteID, 0.45, 0.11); // 
	rmAddTradeRouteWaypoint(tradeRouteID, 0.42, 0.20); //0.54, 0.20
	rmAddTradeRouteWaypoint(tradeRouteID, 0.42, 0.50); //0.45, 0.50
	rmAddTradeRouteWaypoint(tradeRouteID, 0.42, 0.76); 
	rmAddTradeRouteWaypoint(tradeRouteID, 0.45, 0.89); // 
	rmAddTradeRouteWaypoint(tradeRouteID, 0.52, 1.00); // 
	
	bool placedTradeRouteA = rmBuildTradeRoute(tradeRouteID, "water");
//	if(placedTradeRouteA == false)
//	rmEchoError("Failed to place trade route 1");
//	rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
	vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.02);
	rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.49);
	rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.94);
	rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	
	// ******************************************************************************************************
	
/*	// ******************************************** NATIVES *************************************************

	int nativeID0 = -1;
    int nativeID1 = -1;
		
	nativeID0 = rmCreateGrouping("Klamath village 3", "native klamath village "+1);
    rmSetGroupingMinDistance(nativeID0, 0.0);
    rmSetGroupingMaxDistance(nativeID0, 0.00);
//	rmAddGroupingConstraint(nativeID0, avoidImpassableLand);
	rmAddGroupingToClass(nativeID0, rmClassID("natives"));
    rmAddGroupingToClass(nativeID0, rmClassID("importantItem"));
//	rmAddGroupingConstraint(nativeID0, avoidNatives);
	rmPlaceGroupingAtLoc(nativeID0, 0, 0.84, 0.30);
	rmPlaceGroupingAtLoc(nativeID0, 0, 0.84, 0.72);
	
	nativeID1 = rmCreateGrouping("nootka village 4", "native nootka village "+1);
    rmSetGroupingMinDistance(nativeID1, 0.0);
    rmSetGroupingMaxDistance(nativeID1, 0.00);
//	rmAddGroupingConstraint(nativeID1, avoidImpassableLand);
	rmAddGroupingToClass(nativeID1, rmClassID("natives"));
    rmAddGroupingToClass(nativeID1, rmClassID("importantItem"));
//	rmAddGroupingConstraint(nativeID1, avoidNatives);
	rmPlaceGroupingAtLoc(nativeID1, 0, 0.30, 0.20); // 0.28, 0.25
	rmPlaceGroupingAtLoc(nativeID1, 0, 0.30, 0.80); // 0.28, 0.75
	
*/	// ******************************************************************************************************
	
	// Text
	rmSetStatusText("",0.50);
	
	// ************************************ PLAYER STARTING RESOURCES ***************************************

	// ***** Define *****
	
	// Town center & units
	int TCID = rmCreateObjectDef("player TC");
	int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	if (rmGetNomadStart())
	{
		rmAddObjectDefItem(TCID, "CoveredWagon", 1, 0.0);
	}
	else
	{
	rmAddObjectDefItem(TCID, "TownCenter", 1, 0.0);
	rmAddObjectDefToClass(TCID, classStartingResource);
	}
	rmSetObjectDefMinDistance(TCID, 0.0);
	rmSetObjectDefMaxDistance(TCID, 0.0);
	
	// Starting mines
	int playergoldID = rmCreateObjectDef("player mine");
	rmAddObjectDefItem(playergoldID, "mine", 1, 0);
	rmSetObjectDefMinDistance(playergoldID, 12.0);
	rmSetObjectDefMaxDistance(playergoldID, 20.0);
	rmAddObjectDefToClass(playergoldID, classStartingResource);
	rmAddObjectDefToClass(playergoldID, classGold);
	rmAddObjectDefConstraint(playergoldID, avoidGoldTypeFar);
	rmAddObjectDefConstraint(playergoldID, avoidTradeRoute);
	rmAddObjectDefConstraint(playergoldID, avoidImpassableLand);
	rmAddObjectDefConstraint(playergoldID, avoidNatives);
	rmAddObjectDefConstraint(playergoldID, avoidStartingResources);
	
	// 2nd mine
	int playergold2ID = rmCreateObjectDef("player second mine");
	rmAddObjectDefItem(playergold2ID, "mine", 1, 0);
	rmSetObjectDefMinDistance(playergold2ID, 70.0); //58
	rmSetObjectDefMaxDistance(playergold2ID, 70.0); //62
//	rmAddObjectDefToClass(playergold2ID, classStartingResource);
	rmAddObjectDefToClass(playergold2ID, classGold);
	rmAddObjectDefConstraint(playergold2ID, avoidTradeRoute);
	rmAddObjectDefConstraint(playergold2ID, avoidImpassableLand);
	rmAddObjectDefConstraint(playergold2ID, avoidCliff);
	rmAddObjectDefConstraint(playergold2ID, avoidNatives);
	rmAddObjectDefConstraint(playergold2ID, avoidGold);
	rmAddObjectDefConstraint(playergold2ID, avoidStartingResources);
	rmAddObjectDefConstraint(playergold2ID, avoidTownCenterFar);
	rmAddObjectDefConstraint(playergold2ID, stayEastclose);
	if (season < 0.5)
	{
		rmAddObjectDefConstraint(playergold2ID, avoidFrozenRiver1);
		rmAddObjectDefConstraint(playergold2ID, avoidFrozenRiver2);
	}
	
	// Starting herd
	int playerbighornID = rmCreateObjectDef("starting bighorn sheep");
	rmAddObjectDefItem(playerbighornID, "bighornsheep", 3, 2.0);
	rmSetObjectDefMinDistance(playerbighornID, 12.0);
	rmSetObjectDefMaxDistance(playerbighornID, 18.0);
	rmSetObjectDefCreateHerd(playerbighornID, true);
	rmAddObjectDefToClass(playerbighornID, classStartingResource);
	rmAddObjectDefConstraint(playerbighornID, avoidTradeRoute);
	rmAddObjectDefConstraint(playerbighornID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerbighornID, avoidNatives);
	rmAddObjectDefConstraint(playerbighornID, avoidStartingResources);
	
	// Closest tree
	int playercloseTreeID = rmCreateObjectDef("player tree close");
    rmAddObjectDefItem(playercloseTreeID, "TreeNorthwestTerritory", rmRandInt(1,1), 1.0);
    rmSetObjectDefMinDistance(playercloseTreeID, 8);
    rmSetObjectDefMaxDistance(playercloseTreeID, 10);
//	rmAddObjectDefToClass(playercloseTreeID, classStartingResource);
//	rmAddObjectDefConstraint(playercloseTreeID, avoidForest);
	rmAddObjectDefConstraint(playercloseTreeID, avoidTradeRoute);
    rmAddObjectDefConstraint(playercloseTreeID, avoidImpassableLand);
//	rmAddObjectDefConstraint(playercloseTreeID, avoidStartingResources);
	
	// Starting trees
	int playerTreeID = rmCreateObjectDef("player trees");
	if (season >= 0.5)
		rmAddObjectDefItem(playerTreeID, "TreeNorthwestTerritory", rmRandInt(6,6), 4.0);
	else
		rmAddObjectDefItem(playerTreeID, "TreeGreatLakesSnow", rmRandInt(6,6), 4.0);
    rmSetObjectDefMinDistance(playerTreeID, 12);
    rmSetObjectDefMaxDistance(playerTreeID, 18);
	rmAddObjectDefToClass(playerTreeID, classStartingResource);
	rmAddObjectDefToClass(playerTreeID, classForest);
	rmAddObjectDefConstraint(playerTreeID, avoidForestShort);
	rmAddObjectDefConstraint(playerTreeID, avoidTradeRoute);
    rmAddObjectDefConstraint(playerTreeID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerTreeID, avoidStartingResources);
	
	// 2nd herd
	int playerCaribouID = rmCreateObjectDef("player caribou");
	if (season >= 0.5)
		rmAddObjectDefItem(playerCaribouID, "caribou", rmRandInt(7,7), 6.0);
	else
		rmAddObjectDefItem(playerCaribouID, "ypmuskdeer", rmRandInt(7,7), 6.0);
    rmSetObjectDefMinDistance(playerCaribouID, 20);
    rmSetObjectDefMaxDistance(playerCaribouID, 26);
	rmAddObjectDefToClass(playerCaribouID, classStartingResource);
	rmSetObjectDefCreateHerd(playerCaribouID, true);
	rmAddObjectDefConstraint(playerCaribouID, avoidCaribou); //Short
	rmAddObjectDefConstraint(playerCaribouID, avoidMuskdeer);
	rmAddObjectDefConstraint(playerCaribouID, avoidTradeRoute);
	rmAddObjectDefConstraint(playerCaribouID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerCaribouID, avoidNatives);
	rmAddObjectDefConstraint(playerCaribouID, avoidStartingResources);
	if (season < 0.5)
	{
		rmAddObjectDefConstraint(playerCaribouID, avoidFrozenRiver1);
		rmAddObjectDefConstraint(playerCaribouID, avoidFrozenRiver2);
	}
	
	// 3rd herd
	int CaribouID5= rmCreateObjectDef("caribou 3rd");
    if (season >= 0.5)
		rmAddObjectDefItem(CaribouID5, "caribou", rmRandInt(7,7), 6.0);
	else
		rmAddObjectDefItem(CaribouID5, "ypmuskdeer", rmRandInt(7,7), 6.0);
	rmSetObjectDefMinDistance(CaribouID5, 44);
    rmSetObjectDefMaxDistance(CaribouID5, 48);
	rmSetObjectDefCreateHerd(CaribouID5, true);
	rmAddObjectDefConstraint(CaribouID5, avoidCaribou); //Short
	rmAddObjectDefConstraint(CaribouID5, avoidMuskdeer);
//	rmAddObjectDefConstraint(CaribouID5, avoidTradeRouteShort);
	rmAddObjectDefConstraint(CaribouID5, avoidTradeRouteSocket);
	rmAddObjectDefConstraint(CaribouID5, avoidImpassableLand);
	rmAddObjectDefConstraint(CaribouID5, avoidCliff);
	rmAddObjectDefConstraint(CaribouID5, avoidNatives);
	rmAddObjectDefConstraint(CaribouID5, avoidStartingResources);
//	rmAddObjectDefConstraint(CaribouID5, avoidTownCenterResources);
	rmAddObjectDefConstraint(CaribouID5, avoidGoldTypeShort);
//	rmAddObjectDefConstraint(CaribouID5, avoidForestMin);
	if (season < 0.5)
	{
		rmAddObjectDefConstraint(CaribouID5, avoidFrozenRiver1);
		rmAddObjectDefConstraint(CaribouID5, avoidFrozenRiver2);
	}
	
	// 4th herd
	int CaribouID6= rmCreateObjectDef("caribou 4th");
    if (season >= 0.5)
		rmAddObjectDefItem(CaribouID6, "caribou", rmRandInt(7,7), 6.0);
	else
		rmAddObjectDefItem(CaribouID6, "ypmuskdeer", rmRandInt(7,7), 6.0);
	rmSetObjectDefMinDistance(CaribouID6, 44);
    rmSetObjectDefMaxDistance(CaribouID6, 48);
	rmSetObjectDefCreateHerd(CaribouID6, true);
	rmAddObjectDefConstraint(CaribouID6, avoidCaribou); //Short
	rmAddObjectDefConstraint(CaribouID6, avoidMuskdeer);
//	rmAddObjectDefConstraint(CaribouID6, avoidTradeRouteShort);
	rmAddObjectDefConstraint(CaribouID6, avoidTradeRouteSocket);
	rmAddObjectDefConstraint(CaribouID6, avoidImpassableLand);
	rmAddObjectDefConstraint(CaribouID6, avoidCliff);
	rmAddObjectDefConstraint(CaribouID6, avoidNatives);
	rmAddObjectDefConstraint(CaribouID6, avoidStartingResources);
//	rmAddObjectDefConstraint(CaribouID6, avoidTownCenterResources);
	rmAddObjectDefConstraint(CaribouID6, avoidGoldTypeShort);
//	rmAddObjectDefConstraint(CaribouID6, avoidForestMin);
	if (season < 0.5)
	{
		rmAddObjectDefConstraint(CaribouID6, avoidFrozenRiver1);
		rmAddObjectDefConstraint(CaribouID6, avoidFrozenRiver2);
	}
	
	// Starting treasures
	int playerNuggetID = rmCreateObjectDef("player nugget"); 
	rmAddObjectDefItem(playerNuggetID, "Nugget", 1, 0.0);
	rmSetNuggetDifficulty(1, 1);
	rmSetObjectDefMinDistance(playerNuggetID, 20.0);
	rmSetObjectDefMaxDistance(playerNuggetID, 30.0);
	rmAddObjectDefToClass(playerNuggetID, classStartingResource);
	rmAddObjectDefConstraint(playerNuggetID, avoidTradeRoute);
	rmAddObjectDefConstraint(playerNuggetID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerNuggetID, avoidNatives);
	rmAddObjectDefConstraint(playerNuggetID, avoidStartingResources);
	rmAddObjectDefConstraint(playerNuggetID, avoidNuggetShort);
	rmAddObjectDefConstraint(playerNuggetID, avoidEdge);
	if (season < 0.5)
	{
		rmAddObjectDefConstraint(playerNuggetID, avoidFrozenRiver1);
		rmAddObjectDefConstraint(playerNuggetID, avoidFrozenRiver2);
	}
	int nugget0count = rmRandInt (1,2);
		
	// ***** Place *****
	
	for(i=1; <numPlayer)
	{
		rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));

		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playergoldID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
//		rmPlaceObjectDefAtLoc(playercloseTreeID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playergoldID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTreeID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTreeID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerbighornID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerbighornID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playergold2ID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerNuggetID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		if (nugget0count == 2)
			rmPlaceObjectDefAtLoc(playerNuggetID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		
		rmPlaceObjectDefAtLoc(playerCaribouID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(CaribouID5, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(CaribouID6, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		
		if(ypIsAsian(i) && rmGetNomadStart() == false)
		rmPlaceObjectDefAtLoc(ypMonasteryBuilder(i, 1), i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));

		vector closestPoint = rmFindClosestPointVector(TCLoc, rmXFractionToMeters(1.0));
	}
	
	// ************************************************************************************************
	
	// Text
	rmSetStatusText("",0.60);
	
	// ************************************** COMMON RESOURCES ****************************************
   
   
	// ******** Mines *********
		
	int sidegoldCount = rmRandInt(2,2);  // 2,3 
	
	//South mines
	for(i=0; < sidegoldCount)
	{
		int sidegoldID = rmCreateObjectDef("side gold south"+i);
		rmAddObjectDefItem(sidegoldID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(sidegoldID, 0.0);
		rmSetObjectDefMaxDistance(sidegoldID, rmXFractionToMeters(0.6));
		rmAddObjectDefToClass(sidegoldID, classGold);
		rmAddObjectDefConstraint(sidegoldID, Southwestconstraint);
		rmAddObjectDefConstraint(sidegoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(sidegoldID, avoidImpassableLand);
		rmAddObjectDefConstraint(sidegoldID, avoidCliff);
		rmAddObjectDefConstraint(sidegoldID, avoidNatives);
		rmAddObjectDefConstraint(sidegoldID, avoidImportantItem);
		rmAddObjectDefConstraint(sidegoldID, avoidEdge);
		rmAddObjectDefConstraint(sidegoldID, avoidCenter);
		rmAddObjectDefConstraint(sidegoldID, avoidGoldFar);
		if (season < 0.5)
		{
			rmAddObjectDefConstraint(sidegoldID, avoidFrozenRiver1);
			rmAddObjectDefConstraint(sidegoldID, avoidFrozenRiver2);
		}
		rmPlaceObjectDefAtLoc(sidegoldID, 0, 0.32, 0.18);	
	}

	//North mines
	for(i=0; < sidegoldCount)
	{
		int sidegold2ID = rmCreateObjectDef("side gold north"+i);
		rmAddObjectDefItem(sidegold2ID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(sidegold2ID, 0.0);
		rmSetObjectDefMaxDistance(sidegold2ID, rmXFractionToMeters(0.6));
		rmAddObjectDefToClass(sidegold2ID, classGold);
		rmAddObjectDefConstraint(sidegold2ID, Northwestconstraint);
		rmAddObjectDefConstraint(sidegold2ID, avoidTradeRoute);
		rmAddObjectDefConstraint(sidegold2ID, avoidImpassableLand);
		rmAddObjectDefConstraint(sidegold2ID, avoidCliff);
		rmAddObjectDefConstraint(sidegold2ID, avoidNatives);
		rmAddObjectDefConstraint(sidegold2ID, avoidImportantItem);
		rmAddObjectDefConstraint(sidegold2ID, avoidEdge);
		rmAddObjectDefConstraint(sidegold2ID, avoidCenter);
		rmAddObjectDefConstraint(sidegold2ID, avoidGoldFar);
			if (season < 0.5)
		{
			rmAddObjectDefConstraint(sidegold2ID, avoidFrozenRiver1);
			rmAddObjectDefConstraint(sidegold2ID, avoidFrozenRiver2);
		}
		rmPlaceObjectDefAtLoc(sidegold2ID, 0, 0.32, 0.82);
	}
  
	// Central mines
	int centralgoldCount = rmRandInt(2,2);  // 1,2 
	
   	for(i=0; < centralgoldCount)
	{
		int centralgoldID = rmCreateObjectDef("central gold"+i);
		rmAddObjectDefItem(centralgoldID, "mine", 1, 0.0);
		rmSetObjectDefMinDistance(centralgoldID, 0.0);
		rmSetObjectDefMaxDistance(centralgoldID, rmXFractionToMeters(0.5));
		rmAddObjectDefToClass(centralgoldID, classGold);
		rmAddObjectDefConstraint(centralgoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(centralgoldID, avoidImpassableLand);
		rmAddObjectDefConstraint(centralgoldID, avoidNatives);
		rmAddObjectDefConstraint(centralgoldID, avoidImportantItem);
		rmAddObjectDefConstraint(centralgoldID, stayCenter);
		rmAddObjectDefConstraint(centralgoldID, avoidGold);
		if (season < 0.5)
		{
			rmAddObjectDefConstraint(centralgoldID, avoidFrozenRiver1);
			rmAddObjectDefConstraint(centralgoldID, avoidFrozenRiver2);
		}
		rmPlaceObjectDefAtLoc(centralgoldID, 0, 0.4, 0.5);
	}
	
	// ***********************
	
	// Text
	rmSetStatusText("",0.70);
	
   	// ******** Forest ********
	int westforestcount = 6;
	int eastforestcount = 8;
	
	// Western half trees
	for (i=0; < westforestcount)
	{
		int westforestID = rmCreateArea("side forest west"+i);
		rmSetAreaSize(westforestID, rmAreaTilesToFraction(50), rmAreaTilesToFraction(65)); // 65   80
		rmSetAreaWarnFailure(westforestID, false);
		rmSetAreaObeyWorldCircleConstraint(westforestID, false);
		if (season >= 0.5)
		rmSetAreaTerrainType(westforestID, "patagonia\groundforest_pat");
		else
			rmSetAreaTerrainType(westforestID, "patagonia\groundforest_snow_pat");
		rmSetAreaMinBlobs(westforestID, 2);
		rmSetAreaMaxBlobs(westforestID, 5);
		rmSetAreaMinBlobDistance(westforestID, 14.0);
		rmSetAreaMaxBlobDistance(westforestID, 32.0);
		rmSetAreaCoherence(westforestID, 0.0);
		rmSetAreaSmoothDistance(westforestID, 5);
		rmAddAreaToClass(westforestID, classForest);
		rmAddAreaConstraint(westforestID, avoidTradeRouteShort);
		rmAddAreaConstraint(westforestID, avoidImpassableLandShort);
		rmAddAreaConstraint(westforestID, avoidCliffShort);
//		rmAddAreaConstraint(westforestID, avoidWaterShort);
		rmAddAreaConstraint(westforestID, avoidStartingResources);
		rmAddAreaConstraint(westforestID, avoidCaribouMin);
		rmAddAreaConstraint(westforestID, avoidMuskdeerMin);
		rmAddAreaConstraint(westforestID, avoidGoldTypeShort);
		rmAddAreaConstraint(westforestID, avoidTownCenterResources);
		rmAddAreaConstraint(westforestID, avoidForestShort);
//		rmAddAreaConstraint(westforestID, avoidNatives);
		rmAddAreaConstraint(westforestID, avoidCenter);
		if (i < 3)
			rmAddAreaConstraint(westforestID, Northwestconstraint);
		else
			rmAddAreaConstraint(westforestID, Southwestconstraint);
		if (season < 0.5)
		{
			rmAddAreaConstraint(westforestID, avoidFrozenRiver1Short);
			rmAddAreaConstraint(westforestID, avoidFrozenRiver2Short);
		}
		
		rmBuildArea(westforestID);
		
		int stayInWestForest = rmCreateAreaMaxDistanceConstraint("stay in west forest"+i, westforestID, 0);
		
		for (j=0; < 12) //14
		{
			int westtreeID = rmCreateObjectDef("side trees west"+i+j);
			if (season >= 0.5)
				rmAddObjectDefItem(westtreeID, "TreeNorthwestTerritory", rmRandInt(1,2), 2.0); //9,10
			else
				rmAddObjectDefItem(westtreeID, "TreeGreatLakesSnow", rmRandInt(1,2), 2.0); //9,10
			rmSetObjectDefMinDistance(westtreeID,  rmXFractionToMeters(0.0));
			rmSetObjectDefMaxDistance(westtreeID,  rmXFractionToMeters(0.5));
//			rmAddObjectDefToClass(westtreeID, classForest);
		//	rmAddObjectDefConstraint(westtreeID, avoidForestShort);
			rmAddObjectDefConstraint(westtreeID, avoidImpassableLandShort);
			rmAddObjectDefConstraint(westtreeID, stayInWestForest);	
			rmPlaceObjectDefAtLoc(westtreeID, 0, 0.50, 0.50);
		}
		
	}
		
	// Eastern half trees
	for (i=0; < eastforestcount)
	{
		int eastforestID = rmCreateArea("side forest east"+i);
		rmSetAreaSize(eastforestID, rmAreaTilesToFraction(60), rmAreaTilesToFraction(70)); // 65   80
		rmSetAreaWarnFailure(eastforestID, false);
		rmSetAreaObeyWorldCircleConstraint(eastforestID, false);
		if (season >= 0.5)
			rmSetAreaTerrainType(eastforestID, "patagonia\groundforest_pat");
		else
			rmSetAreaTerrainType(eastforestID, "patagonia\groundforest_snow_pat");
		rmSetAreaMinBlobs(eastforestID, 2);
		rmSetAreaMaxBlobs(eastforestID, 5);
		rmSetAreaMinBlobDistance(eastforestID, 14.0);
		rmSetAreaMaxBlobDistance(eastforestID, 32.0);
		rmSetAreaCoherence(eastforestID, 0.0);
		rmSetAreaSmoothDistance(eastforestID, 5);
		rmAddAreaToClass(eastforestID, classForest);
		rmAddAreaConstraint(eastforestID, avoidTradeRouteShort);
		rmAddAreaConstraint(eastforestID, avoidImpassableLandShort);
		rmAddAreaConstraint(eastforestID, avoidCliffShort);
//		rmAddAreaConstraint(eastforestID, avoidWaterShort);
		rmAddAreaConstraint(eastforestID, avoidStartingResources);
		rmAddAreaConstraint(eastforestID, avoidCaribouMin);
		rmAddAreaConstraint(eastforestID, avoidMuskdeerMin);
		rmAddAreaConstraint(eastforestID, avoidGoldTypeShort);
		rmAddAreaConstraint(eastforestID, avoidTownCenter);
		rmAddAreaConstraint(eastforestID, avoidForestShort);
//		rmAddAreaConstraint(eastforestID, avoidNatives);
		rmAddAreaConstraint(eastforestID, avoidCenter);
		if (i < 4)
			rmAddAreaConstraint(eastforestID, Northeastconstraint);
		else
			rmAddAreaConstraint(eastforestID, Southeastconstraint);
		if (season < 0.5)
		{
			rmAddAreaConstraint(eastforestID, avoidFrozenRiver1Short);
			rmAddAreaConstraint(eastforestID, avoidFrozenRiver2Short);
		}
		
		rmBuildArea(eastforestID);
		
		int stayInEastForest = rmCreateAreaMaxDistanceConstraint("stay in east forest"+i, eastforestID, 0);
		
		for (j=0; < 13) // 14
		{
			int easttreeID = rmCreateObjectDef("side trees east"+i+j);
			if (season >= 0.5)
				rmAddObjectDefItem(easttreeID, "TreeNorthwestTerritory", rmRandInt(1,2), 2.0); //9,10
			else
				rmAddObjectDefItem(easttreeID, "TreeGreatLakesSnow", rmRandInt(1,2), 2.0); //9,10
			rmSetObjectDefMinDistance(easttreeID,  rmXFractionToMeters(0.0));
			rmSetObjectDefMaxDistance(easttreeID,  rmXFractionToMeters(0.5));
//			rmAddObjectDefToClass(easttreeID, classForest);
		//	rmAddObjectDefConstraint(easttreeID, avoidForestShort);
			rmAddObjectDefConstraint(easttreeID, avoidImpassableLandShort);
			rmAddObjectDefConstraint(easttreeID, stayInEastForest);	
			rmPlaceObjectDefAtLoc(easttreeID, 0, 0.50, 0.50);
		}
		
	}
	
	// Center trees
	int centertreeID = rmCreateObjectDef("center trees");
	if (season >= 0.5)
		rmAddObjectDefItem(centertreeID, "TreeNorthwestTerritory", rmRandInt(15,16), 7.0);
	else
		rmAddObjectDefItem(centertreeID, "TreeGreatLakesSnow", rmRandInt(15,16), 7.0);
    rmSetObjectDefMinDistance(centertreeID, 0);
    rmSetObjectDefMaxDistance(centertreeID, rmXFractionToMeters(0.5));
	rmAddObjectDefToClass(centertreeID, classForest);
	rmAddObjectDefConstraint(centertreeID, avoidTradeRouteShort);
	rmAddObjectDefConstraint(centertreeID, avoidTradeRouteSocket);
    rmAddObjectDefConstraint(centertreeID, avoidImpassableLand);
	rmAddObjectDefConstraint(centertreeID, avoidStartingResources);
	rmAddObjectDefConstraint(centertreeID, stayCenter);
//	rmAddObjectDefConstraint(centertreeID, avoidGoldMin);
	rmAddObjectDefConstraint(centertreeID, avoidGoldType);
	rmAddObjectDefConstraint(centertreeID, avoidTownCenterResources);
	rmAddObjectDefConstraint(centertreeID, avoidForest);
	rmAddObjectDefConstraint(centertreeID, avoidNatives);
	rmAddObjectDefConstraint(centertreeID, avoidImportantItem);
	if (season < 0.5)
	{
		rmAddObjectDefConstraint(centertreeID, avoidFrozenRiver1);
		rmAddObjectDefConstraint(centertreeID, avoidFrozenRiver2);
	}
	
	int centerforestcount = rmRandInt(2,2); // 1,2
	for (i=0; < centerforestcount)
	{
		rmPlaceObjectDefAtAreaLoc(centertreeID, 0, CenterID);
	}
	
	// ************************
	
	// Text
	rmSetStatusText("",0.80);
	
	// ******** Herds *********
	
	// Northwest herd
	int CaribouID = rmCreateObjectDef("caribou northwest");
    if (season >= 0.5)
		rmAddObjectDefItem(CaribouID, "caribou", rmRandInt(7,7), 6.0);
	else
		rmAddObjectDefItem(CaribouID, "ypmuskdeer", rmRandInt(7,7), 6.0);
	rmSetObjectDefMinDistance(CaribouID, 0);
    rmSetObjectDefMaxDistance(CaribouID, 80);
	rmSetObjectDefCreateHerd(CaribouID, true);
	rmAddObjectDefConstraint(CaribouID, avoidCaribou);
	rmAddObjectDefConstraint(CaribouID, avoidMuskdeer);
	rmAddObjectDefConstraint(CaribouID, Northwestsideconstraint);
//	rmAddObjectDefConstraint(CaribouID, avoidTradeRoute);
	rmAddObjectDefConstraint(CaribouID, avoidTradeRouteSocket);
    rmAddObjectDefConstraint(CaribouID, avoidImpassableLand);
	rmAddObjectDefConstraint(CaribouID, avoidCliff);
	rmAddObjectDefConstraint(CaribouID, avoidStartingResources);
//	rmAddObjectDefConstraint(CaribouID, avoidGoldMin);
	rmAddObjectDefConstraint(CaribouID, avoidGoldTypeShort);
	rmAddObjectDefConstraint(CaribouID, avoidTownCenterFar);
	rmAddObjectDefConstraint(CaribouID, avoidForestMin);
	rmAddObjectDefConstraint(CaribouID, avoidNatives);
	rmAddObjectDefConstraint(CaribouID, avoidImportantItem);
	if (season < 0.5)
	{
		rmAddObjectDefConstraint(CaribouID, avoidFrozenRiver1);
		rmAddObjectDefConstraint(CaribouID, avoidFrozenRiver2);
	}
	
	int sideherdcount = rmRandInt(3,3); //2,3
		
	for (i=0; < sideherdcount)
	{
		rmPlaceObjectDefAtAreaLoc(CaribouID, 0, quarterID1);
	}
	
	// Southwest herds
	int CaribouID1 = rmCreateObjectDef("caribou southwest");
    if (season >= 0.5)
		rmAddObjectDefItem(CaribouID1, "caribou", rmRandInt(7,7), 6.0);
	else
		rmAddObjectDefItem(CaribouID1, "ypmuskdeer", rmRandInt(7,7), 6.0);
	rmSetObjectDefMinDistance(CaribouID1, 0);
    rmSetObjectDefMaxDistance(CaribouID1, 80);
	rmSetObjectDefCreateHerd(CaribouID1, true);
	rmAddObjectDefConstraint(CaribouID1, avoidCaribou);
	rmAddObjectDefConstraint(CaribouID1, avoidMuskdeer);
	rmAddObjectDefConstraint(CaribouID1, Southwestsideconstraint);
//	rmAddObjectDefConstraint(CaribouID1, avoidTradeRoute);
	rmAddObjectDefConstraint(CaribouID1, avoidTradeRouteSocket);
    rmAddObjectDefConstraint(CaribouID1, avoidImpassableLand);
	rmAddObjectDefConstraint(CaribouID1, avoidCliff);
	rmAddObjectDefConstraint(CaribouID1, avoidStartingResources);
//	rmAddObjectDefConstraint(CaribouID1, avoidGoldMin);
	rmAddObjectDefConstraint(CaribouID1, avoidGoldTypeShort);
	rmAddObjectDefConstraint(CaribouID1, avoidTownCenterFar);
	rmAddObjectDefConstraint(CaribouID1, avoidForestMin);
	rmAddObjectDefConstraint(CaribouID1, avoidNatives);
	rmAddObjectDefConstraint(CaribouID1, avoidImportantItem);
	if (season < 0.5)
	{
		rmAddObjectDefConstraint(CaribouID1, avoidFrozenRiver1);
		rmAddObjectDefConstraint(CaribouID1, avoidFrozenRiver2);
	}
	
	for (i=0; < sideherdcount)
	{
		rmPlaceObjectDefAtAreaLoc(CaribouID1, 0, quarterID4);
	}
   
   
   // Northeast herd
	int CaribouID3 = rmCreateObjectDef("caribou Northeast");
    if (season >= 0.5)
		rmAddObjectDefItem(CaribouID3, "caribou", rmRandInt(7,7), 6.0);
	else
		rmAddObjectDefItem(CaribouID3, "ypmuskdeer", rmRandInt(7,7), 6.0);
	rmSetObjectDefMinDistance(CaribouID3, 0);
    rmSetObjectDefMaxDistance(CaribouID3, 80);
	rmSetObjectDefCreateHerd(CaribouID3, true);
	rmAddObjectDefConstraint(CaribouID3, avoidCaribou);
	rmAddObjectDefConstraint(CaribouID3, avoidMuskdeer);
	rmAddObjectDefConstraint(CaribouID3, stayEastclose);
	rmAddObjectDefConstraint(CaribouID3, Northeastsideconstraint);
	rmAddObjectDefConstraint(CaribouID3, avoidTradeRoute);
    rmAddObjectDefConstraint(CaribouID3, avoidImpassableLand);
	rmAddObjectDefConstraint(CaribouID3, avoidCliff);
	rmAddObjectDefConstraint(CaribouID3, avoidStartingResources);
//	rmAddObjectDefConstraint(CaribouID3, avoidGoldMin);
//	rmAddObjectDefConstraint(CaribouID3, avoidGoldTypeShort);
	rmAddObjectDefConstraint(CaribouID3, avoidTownCenterFar);
	rmAddObjectDefConstraint(CaribouID3, avoidForestMin);
	rmAddObjectDefConstraint(CaribouID3, avoidNatives);
	rmAddObjectDefConstraint(CaribouID3, avoidImportantItem);
	if (season < 0.5)
	{
		rmAddObjectDefConstraint(CaribouID3, avoidFrozenRiver1);
		rmAddObjectDefConstraint(CaribouID3, avoidFrozenRiver2);
	}
	
	int eastherdcount = rmRandInt(1,1);
	for (i=0; < eastherdcount)
	{
		rmPlaceObjectDefAtAreaLoc(CaribouID3, 0, quarterID2);
	}
	
	// Southeast herd
	int CaribouID4 = rmCreateObjectDef("caribou southeast");
    if (season >= 0.5)
		rmAddObjectDefItem(CaribouID4, "caribou", rmRandInt(7,7), 6.0);
	else
		rmAddObjectDefItem(CaribouID4, "ypmuskdeer", rmRandInt(7,7), 6.0);
	rmSetObjectDefMinDistance(CaribouID4, 0);
    rmSetObjectDefMaxDistance(CaribouID4, 80);
	rmSetObjectDefCreateHerd(CaribouID4, true);
	rmAddObjectDefConstraint(CaribouID4, avoidCaribou); //avoidCaribouShort
	rmAddObjectDefConstraint(CaribouID4, avoidMuskdeer);
	rmAddObjectDefConstraint(CaribouID4, stayEastclose);
	rmAddObjectDefConstraint(CaribouID4, Southeastsideconstraint);
	rmAddObjectDefConstraint(CaribouID4, avoidTradeRoute);
    rmAddObjectDefConstraint(CaribouID4, avoidImpassableLand);
	rmAddObjectDefConstraint(CaribouID4, avoidCliff);
	rmAddObjectDefConstraint(CaribouID4, avoidStartingResources);
//	rmAddObjectDefConstraint(CaribouID4, avoidGoldMin);
//	rmAddObjectDefConstraint(CaribouID4, avoidGoldTypeShort);
	rmAddObjectDefConstraint(CaribouID4, avoidTownCenterFar);
	rmAddObjectDefConstraint(CaribouID4, avoidForestMin);
	rmAddObjectDefConstraint(CaribouID4, avoidNatives);
	rmAddObjectDefConstraint(CaribouID4, avoidImportantItem);
	if (season < 0.5)
	{
		rmAddObjectDefConstraint(CaribouID4, avoidFrozenRiver1);
		rmAddObjectDefConstraint(CaribouID4, avoidFrozenRiver2);
	}
	
		for (i=0; < eastherdcount)
	{
		rmPlaceObjectDefAtAreaLoc(CaribouID4, 0, quarterID3);
	}
	
	// Central herd
	int elkID = rmCreateObjectDef("elk center");
	if (season >= 0.5)
		rmAddObjectDefItem(elkID, "elk", rmRandInt(7,7), 7.0); // 10,12
	else
		 rmAddObjectDefItem(elkID, "ypibex", rmRandInt(8,8), 7.0); // 10,12
	rmSetObjectDefMinDistance(elkID, 20);
    rmSetObjectDefMaxDistance(elkID, 60);
	rmSetObjectDefCreateHerd(elkID, true);
	rmAddObjectDefConstraint(elkID, avoidCaribou); 
	rmAddObjectDefConstraint(elkID, avoidElk);
	rmAddObjectDefConstraint(elkID, avoidIbex);
	rmAddObjectDefConstraint(elkID, avoidMuskdeer);
	rmAddObjectDefConstraint(elkID, stayCenter);
	rmAddObjectDefConstraint(elkID, avoidTradeRouteSocket);
    rmAddObjectDefConstraint(elkID, avoidImpassableLand);
	rmAddObjectDefConstraint(elkID, avoidStartingResources);
//	rmAddObjectDefConstraint(elkID, avoidGoldMin);
	rmAddObjectDefConstraint(elkID, avoidGoldTypeShort);
	rmAddObjectDefConstraint(elkID, avoidTownCenterFar);
	rmAddObjectDefConstraint(elkID, avoidForestMin);
	rmAddObjectDefConstraint(elkID, avoidNatives);
	rmAddObjectDefConstraint(elkID, avoidImportantItem);
	if (season < 0.5)
	{
		rmAddObjectDefConstraint(elkID, avoidFrozenRiver1);
		rmAddObjectDefConstraint(elkID, avoidFrozenRiver2);
	}
	
	int elkcount = rmRandInt (2,2); //1,2
	
	for (i=0; < elkcount)
	{
		rmPlaceObjectDefAtAreaLoc(elkID, 0, CenterID);
	}
	
	// ****************************
	
	// Text
	rmSetStatusText("",0.90);
	
	// ******** Treasures *********
	
	int nugget1count = -1; 
	int nugget2count = -1;
	int nugget3count = -1;
	int nugget4count = -1;
	
	if (nugget0count == 1)
		nugget1count = rmRandInt(2,3); //3,4
	else
		nugget1count = rmRandInt (2,2);
	if (nugget1count == 2)
		nugget2count = rmRandInt(0,1);	
	else
		nugget2count = 0;
	
	
	// Northwest treasures
	int NWNuggetID = rmCreateObjectDef("NW nugget"); 
	rmAddObjectDefItem(NWNuggetID, "Nugget", 1, 0.0);
//	rmSetNuggetDifficulty(1, 2);
	rmSetObjectDefMinDistance(NWNuggetID, 0);
    rmSetObjectDefMaxDistance(NWNuggetID, 180);
//	rmAddObjectDefConstraint(NWNuggetID, avoidCaribou);
	rmAddObjectDefConstraint(NWNuggetID, Northwestsideconstraint);
	rmAddObjectDefConstraint(NWNuggetID, avoidNuggetShort);
	rmAddObjectDefConstraint(NWNuggetID, avoidTradeRouteShort);
	rmAddObjectDefConstraint(NWNuggetID, avoidTradeRouteSocket);
    rmAddObjectDefConstraint(NWNuggetID, avoidImpassableLand);
	rmAddObjectDefConstraint(NWNuggetID, avoidCliff);
	rmAddObjectDefConstraint(NWNuggetID, avoidGoldTypeShort);
	rmAddObjectDefConstraint(NWNuggetID, avoidTownCenterResources);
	rmAddObjectDefConstraint(NWNuggetID, avoidForestMin);
	rmAddObjectDefConstraint(NWNuggetID, avoidNatives);
	rmAddObjectDefConstraint(NWNuggetID, avoidImportantItem);
	if (season < 0.5)
	{
		rmAddObjectDefConstraint(NWNuggetID, avoidFrozenRiver1);
		rmAddObjectDefConstraint(NWNuggetID, avoidFrozenRiver2);
	}

	
	for (i=0; < nugget2count)
	{
		rmSetNuggetDifficulty(1,2);	
		rmPlaceObjectDefAtAreaLoc(NWNuggetID, 0, quarterID1);
	}
	
	for (i=0; < nugget1count)
	{
		rmSetNuggetDifficulty(1,1);	
		rmPlaceObjectDefAtAreaLoc(NWNuggetID, 0, quarterID1);
	}
	
	// Southwest treasures
	int SWNuggetID = rmCreateObjectDef("SW nugget"); 
	rmAddObjectDefItem(SWNuggetID, "Nugget", 1, 0.0);
//	rmSetNuggetDifficulty(1, 2);
	rmSetObjectDefMinDistance(SWNuggetID, 0);
    rmSetObjectDefMaxDistance(SWNuggetID, 180);
//	rmAddObjectDefConstraint(SWNuggetID, avoidCaribou);
	rmAddObjectDefConstraint(SWNuggetID, Southwestsideconstraint);
	rmAddObjectDefConstraint(SWNuggetID, avoidNuggetShort);
	rmAddObjectDefConstraint(SWNuggetID, avoidTradeRouteShort);
	rmAddObjectDefConstraint(SWNuggetID, avoidTradeRouteSocket);
    rmAddObjectDefConstraint(SWNuggetID, avoidImpassableLand);
	rmAddObjectDefConstraint(SWNuggetID, avoidCliff);
	rmAddObjectDefConstraint(SWNuggetID, avoidGoldTypeShort);
	rmAddObjectDefConstraint(SWNuggetID, avoidTownCenterResources);
	rmAddObjectDefConstraint(SWNuggetID, avoidForestMin);
	rmAddObjectDefConstraint(SWNuggetID, avoidNatives);
	rmAddObjectDefConstraint(SWNuggetID, avoidImportantItem);
	if (season < 0.5)
	{
		rmAddObjectDefConstraint(SWNuggetID, avoidFrozenRiver1);
		rmAddObjectDefConstraint(SWNuggetID, avoidFrozenRiver2);
	}
	
	for (i=0; < nugget2count)
	{
		rmSetNuggetDifficulty(1,2);	
		rmPlaceObjectDefAtAreaLoc(SWNuggetID, 0, quarterID4);
	}
	
	for (i=0; < nugget1count)
	{
		rmSetNuggetDifficulty(1,1);	
		rmPlaceObjectDefAtAreaLoc(SWNuggetID, 0, quarterID4);
	}
	
	// Central treasures
	int CenterNuggetID = rmCreateObjectDef("Center nugget"); 
	rmAddObjectDefItem(CenterNuggetID, "Nugget", 1, 0.0);
	rmSetObjectDefMinDistance(CenterNuggetID, 0);
    rmSetObjectDefMaxDistance(CenterNuggetID, 100);
//	rmAddObjectDefConstraint(CenterNuggetID, avoidCaribou);
	rmAddObjectDefConstraint(CenterNuggetID, stayCenter);
	rmAddObjectDefConstraint(CenterNuggetID, avoidNugget);
	rmAddObjectDefConstraint(CenterNuggetID, avoidTradeRouteShort);
	rmAddObjectDefConstraint(CenterNuggetID, avoidTradeRouteSocket);
    rmAddObjectDefConstraint(CenterNuggetID, avoidImpassableLand);
	rmAddObjectDefConstraint(CenterNuggetID, avoidGoldTypeShort);
	rmAddObjectDefConstraint(CenterNuggetID, avoidTownCenterResources);
	rmAddObjectDefConstraint(CenterNuggetID, avoidForestMin);
	rmAddObjectDefConstraint(CenterNuggetID, avoidNatives);
	rmAddObjectDefConstraint(CenterNuggetID, avoidImportantItem);
	if (season < 0.5)
	{
		rmAddObjectDefConstraint(CenterNuggetID, avoidFrozenRiver1);
		rmAddObjectDefConstraint(CenterNuggetID, avoidFrozenRiver2);
	}
	
	if (nugget2count == 0)
		nugget3count = rmRandInt(1,2); //2,2
	else
		nugget3count = 1;  
	
	for (i=0; < nugget3count)
	{
		if (nugget3count == 1)
			rmSetNuggetDifficulty(2, 2);
		else
			rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtAreaLoc(CenterNuggetID, 0, CenterID);
	}
	
	// East treasure
	int ENuggetID = rmCreateObjectDef("East nugget"); 
	rmAddObjectDefItem(ENuggetID, "Nugget", 1, 0.0);
	rmSetObjectDefMinDistance(ENuggetID, 0);
    rmSetObjectDefMaxDistance(ENuggetID, 100);
//	rmAddObjectDefConstraint(ENuggetID, avoidCaribou);
	rmAddObjectDefConstraint(ENuggetID, stayEastveryclose);
//	rmAddObjectDefConstraint(ENuggetID, Northeastsideconstraint);
	rmAddObjectDefConstraint(ENuggetID, avoidNugget);
	rmAddObjectDefConstraint(ENuggetID, avoidTradeRoute);
    rmAddObjectDefConstraint(ENuggetID, avoidImpassableLand);
	rmAddObjectDefConstraint(ENuggetID, avoidCliff);
//	rmAddObjectDefConstraint(ENuggetID, avoidGoldTypeShort);
	rmAddObjectDefConstraint(ENuggetID, avoidTownCenterResources);
	rmAddObjectDefConstraint(ENuggetID, avoidForestMin);
	rmAddObjectDefConstraint(ENuggetID, avoidNatives);
	rmAddObjectDefConstraint(ENuggetID, avoidImportantItem);
	if (season < 0.5)
	{
		rmAddObjectDefConstraint(ENuggetID, avoidFrozenRiver1);
		rmAddObjectDefConstraint(ENuggetID, avoidFrozenRiver2);
	}
	
	if (nugget3count == 1)
	{
		nugget4count = rmRandInt(2,2);
		rmSetNuggetDifficulty(1, 1);
	}
	else
	{
		nugget4count = rmRandInt(1,2);
		rmSetNuggetDifficulty(1, 2);
	}
	for (i=0; < nugget4count)
	{
		rmPlaceObjectDefAtLoc(ENuggetID, 0, 9.0, 0.5); 
	}	
	
	// *********************************
	
	// Text
	rmSetStatusText("",0.95);
	
	// ********** Random trees **********
	
	// Random tree clumps
	int randomforestcount = rmRandInt(15,15); // 
	
	for (i=0; < randomforestcount)
	{	
		int RandomtreeID = rmCreateObjectDef("random trees"+i);
		if (season >= 0.5)
			rmAddObjectDefItem(RandomtreeID, "TreeNorthwestTerritory", rmRandInt(7,8), 4.0); // 4,5
		else
			rmAddObjectDefItem(RandomtreeID, "TreeGreatLakesSnow", rmRandInt(7,8), 4.0); // 4,5	
		rmSetObjectDefMinDistance(RandomtreeID, 0);
		rmSetObjectDefMaxDistance(RandomtreeID, rmXFractionToMeters(0.6));
		rmAddObjectDefToClass(RandomtreeID, classForest);
		rmAddObjectDefConstraint(RandomtreeID, avoidTradeRouteShort);
		rmAddObjectDefConstraint(RandomtreeID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(RandomtreeID, avoidImpassableLandShort);
		rmAddObjectDefConstraint(RandomtreeID, avoidCliff);
		rmAddObjectDefConstraint(RandomtreeID, avoidStartingResources);
	//	rmAddObjectDefConstraint(RandomtreeID, stayEdge);
		rmAddObjectDefConstraint(RandomtreeID, avoidGoldTypeShort);
		rmAddObjectDefConstraint(RandomtreeID, avoidForest);
		rmAddObjectDefConstraint(RandomtreeID, avoidNatives);
		rmAddObjectDefConstraint(RandomtreeID, avoidImportantItem);
		if (season < 0.5)
		{
			rmAddObjectDefConstraint(RandomtreeID, avoidFrozenRiver1);
			rmAddObjectDefConstraint(RandomtreeID, avoidFrozenRiver2);
		}
		rmPlaceObjectDefAtLoc(RandomtreeID, 0, 0.5, 0.5);
	}
	
	// Edge trees
	int edgeforestcount = rmRandInt(8,8); // 
	
	for (i=0; < edgeforestcount)
	{	
		int EdgetreeID = rmCreateObjectDef("edge trees"+i);
		if (season >= 0.5)
			rmAddObjectDefItem(EdgetreeID, "TreeNorthwestTerritory", rmRandInt(4,5), 4.0); // 4,5
		else
			rmAddObjectDefItem(EdgetreeID, "TreeGreatLakesSnow", rmRandInt(4,5), 4.0); // 4,5	
		rmSetObjectDefMinDistance(EdgetreeID, 0);
		rmSetObjectDefMaxDistance(EdgetreeID, rmXFractionToMeters(0.6));
		rmAddObjectDefToClass(EdgetreeID, classForest);
		rmAddObjectDefConstraint(EdgetreeID, avoidTradeRouteShort);
		rmAddObjectDefConstraint(EdgetreeID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(EdgetreeID, avoidImpassableLandShort);
		rmAddObjectDefConstraint(EdgetreeID, avoidCliff);
		rmAddObjectDefConstraint(EdgetreeID, avoidStartingResources);
		rmAddObjectDefConstraint(EdgetreeID, stayEdge);
		rmAddObjectDefConstraint(EdgetreeID, avoidGoldTypeShort);
		rmAddObjectDefConstraint(EdgetreeID, avoidForestMin);
		rmAddObjectDefConstraint(EdgetreeID, avoidNatives);
		rmAddObjectDefConstraint(EdgetreeID, avoidImportantItem);
		if (season < 0.5)
		{
			rmAddObjectDefConstraint(EdgetreeID, avoidFrozenRiver1);
			rmAddObjectDefConstraint(EdgetreeID, avoidFrozenRiver2);
		}
			rmPlaceObjectDefAtLoc(EdgetreeID, 0, 0.5, 0.5);
	}
	
	// River trees
	if (season < 0.5)
	{
		for (i=0; < 26)
		{
			int RivertreeID = rmCreateObjectDef("river trees"+i);
			rmAddObjectDefItem(RivertreeID, "TreeGreatLakesSnow", rmRandInt(1,2), 2.0); // 1,3	
			rmSetObjectDefMinDistance(RivertreeID, 0);
			rmSetObjectDefMaxDistance(RivertreeID, rmXFractionToMeters(0.5));
			rmAddObjectDefToClass(RivertreeID, classForest);
			rmAddObjectDefConstraint(RivertreeID, avoidTradeRouteShort);
			rmAddObjectDefConstraint(RivertreeID, avoidTradeRouteSocket);
			rmAddObjectDefConstraint(RivertreeID, avoidImpassableLandShort);
			rmAddObjectDefConstraint(RivertreeID, avoidCliff);
			rmAddObjectDefConstraint(RivertreeID, avoidStartingResources);
			rmAddObjectDefConstraint(RivertreeID, avoidGoldTypeShort);
			rmAddObjectDefConstraint(RivertreeID, avoidForestMin);
			rmAddObjectDefConstraint(RivertreeID, avoidNatives);
			rmAddObjectDefConstraint(RivertreeID, avoidImportantItem);
			rmAddObjectDefConstraint(RivertreeID, avoidFrozenRiver1Short);
			rmAddObjectDefConstraint(RivertreeID, avoidFrozenRiver2Short);
			if (i < 13)
				rmAddObjectDefConstraint(RivertreeID, stayNearRiver1);
			else
				rmAddObjectDefConstraint(RivertreeID, stayNearRiver2);
			rmPlaceObjectDefAtLoc(RivertreeID, 0, 0.5, 0.5);
		}
	}
	
	// Goats
	int GoatID = rmCreateObjectDef("goat");
	rmAddObjectDefItem(GoatID, "ypGoat", 1, 1.0);
	rmSetObjectDefMinDistance(GoatID, 0.0);
	rmSetObjectDefMaxDistance(GoatID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(GoatID, avoidTradeRouteShort);
	rmAddObjectDefConstraint(GoatID, avoidImpassableLand);
	rmAddObjectDefConstraint(GoatID, avoidCliff);
	rmAddObjectDefConstraint(GoatID, avoidNatives);
	rmAddObjectDefConstraint(GoatID, avoidImportantItem);
	rmAddObjectDefConstraint(GoatID, avoidEdge);
	rmAddObjectDefConstraint(GoatID, avoidGoat);
	rmAddObjectDefConstraint(GoatID, avoidTownCenterResources);
	rmAddObjectDefConstraint(GoatID, avoidForestMin);
	int goatcount = 8;
	
	for (i=0; <goatcount)
	{
		rmPlaceObjectDefAtLoc(GoatID, 0, 0.5, 0.5);
	}
	
	// Text
	rmSetStatusText("",1.00);
	
	
	// [Special unit placement start] ||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
	for(i=3; <= cNumberNonGaiaPlayers) {
				int unit = rmCreateObjectDef("Target"+i);
				rmAddObjectDefItem(unit,"Target", 1, 1.0);
				rmSetObjectDefMinDistance(unit, 0);
				rmSetObjectDefMaxDistance(unit, 4);
				rmPlaceObjectDefAtLoc(unit,i, 0.82, 0.68, 1);
				rmPlaceObjectDefAtLoc(unit,i, 0.82, 0.32, 1);
	}

	
} //END
	
	