// ESOC MANCHURIA
// designed by Garja


int PlayerNum=2;
int numPlayer=3;

include "mercenaries.xs";
include "ypAsianInclude.xs";
include "ypKOTHInclude.xs";


// Main entry point for random map script
void main(void)
{
		
	// Text
	// These status text lines are used to manually animate the map generation progress bar
	rmSetStatusText("",0.01); 
	
	// ************************************** GENERAL FEATURES *****************************************
	
	// Picks the map size
	int playerTiles=11000; //11000
	int size=2.0*sqrt(PlayerNum*playerTiles); //2.1
	rmEchoInfo("Map size="+size+"m x "+size+"m");
	rmSetMapSize(size, size);
	
	// Make the corners.
	rmSetWorldCircleConstraint(false);
	
	// Picks a default water height
	rmSetSeaLevel(5.0);	// this is height of river surface compared to surrounding land. River depth is in the river XML.

	rmSetMapElevationParameters(cElevTurbulence, 0.05, 2, 0.5, 4.5); // type, frequency, octaves, persistence, variation 
//	rmSetMapElevationHeightBlend(1);
	
	
	// Picks default terrain and water
	rmSetSeaType("coastal japan");
	rmSetBaseTerrainMix("mongolia_forest"); // 
	rmTerrainInitialize("Mongolia\ground_grass4_mongol", 4.0); // 
	rmSetMapType("mongolia"); 
	rmSetMapType("grass");
	rmSetMapType("water");
	rmSetLightingSet("mongolia");

	// Choose Mercs
	chooseMercs();
	
	// Text
	rmSetStatusText("",0.10);
	
	// Set up Natives
	int subCiv0 = -1;
	int subCiv1 = -1;
	subCiv0 = rmGetCivID("Shaolin");
	subCiv1 = rmGetCivID("Zen");
	rmSetSubCiv(0, "Shaolin");
	rmSetSubCiv(1, "Zen");
	

	//Define some classes. These are used later for constraints.
	int classPlayer = rmDefineClass("player");
	rmDefineClass("classHill");
	int classPatch = rmDefineClass("patch");
	int classPatch2 = rmDefineClass("patch2");
	int classPatch3 = rmDefineClass("patch3");
	int classPond = rmDefineClass("pond");
	int classRocks = rmDefineClass("rocks");
	int classGrass = rmDefineClass("grass");
	rmDefineClass("starting settlement");
	rmDefineClass("startingUnit");
	int classForest = rmDefineClass("Forest");
	int importantItem = rmDefineClass("importantItem");
	int classNative = rmDefineClass("natives");
	int classCliff = rmDefineClass("Cliffs");
	int classGold = rmDefineClass("Gold");
	int classStartingResource = rmDefineClass("startingResource");
	
	// ******************************************************************************************
	
	// Text
	rmSetStatusText("",0.20);
	
	// ************************************* CONTRAINTS *****************************************
	// These are used to have objects and areas avoid each other
   
	// Cardinal Directions & Map placement
	int avoidEdge = rmCreatePieConstraint("Avoid Edge",0.5,0.5, rmXFractionToMeters(0.0),rmXFractionToMeters(0.47), rmDegreesToRadians(0),rmDegreesToRadians(360));
	int avoidEdgeMore = rmCreatePieConstraint("Avoid Edge More",0.5,0.5, rmXFractionToMeters(0.0),rmXFractionToMeters(0.38), rmDegreesToRadians(0),rmDegreesToRadians(360));
	int avoidCenter = rmCreatePieConstraint("Avoid Center",0.5,0.5,rmXFractionToMeters(0.28), rmXFractionToMeters(0.5), rmDegreesToRadians(0),rmDegreesToRadians(360));
	int stayCenter = rmCreatePieConstraint("Stay Center", 0.50, 0.50, rmXFractionToMeters(0.0), rmXFractionToMeters(0.28), rmDegreesToRadians(0),rmDegreesToRadians(360));
	int stayCenterMore = rmCreatePieConstraint("Stay Center more",0.45,0.45,rmXFractionToMeters(0.0), rmXFractionToMeters(0.26), rmDegreesToRadians(0),rmDegreesToRadians(360));
	int stayNW = rmCreatePieConstraint("Stay NW", 0.50, 0.65,rmXFractionToMeters(0.0), rmXFractionToMeters(0.50), rmDegreesToRadians(270),rmDegreesToRadians(90));
	int staySW = rmCreatePieConstraint("Stay SW", 0.35, 0.50,rmXFractionToMeters(0.0), rmXFractionToMeters(0.50), rmDegreesToRadians(180),rmDegreesToRadians(360));
	int stayNE = rmCreatePieConstraint("Stay NE", 0.65, 0.50,rmXFractionToMeters(0.0), rmXFractionToMeters(0.50), rmDegreesToRadians(360),rmDegreesToRadians(180));
	int staySouthHalf = rmCreatePieConstraint("Stay south half", 0.50, 0.50,rmXFractionToMeters(0.0), rmXFractionToMeters(0.50), rmDegreesToRadians(180),rmDegreesToRadians(360));
	int stayNorthHalf = rmCreatePieConstraint("Stay north half", 0.50, 0.50,rmXFractionToMeters(0.0), rmXFractionToMeters(0.50), rmDegreesToRadians(360),rmDegreesToRadians(180));
		
	// Resource avoidance
	int avoidForest=rmCreateClassDistanceConstraint("avoid forest", rmClassID("Forest"), 30.0); //15.0
	int avoidForestShort=rmCreateClassDistanceConstraint("avoid forest short", rmClassID("Forest"), 24.0); //15.0
	int avoidForestMin=rmCreateClassDistanceConstraint("avoid forest min", rmClassID("Forest"), 4.0);
	int avoidSerowFar = rmCreateTypeDistanceConstraint("avoid Serow far", "ypSerow", 50.0);
	int avoidSerow = rmCreateTypeDistanceConstraint("avoid Serow", "ypSerow", 45.0);
	int avoidSerowShort = rmCreateTypeDistanceConstraint("avoid Serow short", "ypSerow", 25.0);
	int avoidSerowMin = rmCreateTypeDistanceConstraint("avoid Serow min", "ypSerow", 4.0);
	int avoidSheepFar = rmCreateTypeDistanceConstraint("avoid Sheep far", "ypMarcoPoloSheep", 45.0);
	int avoidSheep = rmCreateTypeDistanceConstraint("avoid  Sheep", "ypMarcoPoloSheep", 40.0);
	int avoidSheepShort = rmCreateTypeDistanceConstraint("avoid  Sheep short", "ypMarcoPoloSheep", 35.0);
	int avoidSheepMin = rmCreateTypeDistanceConstraint("avoid Sheep min", "ypMarcoPoloSheep", 5.0);
	int avoidMuskdeerFar = rmCreateTypeDistanceConstraint("avoid muskdeer far", "ypmuskdeer", 56.0);
	int avoidMuskdeer = rmCreateTypeDistanceConstraint("avoid muskdeer ", "ypmuskdeer", 45.0);
	int avoidMuskdeerMin = rmCreateTypeDistanceConstraint("avoid muskdeer min ", "ypmuskdeer", 4.0);
	int avoidGoldMed = rmCreateTypeDistanceConstraint("coin avoids coin", "gold", 25.0);
	int avoidGoldTypeShort = rmCreateTypeDistanceConstraint("coin avoids coin short", "gold", 8.0);
	int avoidGoldType = rmCreateTypeDistanceConstraint("coin avoids coin ", "gold", 35.0);
	int avoidGoldTypeFar = rmCreateTypeDistanceConstraint("coin avoids coin far ", "gold", 50.0);
	int avoidGoldMin=rmCreateClassDistanceConstraint("min distance vs gold", rmClassID("Gold"), 8.0);
	int avoidGoldShort = rmCreateClassDistanceConstraint ("gold avoid gold short", rmClassID("Gold"), 15.0);
	int avoidGold = rmCreateClassDistanceConstraint ("gold avoid gold med", rmClassID("Gold"), 30.0);
	int avoidGoldFar = rmCreateClassDistanceConstraint ("gold avoid gold far", rmClassID("Gold"), 60.0);
	int avoidGoldVeryFar = rmCreateClassDistanceConstraint ("gold avoid gold very far", rmClassID("Gold"), 66.0);
	int avoidNuggetMin = rmCreateTypeDistanceConstraint("nugget avoid nugget min", "AbstractNugget", 10.0);
	int avoidNuggetShort = rmCreateTypeDistanceConstraint("nugget avoid nugget short", "AbstractNugget", 15.0);
	int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 40.0);
	int avoidNuggetFar = rmCreateTypeDistanceConstraint("nugget avoid nugget Far", "AbstractNugget", 50.0);
	int avoidTownCenterVeryFar = rmCreateTypeDistanceConstraint("avoid Town Center Very Far", "townCenter", 85.0);
	int avoidTownCenterFar = rmCreateTypeDistanceConstraint("avoid Town Center Far", "townCenter", 64.0);
	int avoidTownCenter = rmCreateTypeDistanceConstraint("avoid Town Center", "townCenter", 45.0);
//	int avoidTownCenterMed = rmCreateTypeDistanceConstraint("avoid Town Center med", "townCenter", 40.0);
	int avoidTownCenterShort = rmCreateTypeDistanceConstraint("avoid Town Center short", "townCenter", 25.0);
	int avoidTownCenterMin = rmCreateTypeDistanceConstraint("avoid Town Center min", "townCenter", 18.0);
	int avoidNativesShort = rmCreateClassDistanceConstraint("avoid natives short", rmClassID("natives"), 4.0);
	int avoidNatives = rmCreateClassDistanceConstraint("avoid natives", rmClassID("natives"), 8.0);
	int avoidNativesFar = rmCreateClassDistanceConstraint("avoid natives far", rmClassID("natives"), 15.0);
	int avoidStartingResources = rmCreateClassDistanceConstraint("avoid starting resources", rmClassID("startingResource"), 8.0);
	int avoidStartingResourcesShort = rmCreateClassDistanceConstraint("avoid starting resources short", rmClassID("startingResource"), 4.0);
	int avoidWhale=rmCreateTypeDistanceConstraint("avoid whale", "fish", 30.0);
	int avoidFish=rmCreateTypeDistanceConstraint("avoid fish", "fish", 15.0);
	int avoidYak=rmCreateTypeDistanceConstraint("avoid yak", "ypyak", 58.0);
	int avoidColonyShip = rmCreateTypeDistanceConstraint("avoid colony ship", "HomeCityWaterSpawnFlag", 30.0);
	int avoidColonyShipShort = rmCreateTypeDistanceConstraint("avoid colony ship short", "HomeCityWaterSpawnFlag", 15.0);

	// Avoid impassable land
	int avoidImpassableLandMin = rmCreateTerrainDistanceConstraint("avoid impassable land min", "Land", false, 1.0);
	int avoidImpassableLandShort = rmCreateTerrainDistanceConstraint("avoid impassable land short", "Land", false, 3.0);
	int avoidImpassableLand = rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 8.0);
	int avoidImpassableLandMed=rmCreateTerrainDistanceConstraint("avoid impassable land medium", "Land", false, 12.0);
	int avoidImpassableLandFar = rmCreateTerrainDistanceConstraint("avoid impassable land far", "Land", false, 20.0);
	int stayNearLand = rmCreateTerrainMaxDistanceConstraint("stay near land ", "Land", true, 5.0);
	int avoidLand = rmCreateTerrainDistanceConstraint("avoid land ", "Land", true, 10.0);
	int avoidLandFar = rmCreateTerrainDistanceConstraint("avoid land far ", "Land", true, 14.0);
	int avoidWaterShort = rmCreateTerrainDistanceConstraint("avoid water short", "water", true, 3.0);
	int avoidWater = rmCreateTerrainDistanceConstraint("avoid water ", "water", true, 10);
	int avoidWaterFar = rmCreateTerrainDistanceConstraint("avoid water far", "water", true, 30.0);
	int stayNearWater = rmCreateTerrainMaxDistanceConstraint("stay near water ", "water", true, 20.0);
	int stayInWater = rmCreateTerrainMaxDistanceConstraint("stay in water ", "water", true, 0.0);
	int avoidPatch = rmCreateClassDistanceConstraint("avoid patch", rmClassID("patch"), 5.0);
	int avoidPatch2 = rmCreateClassDistanceConstraint("avoid patch2", rmClassID("patch2"), 20.0);
	int avoidPatch3 = rmCreateClassDistanceConstraint("avoid patch3", rmClassID("patch3"), 5.0);
	
	// Unit avoidance
	int avoidStartingUnits = rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 35.0);	
	
	// VP avoidance
	int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 8.0);
	int avoidTradeRouteShort = rmCreateTradeRouteDistanceConstraint("trade route short", 4.0);
	int avoidTradeRouteSocket = rmCreateTypeDistanceConstraint("avoid trade route socket", "socketTradeRoute", 8.0);
	int avoidTradeRouteSocketShort = rmCreateTypeDistanceConstraint("avoid trade route socket short", "socketTradeRoute", 3.0);
	int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 10.0);
   
	
	// ***********************************************************************************************
	
	// **************************************** PLACE PLAYERS ****************************************

	int teamZeroCount = rmGetNumberPlayersOnTeam(0);
	int teamOneCount = rmGetNumberPlayersOnTeam(1);
	
	// 2 team and FFA support
	float OneVOnePlacement=rmRandFloat(0, 1);
	if (PlayerNum == 2)
	{

		if ( OneVOnePlacement < 0.5)
		{
			rmSetPlacementTeam(0);
			rmPlacePlayersLine(0.18, 0.50, 0.4, 0.20, 0, 0.0); // disregard line end

			rmSetPlacementTeam(1);
			rmPlacePlayersLine(0.82, 0.50, 0.4, 0.8, 0, 0.0); // disregard line end
		}
		else
		{
			rmSetPlacementTeam(0);
			rmPlacePlayersLine(0.82, 0.50, 0.4, 0.8, 0, 0.0);

			rmSetPlacementTeam(1);
			rmPlacePlayersLine(0.18, 0.50, 0.4, 0.20, 0, 0.0);
		}
		
	}
	
/*	// Team placement
	else if ( PlayerNum == 2 && teamZeroCount == teamOneCount)
	{

		rmSetPlacementTeam(0);
		rmSetTeamSpacingModifier(0.25);
		rmPlacePlayersLine(0.2, 0.2, 0.5, 0.2, 0, 0.0);

		rmSetPlacementTeam(1);
		rmSetTeamSpacingModifier(0.25);
		rmPlacePlayersLine(0.8, 0.8, 0.5, 0.8, 0, 0.0);
	
	}
	// FFA support
	else if (PlayerNum > 2)
	{
      bool southSide = true;

      float spacingIncrement = (0.35 / (PlayerNum / 2));
      float spacingSouth = 0;
      float spacingNorth = 0;
      
      float southStart = 0.45;
      float southEnd = 0.82;
      float northStart = 0.95;
      float northEnd = 0.32;

      for (i = 0; < PlayerNum)
      {
         rmEchoInfo("i = "+i);
         if (southSide == true)
         {
            rmSetPlacementTeam(i);
            rmSetPlacementSection((southStart + spacingSouth), southEnd);
	         rmSetTeamSpacingModifier(0.25);
	         rmPlacePlayersCircular(0.4, 0.4, 0);
            spacingSouth = spacingSouth + spacingIncrement;
         }
         else
         {
            rmSetPlacementTeam(i);
            rmSetPlacementSection((northStart + spacingNorth), northEnd);
	         rmSetTeamSpacingModifier(0.25);
	         rmPlacePlayersCircular(0.4, 0.4, 0);
            spacingNorth = spacingNorth + spacingIncrement;
         }
         if (southSide == true)
         {
            southSide = false;
         }
         else
         {
            southSide = true;
         }
      }
   }
   else 
   {
      if (teamZeroCount < teamOneCount)
      {
         rmSetPlacementTeam(0);
         rmSetPlacementSection(0.55, 0.75);
		   rmSetTeamSpacingModifier(0.35 / teamZeroCount);
		   rmPlacePlayersCircular(0.4, 0.4, 0);

		   rmSetPlacementTeam(1);
         rmSetPlacementSection(0.95, 0.32);
		   rmSetTeamSpacingModifier(0.35 / teamOneCount);
		   rmPlacePlayersCircular(0.4, 0.4, 0);
      }
      else 
      {
         rmSetPlacementTeam(0);
         rmSetPlacementSection(0.45, 0.82);
		   rmSetTeamSpacingModifier(0.35 / teamZeroCount);
		   rmPlacePlayersCircular(0.4, 0.4, 0);

		   rmSetPlacementTeam(1);
         rmSetPlacementSection(0.0, 0.2);
		   rmSetTeamSpacingModifier(0.35 / teamOneCount);
		   rmPlacePlayersCircular(0.4, 0.4, 0);
      }
   }
*/
	// **************************************************************************************************
   
	// Text
	rmSetStatusText("",0.30);
	
	// ******************************************** MAP LAYOUT **************************************************
	
	
	//High ground 
	int highgroundID = rmCreateArea("high ground");
    rmSetAreaWarnFailure(highgroundID, false);
	rmSetAreaObeyWorldCircleConstraint(highgroundID, false);
    rmSetAreaSize(highgroundID, 0.28, 0.28);
	rmSetAreaLocation(highgroundID, 0.5, 0.9);
	rmAddAreaInfluenceSegment(highgroundID, 1.00, 0.90, 0.00, 0.90);
	rmSetAreaMix(highgroundID, "mongolia_grass_b");
    rmSetAreaCoherence(highgroundID, 0.70);
	rmSetAreaSmoothDistance(highgroundID, 5);
//	rmAddAreaConstraint(highgroundID, avoidHill);
    rmBuildArea(highgroundID); 
	
	int avoidHighground = rmCreateAreaDistanceConstraint("avoid high ground", highgroundID, 0.5);
	int avoidHighgroundFar = rmCreateAreaDistanceConstraint("avoid high ground far", highgroundID, 10);
	
	
	//Low ground 
	int lowgroundID = rmCreateArea("low ground");
    rmSetAreaWarnFailure(lowgroundID, false);
	rmSetAreaObeyWorldCircleConstraint(lowgroundID, false);
    rmSetAreaSize(lowgroundID, 0.8, 0.8);
	rmSetAreaLocation(lowgroundID, 0.5, 0.0);
	rmSetAreaTerrainType(lowgroundID, "mongolia\ground_grass4_mongol");
    rmSetAreaCoherence(lowgroundID, 0.75);
	rmSetAreaSmoothDistance(lowgroundID, 8);
	rmAddAreaConstraint(lowgroundID, avoidHighground);
    rmBuildArea(lowgroundID); 
	
	int avoidLowground = rmCreateAreaDistanceConstraint("avoid low ground", lowgroundID, 0.5);

	
	//Sea
	int SeaID = rmCreateArea("Sea");
	rmSetAreaSize(SeaID, 0.25, 0.25);
	rmSetAreaLocation(SeaID, 0.50, 0.10);
	rmSetAreaObeyWorldCircleConstraint(SeaID, false);
	rmAddAreaInfluenceSegment(SeaID, 0.90, 0.00, 0.65, 0.10); 
	rmAddAreaInfluenceSegment(SeaID, 0.65, 0.10, 0.35, 0.10);
	rmAddAreaInfluenceSegment(SeaID, 0.35, 0.10, 0.10, 0.00);
	rmSetAreaWaterType(SeaID, "coastal japan"); 
//	rmAddAreaTerrainLayer(SeaID, "coastal_japan\ground_grass1_co_japan", 0, 2);
	rmSetAreaMinBlobs(SeaID, 8);
	rmSetAreaMaxBlobs(SeaID, 10);
//	rmSetAreaMinBlobDistance(SeaID, 10);
//	rmSetAreaMaxBlobDistance(SeaID, 20);
	rmSetAreaCoherence(SeaID, 0.7);
	rmSetAreaSmoothDistance(SeaID, 22);
	rmBuildArea(SeaID);
	
	int stayNearSea = rmCreateAreaMaxDistanceConstraint("stay near sea", SeaID, 25);
	int stayCloseSea = rmCreateAreaMaxDistanceConstraint("stay close to sea", SeaID, 15);
	int avoidSea = rmCreateAreaDistanceConstraint("avoid sea", SeaID, 1.0);
	int avoidSeaFar = rmCreateAreaDistanceConstraint("avoid sea far", SeaID, 30);
	
	//Spur  
	int spurID = rmCreateArea("spur");
    rmSetAreaWarnFailure(spurID, false);
	rmSetAreaObeyWorldCircleConstraint(spurID, false);
    rmSetAreaSize(spurID, 0.07, 0.07);
	rmSetAreaBaseHeight(spurID, 2.5); 
	rmSetAreaElevationType(spurID, cElevTurbulence);
	rmSetAreaElevationVariation(spurID, 4.5);
	rmSetAreaElevationMinFrequency(spurID, 0.05);
	rmSetAreaElevationOctaves(spurID, 2);
	rmSetAreaElevationPersistence(spurID, 0.5);
	rmSetAreaLocation(spurID, 0.5, 0.38);
	rmSetAreaTerrainType(spurID, "mongolia\ground_grass4_mongol");
    rmSetAreaCoherence(spurID, 0.6);
	rmSetAreaSmoothDistance(spurID, 20);
    rmBuildArea(spurID); 
	
	// Coastal patches
	for (i=0; < 30)
	{
		int patchID = rmCreateArea("patch coastal"+i);
		rmSetAreaWarnFailure(patchID, false);
		rmSetAreaObeyWorldCircleConstraint(patchID, false);
		rmSetAreaSize(patchID, rmAreaTilesToFraction(30), rmAreaTilesToFraction(60));
		rmSetAreaTerrainType(patchID, "coastal_japan\ground_grass1_co_japan");
		rmAddAreaToClass(patchID, rmClassID("patch"));
		rmSetAreaMinBlobs(patchID, 1);
		rmSetAreaMaxBlobs(patchID, 5);
		rmSetAreaMinBlobDistance(patchID, 12.0);
		rmSetAreaMaxBlobDistance(patchID, 30.0);
		rmSetAreaCoherence(patchID, 0.0);
//		if (i < 20)
			rmAddAreaConstraint(patchID, stayNearWater);
//		else
//			rmAddAreaConstraint(patchID, stayCloseSea);
		rmAddAreaConstraint(patchID, avoidPatch);
		rmAddAreaConstraint(patchID, avoidImpassableLandMin);
		rmBuildArea(patchID); 
	}
	
	// Low ground patches
	for (i=0; < 20)
	{
		int patch2ID = rmCreateArea("patch low ground"+i);
		rmSetAreaWarnFailure(patch2ID, false);
		rmSetAreaObeyWorldCircleConstraint(patch2ID, false);
		rmSetAreaSize(patch2ID, rmAreaTilesToFraction(30), rmAreaTilesToFraction(60));
		rmSetAreaTerrainType(patch2ID, "mongolia\ground_grass3_mongol");
		rmAddAreaToClass(patch2ID, rmClassID("patch2"));
		rmSetAreaMinBlobs(patch2ID, 1);
		rmSetAreaMaxBlobs(patch2ID, 5);
		rmSetAreaMinBlobDistance(patch2ID, 12.0);
		rmSetAreaMaxBlobDistance(patch2ID, 30.0);
		rmSetAreaCoherence(patch2ID, 0.0);
		rmAddAreaConstraint(patch2ID, avoidSeaFar);
		rmAddAreaConstraint(patch2ID, avoidPatch2);
		rmAddAreaConstraint(patch2ID, avoidHighground);
//		rmAddAreaConstraint(patch2ID, avoidHill);
		rmBuildArea(patch2ID); 
	}
	
	//Hill
	for (i=0; < 3)
	{
	int hillID = rmCreateArea("hill"+i);
	if (i == 0)
	{
		rmSetAreaSize(hillID, 0.040, 0.040);
		rmSetAreaMix(hillID, "mongolia_forest");	
//		rmAddAreaTerrainLayer(hillID, "mongolia\ground_grass1_co_japan", 0, 2);
	}	
	else if (i == 1)
	{
		rmSetAreaSize(hillID, 0.030, 0.030);
		rmSetAreaCliffHeight(hillID, 4, 0.0, 0.8); 
		rmSetAreaCliffEdge(hillID, 1, 1.0, 0.0, 0.0, 1); 
		rmSetAreaCliffType(hillID, "yellow river"); 
		rmSetAreaCliffPainting(hillID, false, true, true, 0.5 , true); //  paintGround,  paintOutsideEdge,  paintSide,  minSideHeight,  paintInsideEdge
	}
	else
	{
		rmSetAreaSize(hillID, 0.011, 0.011);
		rmSetAreaCliffHeight(hillID, 4, 0.0, 0.8); 
		rmSetAreaCliffEdge(hillID, 1, 1.0, 0.0, 0.0, 1); 
		rmSetAreaCliffType(hillID, "yellow river"); 
		rmSetAreaCliffPainting(hillID, false, true, true, 0.5 , true); //  paintGround,  paintOutsideEdge,  paintSide,  minSideHeight,  paintInsideEdge
	}
	rmSetAreaWarnFailure(hillID, false);
	rmSetAreaObeyWorldCircleConstraint(hillID, false);
	rmSetAreaCoherence(hillID, 0.65);
	rmSetAreaSmoothDistance(hillID, 8);
	rmAddAreaToClass(hillID, rmClassID("Cliffs"));
	rmSetAreaLocation(hillID, 0.5, 1.0);
//	rmAddAreaConstraint(hillID, avoidImpassableLandMin);
	rmBuildArea(hillID);
	rmCreateAreaDistanceConstraint("avoid hill "+i, hillID, 1.0);
	}
	
	int avoidHill = rmConstraintID("avoid hill 0");
	

	
	// Players area
	for (i=1; < numPlayer)
	{
	int playerareaID = rmCreateArea("playerarea"+i);
	rmSetPlayerArea(i, playerareaID);
	rmSetAreaSize(playerareaID, 0.05, 0.05);
	rmSetAreaCoherence(playerareaID, 1.0);
	rmSetAreaWarnFailure(playerareaID, false);
//	rmSetAreaTerrainType(playerareaID, "new_england\ground2_cliff_ne"); // for testing
	rmSetAreaLocPlayer(playerareaID, i);
	rmSetAreaObeyWorldCircleConstraint(playerareaID, false);
	rmBuildArea(playerareaID);
	rmCreateAreaDistanceConstraint("avoid player area "+i, playerareaID, 3.0);
	rmCreateAreaMaxDistanceConstraint("stay in player area "+i, playerareaID, 0.0);
	}
	
	int avoidPlayerArea1 = rmConstraintID("avoid player area 1");
	int avoidPlayerArea2 = rmConstraintID("avoid player area 2");
	int stayInPlayerArea1 = rmConstraintID("stay in player area 1");
	int stayInPlayerArea2 = rmConstraintID("stay in player area 2");

	// *********************************************************************************************************
	
	// Text
	rmSetStatusText("",0.40);
	
		// ****************************************** TRADE ROUTE **********************************************
		
	float TPvariation = -1;
	TPvariation = rmRandFloat(0.1,1.0);
//	TPvariation = 0.3; // <--- TEST
	
	if (TPvariation > 0.5)
	{
		int tradeRouteID = rmCreateTradeRoute();
		int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
		rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
		rmSetObjectDefAllowOverlap(socketID, true);
		rmSetObjectDefMinDistance(socketID, 0.0);
		rmSetObjectDefMaxDistance(socketID, 6.0);

		rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.95, 1.00); 
		rmAddTradeRouteWaypoint(tradeRouteID, 0.65, 0.80);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.50, 0.75);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.35, 0.80);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.05, 1.00);
		
		bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "water");
		if(placedTradeRoute == false)
		rmEchoError("Failed to place trade route");
		rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
		vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.24);
		rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.49);
		rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.76);
		rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);	
	}
	else
	{
		int tradeRoute2ID = rmCreateTradeRoute();
		int socket2ID=rmCreateObjectDef("sockets to dock Trade Posts 2");
		rmAddObjectDefItem(socket2ID, "SocketTradeRoute", 1, 0.0);
		rmSetObjectDefAllowOverlap(socket2ID, true);
		rmSetObjectDefMinDistance(socket2ID, 0.0);
		rmSetObjectDefMaxDistance(socket2ID, 6.0);

		rmSetObjectDefTradeRouteID(socket2ID, tradeRoute2ID);
		rmAddTradeRouteWaypoint(tradeRoute2ID, 1.00, 0.55);
		rmAddTradeRouteWaypoint(tradeRoute2ID, 0.80, 0.75);
		rmAddTradeRouteWaypoint(tradeRoute2ID, 0.74, 1.00); 
		
		bool placedTradeRoute2 = rmBuildTradeRoute(tradeRoute2ID, "water");
		if(placedTradeRoute2 == false)
		rmEchoError("Failed to place trade route 2");
		rmSetObjectDefTradeRouteID(socket2ID, tradeRoute2ID);
		vector socketLoc2 = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.18);
		rmPlaceObjectDefAtPoint(socket2ID, 0, socketLoc2);
		socketLoc2 = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.74);
		rmPlaceObjectDefAtPoint(socket2ID, 0, socketLoc2);
		
		
		int tradeRoute3ID = rmCreateTradeRoute();
		int socket3ID=rmCreateObjectDef("sockets to dock Trade Posts 3");
		rmAddObjectDefItem(socket3ID, "SocketTradeRoute", 1, 0.0);
		rmSetObjectDefAllowOverlap(socket3ID, true);
		rmSetObjectDefMinDistance(socket3ID, 0.0);
		rmSetObjectDefMaxDistance(socket3ID, 6.0);

		rmSetObjectDefTradeRouteID(socket3ID, tradeRoute3ID);
		rmAddTradeRouteWaypoint(tradeRoute3ID, 0.00, 0.55);
		rmAddTradeRouteWaypoint(tradeRoute3ID, 0.20, 0.75);
		rmAddTradeRouteWaypoint(tradeRoute3ID, 0.26, 1.00); 
		
		bool placedTradeRoute3 = rmBuildTradeRoute(tradeRoute3ID, "water");
		if(placedTradeRoute3 == false)
		rmEchoError("Failed to place trade route 3");
		rmSetObjectDefTradeRouteID(socket3ID, tradeRoute3ID);
		vector socketLoc3 = rmGetTradeRouteWayPoint(tradeRoute3ID, 0.12);
		rmPlaceObjectDefAtPoint(socket3ID, 0, socketLoc3);
		socketLoc3 = rmGetTradeRouteWayPoint(tradeRoute3ID, 0.70);
		rmPlaceObjectDefAtPoint(socket3ID, 0, socketLoc3);	
	}

	
	// *************************************************************************************************************
		
	// Text
	rmSetStatusText("",0.45);
	
	// ******************************************** NATIVES *************************************************
	
	float Natsplacement = -1;
	Natsplacement = rmRandFloat(0.1,1.0); // > 0.5 vertical, < 0.5 horizontal
//	Natsplacement = 0.6; // <--- TEST
	
	float Natsvariation = -1;
	Natsvariation = rmRandFloat(0.1,1.0); // > 0.5 shaolin (near hill), < 0.5 zen (near coast)
//	Natsvariation = 0.3; // <--- TEST
	
	int nativeID0 = -1;
    int nativeID1 = -1;
	int nativeID2 = -1;
    int nativeID3 = -1;
	int nativeID4 = -1;
	int nativeID5 = -1;
	
	if (Natsplacement > 0.3)
	{
		if (Natsvariation > 0.5)
		{
			nativeID0 = rmCreateGrouping("Shaolin temple A", "native shaolin temple mongol 0"+1);
			rmSetGroupingMinDistance(nativeID0, 0.00);
			rmSetGroupingMaxDistance(nativeID0, 0.00);
		//	rmAddGroupingConstraint(nativeID0, avoidImpassableLand);
			rmAddGroupingToClass(nativeID0, rmClassID("natives"));
		//  rmAddGroupingToClass(nativeID0, rmClassID("importantItem"));
		//	rmAddGroupingConstraint(nativeID0, avoidNatives);
			if (TPvariation > 0.5)
				rmPlaceGroupingAtLoc(nativeID0, 0, 0.40, 0.60);
			else
				rmPlaceGroupingAtLoc(nativeID0, 0, 0.40, 0.65);
			
			nativeID2 = rmCreateGrouping("Shaolin temple B", "native shaolin temple mongol 0"+2);
			rmSetGroupingMinDistance(nativeID2, 0.00);
			rmSetGroupingMaxDistance(nativeID2, 0.00);
		//	rmAddGroupingConstraint(nativeID2, avoidImpassableLand);
			rmAddGroupingToClass(nativeID2, rmClassID("natives"));
		//  rmAddGroupingToClass(nativeID2, rmClassID("importantItem"));
		//	rmAddGroupingConstraint(nativeID2, avoidNatives);
			if (TPvariation > 0.5)
				rmPlaceGroupingAtLoc(nativeID2, 0, 0.63, 0.60);
			else 
				rmPlaceGroupingAtLoc(nativeID2, 0, 0.63, 0.65);	
		}
		else
		{
			nativeID1 = rmCreateGrouping("Zen temple A", "native zen temple YR 0"+1);
			rmSetGroupingMinDistance(nativeID1, 0.00);
			rmSetGroupingMaxDistance(nativeID1, 0.00);
		//  rmAddGroupingConstraint(nativeID1, avoidImpassableLand);
			rmAddGroupingToClass(nativeID1, rmClassID("natives"));
		//  rmAddGroupingToClass(nativeID1, rmClassID("importantItem"));
		//	rmAddGroupingConstraint(nativeID1, avoidNatives);
			rmPlaceGroupingAtLoc(nativeID1, 0, 0.40, 0.45); // 

			nativeID3 = rmCreateGrouping("Zen temple B", "native zen temple YR 0"+2);
			rmSetGroupingMinDistance(nativeID3, 0.00);
			rmSetGroupingMaxDistance(nativeID3, 0.00);
		//  rmAddGroupingConstraint(nativeID3, avoidImpassableLand);
			rmAddGroupingToClass(nativeID3, rmClassID("natives"));
		//  rmAddGroupingToClass(nativeID3, rmClassID("importantItem"));
		//	rmAddGroupingConstraint(nativeID3, avoidNatives);
			rmPlaceGroupingAtLoc(nativeID3, 0, 0.63, 0.45); // 
		}
	}
	else
	{
		nativeID4 = rmCreateGrouping("Shaolin temple C", "native shaolin temple mongol 0"+1);
		rmSetGroupingMinDistance(nativeID4, 0.00);
		rmSetGroupingMaxDistance(nativeID4, 0.00);
	//	rmAddGroupingConstraint(nativeID4, avoidImpassableLand);
		rmAddGroupingToClass(nativeID4, rmClassID("natives"));
	//  rmAddGroupingToClass(nativeID4, rmClassID("importantItem"));
	//	rmAddGroupingConstraint(nativeID4, avoidNatives);
		if (TPvariation > 0.5)
			rmPlaceGroupingAtLoc(nativeID4, 0, 0.53, 0.60);
		else
			rmPlaceGroupingAtLoc(nativeID4, 0, 0.53, 0.65);	
			
		nativeID5 = rmCreateGrouping("Zen temple C", "native zen temple YR 0"+2);
		rmSetGroupingMinDistance(nativeID5, 0.00);
		rmSetGroupingMaxDistance(nativeID5, 0.00);
	//  rmAddGroupingConstraint(nativeID5, avoidImpassableLand);
		rmAddGroupingToClass(nativeID5, rmClassID("natives"));
	//  rmAddGroupingToClass(nativeID5, rmClassID("importantItem"));
	//	rmAddGroupingConstraint(nativeID5, avoidNatives);
		rmPlaceGroupingAtLoc(nativeID5, 0, 0.53, 0.45); // 
		
	}
	
	
	// ******************************************************************************************************
	
	// Text
	rmSetStatusText("",0.50);
	
	// ************************************ PLAYER STARTING RESOURCES ***************************************

	// ******** Define ********

	// Town center & units
	int TCID = rmCreateObjectDef("player TC");
	int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	if (rmGetNomadStart())
	{
		rmAddObjectDefItem(TCID, "CoveredWagon", 1, 0.0);
	}
	else
	{
	rmAddObjectDefItem(TCID, "TownCenter", 1, 0.0);
	rmAddObjectDefToClass(TCID, classStartingResource);
	}
	rmSetObjectDefMinDistance(TCID, 0.0);
	rmSetObjectDefMaxDistance(TCID, 0.0);
	
	// Starting mines
	int playergoldID = rmCreateObjectDef("player mine");
	rmAddObjectDefItem(playergoldID, "mine", 1, 0);
	rmSetObjectDefMinDistance(playergoldID, 14.0);
	rmSetObjectDefMaxDistance(playergoldID, 16.0);
	rmAddObjectDefToClass(playergoldID, classStartingResource);
	rmAddObjectDefToClass(playergoldID, classGold);
	rmAddObjectDefConstraint(playergoldID, avoidTradeRouteShort);
	rmAddObjectDefConstraint(playergoldID, avoidTradeRouteSocket);
	rmAddObjectDefConstraint(playergoldID, avoidImpassableLand);
	rmAddObjectDefConstraint(playergoldID, avoidNatives);
	rmAddObjectDefConstraint(playergoldID, avoidStartingResources);
//	rmAddObjectDefConstraint(playergoldID, avoidEdge);
	
	// 2nd mine
	int playergold2ID = rmCreateObjectDef("player second mine");
	rmAddObjectDefItem(playergold2ID, "mine", 1, 0);
	rmSetObjectDefMinDistance(playergold2ID, 22.0); //58
	rmSetObjectDefMaxDistance(playergold2ID, 24.0); //62
	rmAddObjectDefToClass(playergold2ID, classStartingResource);
	rmAddObjectDefToClass(playergold2ID, classGold);
	rmAddObjectDefConstraint(playergold2ID, avoidTradeRouteShort);
	rmAddObjectDefConstraint(playergold2ID, avoidTradeRouteSocket);
	rmAddObjectDefConstraint(playergold2ID, avoidImpassableLandFar);
	rmAddObjectDefConstraint(playergold2ID, avoidNatives);
	rmAddObjectDefConstraint(playergold2ID, avoidGoldType);
	rmAddObjectDefConstraint(playergold2ID, avoidStartingResources);
//	rmAddObjectDefConstraint(playergold2ID, avoidCenter);
	rmAddObjectDefConstraint(playergold2ID, avoidEdge);
	
/*	// 3nd mine
	int playergold3ID = rmCreateObjectDef("player third mine");
	rmAddObjectDefItem(playergold3ID, "mine", 1, 0);
	rmSetObjectDefMinDistance(playergold3ID, 66.0); //58
	rmSetObjectDefMaxDistance(playergold3ID, 70.0); //62
//	rmAddObjectDefToClass(playergold3ID, classStartingResource);
	rmAddObjectDefToClass(playergold3ID, classGold);
	rmAddObjectDefConstraint(playergold3ID, avoidTradeRoute);
	rmAddObjectDefConstraint(playergold3ID, avoidImpassableLand);
	rmAddObjectDefConstraint(playergold3ID, avoidNatives);
	rmAddObjectDefConstraint(playergold3ID, avoidGoldTypeFar);
	rmAddObjectDefConstraint(playergold3ID, avoidStartingResources);
	rmAddObjectDefConstraint(playergold3ID, avoidCenter);
	rmAddObjectDefConstraint(playergold3ID, avoidIceArea);
	rmAddObjectDefConstraint(playergold3ID, avoidEdge);
*/
	
	// Starting trees
	int playerTreeID = rmCreateObjectDef("player trees");
	rmAddObjectDefItem(playerTreeID, "ypTreeMongolianFir", rmRandInt(6,6), 5.0);
    rmSetObjectDefMinDistance(playerTreeID, 12);
    rmSetObjectDefMaxDistance(playerTreeID, 16);
	rmAddObjectDefToClass(playerTreeID, classStartingResource);
	rmAddObjectDefToClass(playerTreeID, classForest);
	rmAddObjectDefConstraint(playerTreeID, avoidForestShort);
	rmAddObjectDefConstraint(playerTreeID, avoidTradeRoute);
    rmAddObjectDefConstraint(playerTreeID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerTreeID, avoidStartingResources);
	
	// Starting herd
	int playeherdID = rmCreateObjectDef("starting herd");
	rmAddObjectDefItem(playeherdID, "ypMarcoPoloSheep", rmRandInt(5,5), 4.0);
	rmSetObjectDefMinDistance(playeherdID, 16.0);
	rmSetObjectDefMaxDistance(playeherdID, 20.0);
	rmSetObjectDefCreateHerd(playeherdID, true);
	rmAddObjectDefToClass(playeherdID, classStartingResource);
	rmAddObjectDefConstraint(playeherdID, avoidTradeRoute);
	rmAddObjectDefConstraint(playeherdID, avoidImpassableLand);
	rmAddObjectDefConstraint(playeherdID, avoidNatives);
	rmAddObjectDefConstraint(playeherdID, avoidStartingResources);
		
	// 2nd herd
	int player2ndherdID = rmCreateObjectDef("player 2nd herd");
	rmAddObjectDefItem(player2ndherdID, "ypSerow", rmRandInt(10,10), 7.0);
    rmSetObjectDefMinDistance(player2ndherdID, 30);
    rmSetObjectDefMaxDistance(player2ndherdID, 32);
	rmAddObjectDefToClass(player2ndherdID, classStartingResource);
	rmSetObjectDefCreateHerd(player2ndherdID, true);
	rmAddObjectDefConstraint(player2ndherdID, avoidStartingResources);
	rmAddObjectDefConstraint(player2ndherdID, avoidSheepShort); 
//	rmAddObjectDefConstraint(player2ndherdID, avoidTradeRouteShort);
	rmAddObjectDefConstraint(player2ndherdID, avoidTradeRouteSocket);
	rmAddObjectDefConstraint(player2ndherdID, avoidImpassableLand);
	rmAddObjectDefConstraint(player2ndherdID, avoidEdge);
	rmAddObjectDefConstraint(player2ndherdID, avoidNatives);
		
/*	// 3rd herd
	int player3rdherdID = rmCreateObjectDef("player 3rd herd");
	rmAddObjectDefItem(player3rdherdID, "ypSerow", rmRandInt(7,7), 6.0);
    rmSetObjectDefMinDistance(player3rdherdID, 50);
    rmSetObjectDefMaxDistance(player3rdherdID, 52);
	rmAddObjectDefToClass(player3rdherdID, classStartingResource);
	rmSetObjectDefCreateHerd(player3rdherdID, true);
	rmAddObjectDefConstraint(player3rdherdID, avoidStartingResources);
	rmAddObjectDefConstraint(player3rdherdID, avoidGoldType);
	rmAddObjectDefConstraint(player3rdherdID, avoidCaribou);
//	rmAddObjectDefConstraint(player3rdherdID, avoidTradeRouteShort);
	rmAddObjectDefConstraint(player3rdherdID, avoidTradeRouteSocket);
	rmAddObjectDefConstraint(player3rdherdID, avoidImpassableLandFar);
	rmAddObjectDefConstraint(player3rdherdID, avoidNativesFar);
	rmAddObjectDefConstraint(player3rdherdID, avoidEdge);
	rmAddObjectDefConstraint(player3rdherdID, avoidCenter);
*/	
	// Starting treasures
	int playerNuggetID = rmCreateObjectDef("player nugget"); 
	rmAddObjectDefItem(playerNuggetID, "Nugget", 1, 0.0);
	rmSetNuggetDifficulty(1, 1);
	rmSetObjectDefMinDistance(playerNuggetID, 20.0);
	rmSetObjectDefMaxDistance(playerNuggetID, 30.0);
	rmAddObjectDefToClass(playerNuggetID, classStartingResource);
	rmAddObjectDefConstraint(playerNuggetID, avoidTradeRoute);
	rmAddObjectDefConstraint(playerNuggetID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerNuggetID, avoidNatives);
	rmAddObjectDefConstraint(playerNuggetID, avoidStartingResources);
	rmAddObjectDefConstraint(playerNuggetID, avoidNugget); //Short
	rmAddObjectDefConstraint(playerNuggetID, avoidEdge);
	int nugget0count = rmRandInt (1,2); // 1,2
	
	int colonyShipID = 0;
   for(i=1; < numPlayer)
   {
		colonyShipID=rmCreateObjectDef("colony ship "+i);
	 	rmAddObjectDefItem(colonyShipID, "HomeCityWaterSpawnFlag", 1, 1.0);
		rmSetObjectDefMinDistance(colonyShipID, 0.0);
		rmSetObjectDefMaxDistance(colonyShipID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(colonyShipID, avoidColonyShip);
		rmAddObjectDefConstraint(colonyShipID, avoidLandFar);
		rmAddObjectDefConstraint(colonyShipID, avoidEdgeMore);
	//  vector colonyShipLocation=rmGetUnitPosition(rmGetUnitPlacedOfPlayer(colonyShipID, i));
	//  rmSetHomeCityWaterSpawnPoint(i, colonyShipLocation);
       	rmPlaceObjectDefAtLoc(colonyShipID, i, 0.50, 0.10);
	}   
		
	// ******** Place ********
	
	for(i=1; <numPlayer)
	{
		rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));

		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playergoldID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playergold2ID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
//		rmPlaceObjectDefAtLoc(playergold3ID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTreeID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTreeID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playeherdID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(player2ndherdID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
//		rmPlaceObjectDefAtLoc(player3rdherdID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerNuggetID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		if (nugget0count == 2)
			rmPlaceObjectDefAtLoc(playerNuggetID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
				
		if(ypIsAsian(i) && rmGetNomadStart() == false)
			rmPlaceObjectDefAtLoc(ypMonasteryBuilder(i, 1), i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		vector closestPoint = rmFindClosestPointVector(TCLoc, rmXFractionToMeters(1.0));
	}

	// ************************************************************************************************
	
	// Text
	rmSetStatusText("",0.60);
	
	// ************************************** COMMON RESOURCES ****************************************
  
   
	// ************* Mines **************
	
	int sidegoldcount = rmRandInt(2,2);  
	int centralgoldcount = rmRandInt(2,2);   
	
	int minevariation = rmRandInt (0,1);
	
	// Side mines
	for(i=0; < sidegoldcount)
	{
		int sidegoldID = rmCreateObjectDef("side mines"+i);
		if (minevariation == 0)
			rmAddObjectDefItem(sidegoldID, "Mine", 1, 0.0);
		else
			rmAddObjectDefItem(sidegoldID, "Minegold", 1, 0.0);
		rmSetObjectDefMinDistance(sidegoldID, rmXFractionToMeters(0.26));
		rmSetObjectDefMaxDistance(sidegoldID, rmXFractionToMeters(0.5));
		rmAddObjectDefToClass(sidegoldID, classGold);
		rmAddObjectDefConstraint(sidegoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(sidegoldID, avoidImpassableLandMed);
		rmAddObjectDefConstraint(sidegoldID, avoidNatives);
		rmAddObjectDefConstraint(sidegoldID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(sidegoldID, avoidGoldFar);
		rmAddObjectDefConstraint(sidegoldID, avoidTownCenterFar);
		rmAddObjectDefConstraint(sidegoldID, avoidEdge);
		rmAddObjectDefConstraint(sidegoldID, stayNW);
		rmAddObjectDefConstraint(sidegoldID, avoidHill);
		rmPlaceObjectDefAtLoc(sidegoldID, 0, 0.50, 0.65);
	}
	
	// Central mines
	for(i=0; < centralgoldcount)
	{
		int centralgoldID = rmCreateObjectDef("central mines"+i);
		if (minevariation == 0)
			rmAddObjectDefItem(centralgoldID, "Minegold", 1, 0.0);
		else
			rmAddObjectDefItem(centralgoldID, "Mine", 1, 0.0);
		rmSetObjectDefMinDistance(centralgoldID, rmXFractionToMeters(0.15));
		rmSetObjectDefMaxDistance(centralgoldID, rmXFractionToMeters(0.5));
		rmAddObjectDefToClass(centralgoldID, classGold);
		rmAddObjectDefConstraint(centralgoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(centralgoldID, avoidImpassableLandFar);
		rmAddObjectDefConstraint(centralgoldID, avoidNatives);
		rmAddObjectDefConstraint(centralgoldID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(centralgoldID, avoidGoldVeryFar);
		rmAddObjectDefConstraint(centralgoldID, avoidTownCenterVeryFar);
		rmAddObjectDefConstraint(centralgoldID, avoidEdge);
		rmAddObjectDefConstraint(centralgoldID, avoidHill);
		rmPlaceObjectDefAtLoc(centralgoldID, 0, 0.50, 0.50);
	}
		
	// *********************************
	
	// Text
	rmSetStatusText("",0.70);
	
	// ************ Forest *************
/*	
	// Coastal tree clumps 
	int coastaltreecount = 10; 
	int doubleclump = rmRandInt (0,2);
	
	for (i=0; < coastaltreecount)
	{	
		int coastaltreeID = rmCreateObjectDef("coastal trees"+i);
		rmAddObjectDefItem(coastaltreeID, "ypTreeJapanesePine", rmRandInt(1,5), 5.0); 
//		if (doubleclump > 0)
			rmAddObjectDefItem(coastaltreeID, "ypTreeJapanesePine", rmRandInt(1,3), 5.0); 
		rmSetObjectDefMinDistance(coastaltreeID, 0);
		rmSetObjectDefMaxDistance(coastaltreeID, rmXFractionToMeters(0.5));
		rmAddObjectDefToClass(coastaltreeID, classForest);
		rmAddObjectDefConstraint(coastaltreeID, avoidForestShort);
		rmAddObjectDefConstraint(coastaltreeID, avoidImpassableLand);
		rmAddObjectDefConstraint(coastaltreeID, avoidNatives);
		rmAddObjectDefConstraint(coastaltreeID, stayNearWater);
		rmAddObjectDefConstraint(coastaltreeID, avoidStartingResources);
		rmAddObjectDefConstraint(coastaltreeID, avoidSerowMin); 
		rmAddObjectDefConstraint(coastaltreeID, avoidGoldMin); 
		rmPlaceObjectDefAtLoc(coastaltreeID, 0, 0.50, 0.50);
	}	
*/	
	
	// Lowground forest
	int forestlowcount = 14;
	int stayInForestLowPatch = -1;
	
	for (i=0; < forestlowcount)
	{
		int forestlowID = rmCreateArea("forest lowground "+i);
		rmSetAreaWarnFailure(forestlowID, false);
		rmSetAreaSize(forestlowID, rmAreaTilesToFraction(120), rmAreaTilesToFraction(140));
		rmSetAreaTerrainType(forestlowID, "mongolia\ground_grass3_mongol");
		rmSetAreaObeyWorldCircleConstraint(forestlowID, false);
//		rmSetAreaForestDensity(forestlowID, 0.8);
//		rmSetAreaForestClumpiness(forestlowID, 0.15);
//		rmSetAreaForestUnderbrush(forestlowID, 0.2);
		rmSetAreaMinBlobs(forestlowID, 2);
		rmSetAreaMaxBlobs(forestlowID, 4);
		rmSetAreaMinBlobDistance(forestlowID, 14.0);
		rmSetAreaMaxBlobDistance(forestlowID, 30.0);
		rmSetAreaCoherence(forestlowID, 0.65);
		rmSetAreaSmoothDistance(forestlowID, 6);
		rmAddAreaToClass(forestlowID, classForest);
		rmAddAreaConstraint(forestlowID, avoidForest);
		rmAddAreaConstraint(forestlowID, avoidGoldMin);
		rmAddAreaConstraint(forestlowID, avoidSerowMin); 
		rmAddAreaConstraint(forestlowID, avoidSheepMin); 
		rmAddAreaConstraint(forestlowID, avoidTownCenterShort); 
		rmAddAreaConstraint(forestlowID, avoidNatives);
		rmAddAreaConstraint(forestlowID, avoidTradeRouteShort);
		rmAddAreaConstraint(forestlowID, avoidTradeRouteSocket);
		rmAddAreaConstraint(forestlowID, avoidImpassableLandShort);
		rmAddAreaConstraint(forestlowID, avoidHighground);
		rmAddAreaConstraint(forestlowID, avoidHill);
//		rmAddAreaConstraint(forestlowID, avoidEdge);
		rmBuildArea(forestlowID);
		
		stayInForestLowPatch = rmCreateAreaMaxDistanceConstraint("stay in forest low patch"+i, forestlowID, 0.0);
		
		for (j=0; < rmRandInt(15,17))
		{
			int forestlowtreeID = rmCreateObjectDef("forest lowground trees"+i+j);
			rmAddObjectDefItem(forestlowtreeID, "ypTreeMongolianFir", rmRandInt(1,2), 2.0);
			rmSetObjectDefMinDistance(forestlowtreeID,  rmXFractionToMeters(0.0));
			rmSetObjectDefMaxDistance(forestlowtreeID,  rmXFractionToMeters(0.5));
		//	rmAddObjectDefToClass(forestlowtreeID, classForest);
		//	rmAddObjectDefConstraint(forestlowtreeID, avoidForestShort);
			rmAddObjectDefConstraint(forestlowtreeID, avoidImpassableLandShort);
			rmAddObjectDefConstraint(forestlowtreeID, stayInForestLowPatch);	
			rmPlaceObjectDefAtLoc(forestlowtreeID, 0, 0.50, 0.50);
		}
	}
	
	// Random trees in the lowground
	for (i=0; < 10)
	{
		int randomlowtreeID = rmCreateObjectDef("random trees low ground "+i);
		rmAddObjectDefItem(randomlowtreeID, "ypTreeMongolianFir", rmRandInt(2,5), 5.0);
		rmSetObjectDefMinDistance(randomlowtreeID,  rmXFractionToMeters(0.0));
		rmSetObjectDefMaxDistance(randomlowtreeID,  rmXFractionToMeters(0.5));
		rmAddObjectDefToClass(randomlowtreeID, classForest);
		rmAddObjectDefConstraint(randomlowtreeID, avoidForestShort);
		rmAddObjectDefConstraint(randomlowtreeID, avoidGoldMin);
		rmAddObjectDefConstraint(randomlowtreeID, avoidSerowMin); 
		rmAddObjectDefConstraint(randomlowtreeID, avoidSheepMin); 
		rmAddObjectDefConstraint(randomlowtreeID, avoidTownCenterShort); 
		rmAddObjectDefConstraint(randomlowtreeID, avoidNatives);
		rmAddObjectDefConstraint(randomlowtreeID, avoidTradeRouteShort);
		rmAddObjectDefConstraint(randomlowtreeID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(randomlowtreeID, avoidImpassableLand);
		rmAddObjectDefConstraint(randomlowtreeID, avoidHighground);
		rmAddObjectDefConstraint(randomlowtreeID, avoidHill);
		rmAddObjectDefConstraint(randomlowtreeID, avoidStartingResources);
		rmPlaceObjectDefAtLoc(randomlowtreeID, 0, 0.50, 0.50);
	}

	// Highground forest
	int foresthighcount = 7;
	int stayInForestHighPatch = -1;
	
	for (i=0; < foresthighcount)
	{
		int foresthighID = rmCreateArea("forest highground "+i);
		rmSetAreaWarnFailure(foresthighID, false);
		rmSetAreaSize(foresthighID, rmAreaTilesToFraction(120), rmAreaTilesToFraction(140));
		rmSetAreaTerrainType(foresthighID, "mongolia\ground_grass3_mongol");
		rmSetAreaObeyWorldCircleConstraint(foresthighID, false);
//		rmSetAreaForestDensity(foresthighID, 0.8);
//		rmSetAreaForestClumpiness(foresthighID, 0.15);
//		rmSetAreaForestUnderbrush(foresthighID, 0.2);
		rmSetAreaMinBlobs(foresthighID, 2);
		rmSetAreaMaxBlobs(foresthighID, 4);
		rmSetAreaMinBlobDistance(foresthighID, 12.0);
		rmSetAreaMaxBlobDistance(foresthighID, 30.0);
		rmSetAreaCoherence(foresthighID, 0.65);
		rmSetAreaSmoothDistance(foresthighID, 6);
		rmAddAreaToClass(foresthighID, classForest);
		rmAddAreaConstraint(foresthighID, avoidForestShort);
		rmAddAreaConstraint(foresthighID, avoidGoldMin);
		rmAddAreaConstraint(foresthighID, avoidSerowMin); 
		rmAddAreaConstraint(foresthighID, avoidSheepMin); 
		rmAddAreaConstraint(foresthighID, avoidTownCenterShort); 
		rmAddAreaConstraint(foresthighID, avoidNatives);
		rmAddAreaConstraint(foresthighID, avoidTradeRouteShort);
		rmAddAreaConstraint(foresthighID, avoidTradeRouteSocket);
		rmAddAreaConstraint(foresthighID, avoidImpassableLandShort);
		rmAddAreaConstraint(foresthighID, avoidLowground);
		rmAddAreaConstraint(foresthighID, avoidHill);
//		rmAddAreaConstraint(foresthighID, avoidEdge);
		rmBuildArea(foresthighID);
		
		stayInForestHighPatch = rmCreateAreaMaxDistanceConstraint("stay in forest high patch"+i, foresthighID, 0.0);
		
		for (j=0; < rmRandInt(14,16))
		{
			int foresthightreeID = rmCreateObjectDef("forest highground trees"+i+j);
			rmAddObjectDefItem(foresthightreeID, "ypTreeMongolia", rmRandInt(1,2), 2.0);
			rmSetObjectDefMinDistance(foresthightreeID,  rmXFractionToMeters(0.0));
			rmSetObjectDefMaxDistance(foresthightreeID,  rmXFractionToMeters(0.5));
		//	rmAddObjectDefToClass(foresthightreeID, classForest);
		//	rmAddObjectDefConstraint(foresthightreeID, avoidForestShort);
			rmAddObjectDefConstraint(foresthightreeID, avoidImpassableLandShort);
			rmAddObjectDefConstraint(foresthightreeID, stayInForestHighPatch);	
			rmPlaceObjectDefAtLoc(foresthightreeID, 0, 0.50, 0.50);
		}
	}
	
	// Random trees in the highground
	for (i=0; < 8)
	{
		int randomhightreeID = rmCreateObjectDef("random trees highground "+i);
		rmAddObjectDefItem(randomhightreeID, "ypTreeSaxaul", rmRandInt(3,5), 5.0);
		rmSetObjectDefMinDistance(randomhightreeID,  rmXFractionToMeters(0.0));
		rmSetObjectDefMaxDistance(randomhightreeID,  rmXFractionToMeters(0.5));
		rmAddObjectDefToClass(randomhightreeID, classForest);
		rmAddObjectDefConstraint(randomhightreeID, avoidForestShort);
		rmAddObjectDefConstraint(randomhightreeID, avoidGoldMin);
		rmAddObjectDefConstraint(randomhightreeID, avoidSerowMin); 
		rmAddObjectDefConstraint(randomhightreeID, avoidSheepMin); 
		rmAddObjectDefConstraint(randomhightreeID, avoidTownCenterShort); 
		rmAddObjectDefConstraint(randomhightreeID, avoidNatives);
		rmAddObjectDefConstraint(randomhightreeID, avoidTradeRouteShort);
		rmAddObjectDefConstraint(randomhightreeID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(randomhightreeID, avoidImpassableLand);
		rmAddObjectDefConstraint(randomhightreeID, avoidLowground);
		rmAddObjectDefConstraint(randomhightreeID, avoidHill);
		rmAddObjectDefConstraint(randomhightreeID, avoidStartingResources);
		rmPlaceObjectDefAtLoc(randomhightreeID, 0, 0.50, 0.50);
	}
	
	// ********************************
	
	// Text
	rmSetStatusText("",0.80);
	
	// ************ Herds *************
	
	int lowgroundherdcount = 7;
	int highgroundherdcount = 3;
	
		
	//Lowground herds
	for (i=0; < lowgroundherdcount)
	{
		int lowgroundherdID = rmCreateObjectDef("lowground herd"+i);
		rmAddObjectDefItem(lowgroundherdID, "ypSerow", rmRandInt(7,7), 7.0);
		rmSetObjectDefMinDistance(lowgroundherdID, 0.0);
		rmSetObjectDefMaxDistance(lowgroundherdID, rmXFractionToMeters(0.6));
		rmSetObjectDefCreateHerd(lowgroundherdID, true);
		rmAddObjectDefConstraint(lowgroundherdID, avoidForestMin);
		rmAddObjectDefConstraint(lowgroundherdID, avoidGoldShort);
		rmAddObjectDefConstraint(lowgroundherdID, avoidSerowFar); 
		rmAddObjectDefConstraint(lowgroundherdID, avoidSheepFar); 
		rmAddObjectDefConstraint(lowgroundherdID, avoidTownCenter); 
		rmAddObjectDefConstraint(lowgroundherdID, avoidNatives);
//		rmAddObjectDefConstraint(lowgroundherdID, avoidTradeRouteShort);
		rmAddObjectDefConstraint(lowgroundherdID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(lowgroundherdID, avoidImpassableLand);
		rmAddObjectDefConstraint(lowgroundherdID, avoidHighground);
		rmAddObjectDefConstraint(lowgroundherdID, avoidHill);
		rmAddObjectDefConstraint(lowgroundherdID, avoidEdge);
		if (i < 2)
			rmAddObjectDefConstraint(lowgroundherdID, staySW);
		else if (i < 4)
			rmAddObjectDefConstraint(lowgroundherdID, stayNE);
		rmPlaceObjectDefAtLoc(lowgroundherdID, 0, 0.50, 0.50);	
	}
	
	//Highground herds
	for (i=0; < highgroundherdcount)
	{
		int highgroundherdID = rmCreateObjectDef("highground herd"+i);
		rmAddObjectDefItem(highgroundherdID, "ypMuskdeer", rmRandInt(8,8), 7.0);
		rmSetObjectDefMinDistance(highgroundherdID, 0.0);
		rmSetObjectDefMaxDistance(highgroundherdID, rmXFractionToMeters(0.6));
		rmSetObjectDefCreateHerd(highgroundherdID, true);
		rmAddObjectDefConstraint(highgroundherdID, avoidForestMin);
		rmAddObjectDefConstraint(highgroundherdID, avoidGoldShort);
		rmAddObjectDefConstraint(highgroundherdID, avoidSerow); 
		rmAddObjectDefConstraint(highgroundherdID, avoidMuskdeerFar);  
		rmAddObjectDefConstraint(highgroundherdID, avoidNatives);
//		rmAddObjectDefConstraint(highgroundherdID, avoidTradeRouteShort);
		rmAddObjectDefConstraint(highgroundherdID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(highgroundherdID, avoidImpassableLandShort);
		rmAddObjectDefConstraint(highgroundherdID, avoidLowground);
		rmAddObjectDefConstraint(highgroundherdID, avoidHill);
		rmAddObjectDefConstraint(highgroundherdID, avoidEdge);
//		if (i < 1)
//			rmAddObjectDefConstraint(highgroundherdID, staySW);
//		else if (i < 2)
//			rmAddObjectDefConstraint(highgroundherdID, stayNE);
		rmPlaceObjectDefAtLoc(highgroundherdID, 0, 0.50, 0.50);	
	}
	
	// ************************************
	
	// Text
	rmSetStatusText("",0.90);
		
	// ************** Treasures ***************
	
	int treasure1count = 5;
	int treasure2count = 5;
		
	// Treasures lvl2	
	for (i=0; < treasure2count)
	{
		int Nugget2ID = rmCreateObjectDef("nugget lvl2 "+i); 
		rmAddObjectDefItem(Nugget2ID, "Nugget", 1, 0.0);
		rmSetObjectDefMinDistance(Nugget2ID, 0);
		rmSetObjectDefMaxDistance(Nugget2ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(2,2);
		rmAddObjectDefConstraint(Nugget2ID, avoidNuggetFar);
		rmAddObjectDefConstraint(Nugget2ID, avoidNatives);
		rmAddObjectDefConstraint(Nugget2ID, avoidTradeRouteShort);
		rmAddObjectDefConstraint(Nugget2ID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(Nugget2ID, avoidImpassableLandMed);
		rmAddObjectDefConstraint(Nugget2ID, avoidGoldMin);
		rmAddObjectDefConstraint(Nugget2ID, avoidTownCenter);
		rmAddObjectDefConstraint(Nugget2ID, avoidSerowMin); 
		rmAddObjectDefConstraint(Nugget2ID, avoidMuskdeerMin);
		rmAddObjectDefConstraint(Nugget2ID, avoidForestMin);	
		rmAddObjectDefConstraint(Nugget2ID, avoidEdge); 
		rmAddObjectDefConstraint(Nugget2ID, avoidHill);
		if (i < 2)
			rmAddObjectDefConstraint(Nugget2ID, staySouthHalf); 
		else if (i < 4)
			rmAddObjectDefConstraint(Nugget2ID, stayNorthHalf); 
		rmPlaceObjectDefAtLoc(Nugget2ID, 0, 0.50, 0.50);
	}
	
	// Treasures lvl1
	for (i=0; < treasure1count)
	{
		int Nugget1ID = rmCreateObjectDef("nugget lvl1 "+i); 
		rmAddObjectDefItem(Nugget1ID, "Nugget", 1, 0.0);
		rmSetObjectDefMinDistance(Nugget1ID, 0);
		rmSetObjectDefMaxDistance(Nugget1ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(1,1);
		rmAddObjectDefConstraint(Nugget1ID, avoidNuggetFar);
		rmAddObjectDefConstraint(Nugget1ID, avoidNatives);
		rmAddObjectDefConstraint(Nugget1ID, avoidTradeRouteShort);
		rmAddObjectDefConstraint(Nugget1ID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(Nugget1ID, avoidImpassableLandMed);
		rmAddObjectDefConstraint(Nugget1ID, avoidGoldMin);
		rmAddObjectDefConstraint(Nugget1ID, avoidTownCenter);
		rmAddObjectDefConstraint(Nugget1ID, avoidSerowMin); 
		rmAddObjectDefConstraint(Nugget1ID, avoidMuskdeerMin);
		rmAddObjectDefConstraint(Nugget1ID, avoidForestMin);	
		rmAddObjectDefConstraint(Nugget1ID, avoidEdge); 
		rmAddObjectDefConstraint(Nugget1ID, avoidHill);
		rmPlaceObjectDefAtLoc(Nugget1ID, 0, 0.50, 0.50);
	}
	
	// ****************************************
	
	// Text
	rmSetStatusText("",0.95);
	
	// **************** Yaks *****************
	
	for (i=0; <9)
	{
		int yakID=rmCreateObjectDef("yak"+i);
		if (i < 6)
			rmAddObjectDefItem(yakID, "ypyak", 1, 1.0);
		else
			rmAddObjectDefItem(yakID, "ypyak", 2, 4.0);
		rmSetObjectDefMinDistance(yakID, 0.0);
		rmSetObjectDefMaxDistance(yakID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(yakID, avoidYak);
		rmAddObjectDefConstraint(yakID, avoidNatives);
		rmAddObjectDefConstraint(yakID, avoidTradeRouteSocket);
		if (i < 6)
			rmAddObjectDefConstraint(yakID, avoidImpassableLandMed);
		else
			rmAddObjectDefConstraint(yakID, avoidImpassableLandShort);
		rmAddObjectDefConstraint(yakID, avoidGoldMin);
		rmAddObjectDefConstraint(yakID, avoidTownCenter);
		rmAddObjectDefConstraint(yakID, avoidSerowMin); 
		rmAddObjectDefConstraint(yakID, avoidMuskdeerMin);
		rmAddObjectDefConstraint(yakID, avoidForestMin);
		rmAddObjectDefConstraint(yakID, avoidNuggetShort);
		rmAddObjectDefConstraint(yakID, avoidEdge); 
		rmAddObjectDefConstraint(yakID, avoidHill);
		if (i < 6)
			rmAddObjectDefConstraint(yakID, avoidHighgroundFar);
		else
			rmAddObjectDefConstraint(yakID, avoidLowground);
		rmPlaceObjectDefAtLoc(yakID, 0, 0.50, 0.50);
	}
	// ****************************************
	
	// ************ Sea resources *************
	
	//Fish
	int fishcount = -1;
	fishcount = 10;
	int whalecount = 4;
	
	
	int whaleID=rmCreateObjectDef("whale"+i);
	rmAddObjectDefItem(whaleID, "HumpbackWhale", 1, 2.0);
	rmSetObjectDefMinDistance(whaleID, rmXFractionToMeters(0.0));
	rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.04));
	rmAddObjectDefConstraint(whaleID, avoidWhale);
	rmAddObjectDefConstraint(whaleID, avoidLandFar);
	rmAddObjectDefConstraint(whaleID, avoidColonyShipShort);
	rmPlaceObjectDefAtLoc(whaleID, 0, 0.20, 0.10);
	rmPlaceObjectDefAtLoc(whaleID, 0, 0.40, 0.10);
	rmPlaceObjectDefAtLoc(whaleID, 0, 0.60, 0.10);
	rmPlaceObjectDefAtLoc(whaleID, 0, 0.80, 0.10);
	
	for (i=0; < fishcount)
	{
		int fishID = rmCreateObjectDef("fish"+i);
		rmAddObjectDefItem(fishID, "ypFishTuna", rmRandInt(2,2), 8.0);
		rmSetObjectDefMinDistance(fishID, 0.0);
		rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.49));
		rmAddObjectDefConstraint(fishID, avoidFish);
		rmAddObjectDefConstraint(fishID, avoidLand);
		rmAddObjectDefConstraint(fishID, avoidColonyShipShort);
		rmAddObjectDefConstraint(fishID, avoidEdge);
		rmPlaceObjectDefAtLoc(fishID, 0, 0.50, 0.15);
	}
	
	// Text
	rmSetStatusText("",1.00);
	
} //END